{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,R-,S-,V-,X+}
{-$define windows}
UNIT disundas; {Dies und das}
interface
CONST Ja=TRUE;
CONST Nein=FALSE;
{Standardvorgaben fr JanEin}
CONST JaneinEnter:BOOLEAN=Ja;
CONST JaNeinEsc  :BOOLEAN=Nein;
Function JaNein(Frage:string):Boolean;
Function UpStr(s:string):String;
Function LRStrip(s:string):String;
Function NullFuell(i,n:integer):String;
Procedure WriteU(s:string);
Procedure WriteC(s:string);
Procedure WritelnC(s:string);
Function Fensterbreite:Integer;
Function ChDirFormat(s:string):string;
Function ITOA(I:Longint):String;
Function ATOI(s:string):Longint;
Function ATOR(S:String):Double;
function RTOA(r:Double):string;
PROCEDURE InputS(frage:string;VAR antwort:String);
function LMitPunkt(l:Longint):String;
PROCEDURE ColdBoot;

implementation uses
  dos,
{$ifdef windows}
  wincrt;
{$else}
  crt;
{$endif}
{$ifdef windows}
const windmax=80*256+25;
const windmin=0;
{$endif}
Function Janein(Frage:string):Boolean;
var z:char;
BEGIN
  If JaNeinEnter then
  Write(frage,' (J/n)? ') else
  Write(frage,' (j/N)? ');
  repeat z:=upcase(Readkey) until z in ['J','N',#27,#13];
  if (z=#27) and JaNeinESC then z:='J';
  if (z=#13) and JaNeinEnter then z:='J';

  if z='J' then
  begin
    Janein:=TRUE;
    Writeln('Ja');
  end
  else
  begin
    janein:=FALSE;
    Writeln('Nein');
  end;
END;

Function UpStr(s:string):String;
{Umwandlung in Grobuchstaben, auch fr Umlaute}
var i:integer;
BEGIN
  for i:=1 to length(s) do
  if byte(s[i]) and 128 = 0 then s[i]:=UpCase(s[i])
  else
  Case s[i] of
  '':s[i]:='';
  '':s[i]:='';
  '':s[i]:='';
  '':s[i]:='I';
  end;
  UpStr:=s;
END;

Function LRStrip(s:string):String;
{Entfernt fhrende und abschlieende Leerzeichen}
BEGIN
  While s[length(s)]=' ' do dec(s[0]);
  While (s[1]=' ') and (length(s)>0) do delete(s,1,1);
  LRSTRIP:=s;
END;

Function NullFuell(i,n:integer):String;
{Fllt Zahl bis zur Lnge n vorn mit Nullen auf}
VAR s:string;
BEGIN
  STR(i,s);
  While length(s)<n do insert('0',s,1);
  NullFuell:=S;
END;

Procedure WriteU(s:string);
{Schreibt String mit Zeilenumbruch, Trennvorschlag mit ''}
  Function Ohnepunkt(z:string):String;
  VAR p:Integer;
  BEGIN
    if z[length(z)]='' then z[length(z)]:='-';
    Repeat
      p:=pos('',z);
      if p<>0 then delete(z,p,1);
    until p=0;
    OhnePunkt:=z;
  END;
var x:Integer;
begin
repeat
  x:=length(s);
  if x>=lo(windmax)-lo(windmin)-wherex-1 then
  begin
  while (x>1) and (x>=lo(windmax)-lo(windmin)-wherex) do dec(x);
  if x>0 then
  repeat
    dec(x)
  until (x=0) or (s[x] in [' ','-','']); {#250}
  writeln(ohnepunkt(copy(s,1,x)));
  delete(s,1,x);
  end;
until length(s)<=lo(windmax)-lo(windmin);;
  write(ohnepunkt(s));
end;

Procedure WriteC(s:string);
{Schreibt String zentriert}
begin
  gotoxy(fensterbreite div 2 - length(s) div 2, wherey);
  write(s);
end;

Procedure WritelnC(s:string);
{Schreibt String zentriert}
begin
  gotoxy(fensterbreite div 2 - length(s) div 2, wherey);
  writeln(s);
end;

Function Fensterbreite:Integer;
BEGIN
Fensterbreite:=1+lo(windmax)-lo(windmin);
END;

function chdirformat(s:string):string;
{DummDOS-Patch!
 CHDIR verbietet ein angehngtes "\":
 "CHDIR C:\DOS" ist korrekt, "CHDIR C:\DOS\"
 fhrt zu einer Fehlermeldung. Um ins Wurzelverzeichnis
 zu wechseln, MUSS der "\" aber vorhanden sein! "CHDIR C:\"}
begin
if ((length(s)>3) or (s[2]<>':')) and (s[length(s)]='\') then dec(s[0]);
chdirformat:=s;
end;

Function ITOA(I:Longint):String;
VAR S:String;
BEGIN
STR(i,S);
ITOA:=S;
END;

Function ATOR(S:String):Double;
VAR D:Double;
VAR R:Integer;
BEGIN
VAL(s,d,r);
ATOR:=d;
END;

{*********************************************************************}
{ Fliekommazahl in String wandeln                                    }
{*********************************************************************}

function rtoa(r:Double):string;
var    s:string;

begin
  str(r:0:8,s); {maximal 8 Nachkommastellen}
  while s[1]=' ' do delete(s,1,1);
  while
      (s[length(s)]='0')
  and (pos('.',s)>pos('E',s))
  and (length(s)>1) do dec(s[0]);
  if s[length(s)]='.' then dec(s[0]);
  rtoa:=s;
end;

{*********************************************************************}
{ String in Integerzahl wandeln                                       }
{*********************************************************************}
Function ATOI(s:string):Longint;
var    i:longint;
   dummy:integer;
begin
  val(s,i,dummy);
  atoi:=i;
end;

{*********************************************************************}
{ Editierbare Texteingabe                                             }
{*********************************************************************}

PROCEDURE InputS(frage:string;VAR antwort:String);
var zeichen:char;       {Eingegebenes Zeichen}
    n,                  {Position im Eingabestring}
    x:Byte;             {Position des Eingabestrings auf Bildschirm}
    Enter,              {ENTER-Taste gedrckt}
    NeuEingabe:Boolean; {Dann wird alter Inhalt gelscht}
  begin
    NeuEingabe:=True;
    write(frage,': ');
    x:=WhereX;n:=1;
    Enter:=False;
    repeat
      Gotoxy(x,1);Write(Antwort);ClrEol;
      Gotoxy(X+n-1,1);
      Zeichen:=UpCase(Readkey);
      Case Zeichen of
	#0: BEGIN
	      NeuEingabe:=False;
	      Zeichen:=Readkey;
	      Case Zeichen of
		{CLT}#75: if n>1 then dec(n);
		{CRT}#77: if n<=length(antwort) then inc(n);
		{DEL}#83: delete(antwort,n,1);
                {F2}
                ELSE ENTER:=TRUE;
	      End; {Case Steuerzeichen}
	    END; {#0}
	^H: if n>1 Then
	    BEGIN
	      dec(n);
	      delete(antwort,n,1);
	      NeuEingabe:=False;
	    END;
	^M: Enter:=True;
	#32..#255:
	    BEGIN
	      If NeuEingabe Then
		BEGIN
		  NeuEingabe:=False;
		  Antwort:='';                                                               
		  n:=1;                                                                      
		END;
	      Insert(zeichen,antwort,n);                                              
	      inc(n);
	    END;
      END; {CASE}                                                              
    until Enter;                                                               
    while (length(antwort)>0) and (antwort[1]=' ') do delete(antwort,1,1);     
    gotoxy(1,1);ClrEol;
  end;

function LMitPunkt(l:Longint):String;
{Macht aus der Zahl 7543765437 den String 7.543.765.437}
VAR s:String;
BEGIN
  STR(l,s);
  s:=s+'.';
  while pos('.',s)>4 do insert('.',s,pos('.',s)-3);
  dec(s[0]);
  LMitPunkt:=s;
END;

PROCEDURE ColdBoot;
{  Kaltstart mit RAM-Test und so.}
BEGIN
inline($B8/$40/$00/           { MOV AX,40 }
       $8E/$D8/               { MOV DS,AX }
       $B8/$7f/$7f/           { MOV AX,7F7F }
       $A3/$72/$00/           { MOV [72],AX }
       $EA/$00/$00/$FF/$FF);  { JMP FFFF:0000 }
END;

begin end.
