{$A+,B-,D+,E+,F+,I-,L+,N+,O+,P-,Q-,R-,T-,V-,X+,Y+}
{
 Hardcopyroutinen
 mv 10.3.93

 10.03.93	Fr HP DeskJet
 26.07.93       Fr Nadeldrucker LX-800 und LQ-1170
}
unit HardCopy;
interface uses graph, dos, crt, printer;
const ptHPLaserJet=1;
const ptHPDeskJet =2;
const pt9Nadler   =3;
const pt24Nadler  =4;
const ptLX800     =5;

function PrintWindow(x1,y1,x2,y2:Integer):Boolean;
function GetHardCopyPrinterName:String;
const HardCopyPrinterID:Integer=ptHPDeskJet;
const HardCopyPrinterRes:Integer=0;
implementation


function HardCopyLaserJet(x1,y1,x2,y2:Integer):Boolean;
label Fehler;
type Zeilentyp=Array[0..900] of Byte; {30 cm bei 600 DPI}
var bpos:integer;
var breite:integer; {in Byte}
var x,y:integer;
var b:^Zeilentyp;
begin
  b:=nil;
  breite:=(x2-x1+15) div 8;
  if (breite>sizeof(zeilentyp))
  or (maxavail<breite) then goto fehler;
  getmem(b,breite);
  Case HardCopyPrinterRes of
  1,75: write(LST,#27'*t75R');           { 75 DPI}
  2,100: write(LST,#27'*t100R');         {100 DPI}
  3,150: write(LST,#27'*t150R');         {150 DPI}
  4,300: write(LST,#27'*t300R');         {300 DPI}
  5,600: write(LST,#27'*t600R');         {600 DPI}
  else write(LST,#27'*t150R');           {150 DPI}
  end;
  if ioresult<>0 then goto fehler;
  write(LST,#27,'*r',x2-x1+1,'S');     {Setze Bildbreite}
  if ioresult<>0 then goto fehler;
  for y:=y1 to y2 do
  begin
  x:=x1;
  bpos:=0;
  while x<=x2 do
  begin
    b^[bpos]
     :=byte((getpixel(x,y)=0)) shl 7
    or byte((getpixel(x+1,y)=0) and (x+1<=x2)) shl 6
    or byte((getpixel(x+2,y)=0) and (x+2<=x2)) shl 5
    or byte((getpixel(x+3,y)=0) and (x+3<=x2)) shl 4
    or byte((getpixel(x+4,y)=0) and (x+4<=x2)) shl 3
    or byte((getpixel(x+5,y)=0) and (x+5<=x2)) shl 2
    or byte((getpixel(x+6,y)=0) and (x+6<=x2)) shl 1
    or byte((getpixel(x+7,y)=0) and (x+7<=x2));
    inc(x,8);
    inc(bpos);
  end; {x}
  if keypressed and (readkey=#27) then goto fehler;
  write(LST,#27'*b',bpos,'W');
  if ioresult<>0 then goto fehler;
  for x:=0 to bpos-1 do write(LST,char(b^[x]));
  if ioresult<>0 then goto fehler;
  if keypressed and (readkey=#27) then goto fehler;
  end; {y}
  write(LST,#27,'*rB'#12);          {Grafikmodus Ende, Seitenvorschub}
  if ioresult<>0 then goto fehler;
  HardCopyLaserJet:=TRUE;
  freemem(b,breite);
  exit;
Fehler:
  HardCopyLaserJet:=FALSE;
  write(LST,#27,'*rB'#12);          {Grafikmodus Ende, Seitenvorschub}
  if ioresult<>0 then;
  if b<>nil then freemem(b,breite);
end;

function HardCopyDeskJet(x1,y1,x2,y2:Integer):Boolean;
label Fehler;
type Zeilentyp=Array[0..450] of Byte; {30 cm bei 300 DPI}
var breite,bpos,zpos:integer;
var x,y:integer;
var b,z:^Zeilentyp;
var zaehler:Integer;

begin
  b:=nil;
  z:=nil;
  if maxavail<2*sizeof(zeilentyp) then goto fehler;
  new(b);
  new(z);
  Case HardCopyPrinterRes of
  1,75: write(LST,#27'*t75R');           { 75 DPI}
  2,100: write(LST,#27'*t100R');         {100 DPI}
  3,150: write(LST,#27'*t150R');         {150 DPI}
  4,300: write(LST,#27'*t300R');         {300 DPI}
  else write(LST,#27'*t150R');           {150 DPI}
  end;
  if ioresult<>0 then goto fehler;
  write(LST,#27,'*r',x2-x1+1,'S');     {Setze Bildbreite}
  if ioresult<>0 then goto fehler;
  write(LST,#27,'*b2M');               {Kompression Stufe 2}
  if ioresult<>0 then goto fehler;
  for y:=y1 to y2 do
  begin
  x:=x1;
  bpos:=0;
  while x<=x2 do {Zeile lesen}
  begin
    b^[bpos]
     :=byte((getpixel(x,y)=0)) shl 7
    or byte((getpixel(x+1,y)=0) and (x+1<=x2)) shl 6
    or byte((getpixel(x+2,y)=0) and (x+2<=x2)) shl 5
    or byte((getpixel(x+3,y)=0) and (x+3<=x2)) shl 4
    or byte((getpixel(x+4,y)=0) and (x+4<=x2)) shl 3
    or byte((getpixel(x+5,y)=0) and (x+5<=x2)) shl 2
    or byte((getpixel(x+6,y)=0) and (x+6<=x2)) shl 1
    or byte((getpixel(x+7,y)=0) and (x+7<=x2));
    inc(x,8);
    inc(bpos);
  end; {x}
  if keypressed and (readkey=#27) then goto fehler;
  breite:=bpos;
  bpos:=0;
  zpos:=0;
  repeat {Zeile komprimieren}
    zaehler:=0;
    if b^[bpos]<>b^[bpos+1] then
    begin {Ungleich}
      repeat inc(bpos);inc(zaehler);
      until (bpos>breite)
      or    (b^[bpos]=b^[bpos+1])
      or    (zaehler=127);
      z^[zpos]:=zaehler-1;
      move (b^[bpos-zaehler],z^[zpos+1],zaehler);
      inc(zpos,zaehler+1);
    end
    else
    begin {Wiederholung}
      repeat inc(bpos);inc(zaehler);
      until (bpos>breite)
      or    (b^[bpos]<>b^[bpos-1])
      or    (Zaehler=127);
      z^[zpos]:=-Zaehler+1;
      z^[zpos+1]:=b^[bpos-1];
      inc(zpos,2);
    end;
  until bpos>=breite;

  write(LST,#27'*b',zpos,'W');
  if ioresult<>0 then goto fehler;
  for x:=0 to zpos-1 do write(LST,char(z^[x]));
  if ioresult<>0 then goto fehler;
  if keypressed and (readkey=#27) then goto fehler;
  end; {y}
  write(LST,#27,'*rB'#12);          {Grafikmodus Ende, Seitenvorschub}
  if ioresult<>0 then goto fehler;
  HardCopyDeskJet:=TRUE;
  dispose(z);
  dispose(b);
  exit;
Fehler:
  HardCopyDeskJet:=FALSE;
  write(LST,#27,'*rB'#12);          {Grafikmodus Ende, Seitenvorschub}
  if ioresult<>0 then;
  if b<>nil then dispose(b);
  if z<>nil then dispose(z);
end;

function HardCopy9Nadler(x1,y1,x2,y2:Integer):Boolean;
label Fehler;
type Zeilentyp=Array[0..3550] of Byte; {30 cm bei 300 DPI}
var bpos:integer;
var breite:integer; {in Byte}
var x,y:integer;
var b:^Zeilentyp;
begin
  b:=nil;
  breite:=(x2-x1+1);
  if (breite>sizeof(zeilentyp))
  or (maxavail<breite) then goto fehler;
  getmem(b,breite);
  write(LST,#27'3',#24);              {Grafikauflsung? Zeilenabstand?}
  if ioresult<>0 then goto fehler;
  y:=y1;
  while y<=y2 do
  begin
  x:=x1;
  bpos:=0;
  while x<=x2 do
  begin
    b^[bpos]
     :=byte((getpixel(x,y)=0)) shl 7
    or byte((getpixel(x,y+1)=0) and (y+1<=y2)) shl 6
    or byte((getpixel(x,y+2)=0) and (y+2<=y2)) shl 5
    or byte((getpixel(x,y+3)=0) and (y+3<=y2)) shl 4
    or byte((getpixel(x,y+4)=0) and (y+4<=y2)) shl 3
    or byte((getpixel(x,y+5)=0) and (y+5<=y2)) shl 2
    or byte((getpixel(x,y+6)=0) and (y+6<=y2)) shl 1
    or byte((getpixel(x,y+7)=0) and (y+7<=y2));
    inc(x);
    inc(bpos);
  end; {x}
  if keypressed and (readkey=#27) then goto fehler;
  write(LST,#27'L',char(lo(bpos)),char(hi(bpos)));
  if ioresult<>0 then goto fehler;
  for x:=0 to bpos-1 do write(LST,char(b^[x]));
  if ioresult<>0 then goto fehler;
  Writeln(LST);
  if ioresult<>0 then goto fehler;
  if keypressed and (readkey=#27) then goto fehler;
  inc(y,8);
  end; {y}
  write(LST,#27#64#12);          {Reset, Seitenvorschub}
  if ioresult<>0 then goto fehler;
  HardCopy9Nadler:=TRUE;
  freemem(b,breite);
  exit;
Fehler:
  HardCopy9Nadler:=FALSE;
  write(LST,#27#64#12);          {Reset, Seitenvorschub}
  if ioresult<>0 then;
  if b<>nil then freemem(b,breite);
end;

function HardCopyLX800(x1,y1,x2,y2:Integer):Boolean;
label Fehler;
type Zeilentyp=Array[0..3550] of Byte; {30 cm bei 300 DPI}
var bpos:integer;
var breite:integer; {in Byte}
var x,y:integer;
var b:^Zeilentyp;
begin
  b:=nil;
  breite:=(x2-x1+1);
  if (breite>sizeof(zeilentyp))
  or (maxavail<breite) then goto fehler;
  getmem(b,breite);
  write(LST,#27'A',#8);              {8/72 Zoll Zeilenabstand}
  if ioresult<>0 then goto fehler;
  y:=y1;
  while y<=y2 do
  begin
  x:=x1;
  bpos:=0;
  while x<=x2 do
  begin
    b^[bpos]
     :=byte((getpixel(x,y)=0)) shl 7
    or byte((getpixel(x,y+1)=0) and (y+1<=y2)) shl 6
    or byte((getpixel(x,y+2)=0) and (y+2<=y2)) shl 5
    or byte((getpixel(x,y+3)=0) and (y+3<=y2)) shl 4
    or byte((getpixel(x,y+4)=0) and (y+4<=y2)) shl 3
    or byte((getpixel(x,y+5)=0) and (y+5<=y2)) shl 2
    or byte((getpixel(x,y+6)=0) and (y+6<=y2)) shl 1
    or byte((getpixel(x,y+7)=0) and (y+7<=y2));
    inc(x);
    inc(bpos);
  end; {x}
  if keypressed and (readkey=#27) then goto fehler;
  Case HardCopyPrinterRes of
  1,60:  write(LST,#27'*'#0);            { 60x72 DPI}
  2,72:  write(LST,#27'*'#5);            { 72x72 DPI}
  3,120: write(LST,#27'*'#1);            {120x72 DPI}
  4,240: write(LST,#27'*'#3);            {240x72 DPI}
  else write(LST,#27'*'#5);              { 72x72 DPI}
  end;
  write(LST,char(lo(bpos)),char(hi(bpos)));
  if ioresult<>0 then goto fehler;
  for x:=0 to bpos-1 do write(LST,char(b^[x]));
  if ioresult<>0 then goto fehler;
  Writeln(LST);
  if ioresult<>0 then goto fehler;
  if keypressed and (readkey=#27) then goto fehler;
  inc(y,8);
  end; {y}
  write(LST,#27#64#12);          {Reset, Seitenvorschub}
  if ioresult<>0 then goto fehler;
  HardCopyLX800:=TRUE;
  freemem(b,breite);
  exit;
Fehler:
  HardCopyLX800:=FALSE;
  write(LST,#27#64#12);          {Reset, Seitenvorschub}
  if ioresult<>0 then;
  if b<>nil then freemem(b,breite);
end;


function HardCopy24Nadler(x1,y1,x2,y2:Integer):Boolean;
label Fehler;
type Zeilentyp=Array[0..7100] of Byte; {30 cm bei 600 DPI}
var bpos:integer;
var breite:integer; {in Byte}
var x,y:integer;
var b1,b2,b3:^Zeilentyp;
begin
  b1:=nil;
  b2:=nil;
  b3:=nil;
  breite:=(x2-x1+1);
  if (breite>sizeof(zeilentyp))
  or (maxavail<3*breite) then goto fehler;
  getmem(b1,breite);
  getmem(b2,breite);
  getmem(b3,breite);
  write(LST,#27'3',#24);              {Zeilenabstand 24/180 Zoll}
  if ioresult<>0 then goto fehler;
  y:=y1;
  while y<=y2 do
  begin
  x:=x1;
  bpos:=0;
  while x<=x2 do
  begin
    b1^[bpos]
     :=byte((getpixel(x,y)=0) and (y<=y2)) shl 7
    or byte((getpixel(x,y+1)=0) and (y+1<=y2)) shl 6
    or byte((getpixel(x,y+2)=0) and (y+2<=y2)) shl 5
    or byte((getpixel(x,y+3)=0) and (y+3<=y2)) shl 4
    or byte((getpixel(x,y+4)=0) and (y+4<=y2)) shl 3
    or byte((getpixel(x,y+5)=0) and (y+5<=y2)) shl 2
    or byte((getpixel(x,y+6)=0) and (y+6<=y2)) shl 1
    or byte((getpixel(x,y+7)=0) and (y+7<=y2));
    b2^[bpos]
     :=byte((getpixel(x,y+8)=0) and (y+8<=y2)) shl 7
    or byte((getpixel(x,y+8+1)=0) and (y+8+1<=y2)) shl 6
    or byte((getpixel(x,y+8+2)=0) and (y+8+2<=y2)) shl 5
    or byte((getpixel(x,y+8+3)=0) and (y+8+3<=y2)) shl 4
    or byte((getpixel(x,y+8+4)=0) and (y+8+4<=y2)) shl 3
    or byte((getpixel(x,y+8+5)=0) and (y+8+5<=y2)) shl 2
    or byte((getpixel(x,y+8+6)=0) and (y+8+6<=y2)) shl 1
    or byte((getpixel(x,y+8+7)=0) and (y+8+7<=y2));
    b3^[bpos]
     :=byte((getpixel(x,y+16)=0) and (y+16<=y2)) shl 7
    or byte((getpixel(x,y+16+1)=0) and (y+16+1<=y2)) shl 6
    or byte((getpixel(x,y+16+2)=0) and (y+16+2<=y2)) shl 5
    or byte((getpixel(x,y+16+3)=0) and (y+16+3<=y2)) shl 4
    or byte((getpixel(x,y+16+4)=0) and (y+16+4<=y2)) shl 3
    or byte((getpixel(x,y+16+5)=0) and (y+16+5<=y2)) shl 2
    or byte((getpixel(x,y+16+6)=0) and (y+16+6<=y2)) shl 1
    or byte((getpixel(x,y+16+7)=0) and (y+16+7<=y2));
    inc(x);
    inc(bpos);
  end; {x}
  if keypressed and (readkey=#27) then goto fehler;
  {Aus Handbuch EPSON LQ 870/1170:}
  Case HardCopyPrinterRes of
  1,60:  write(LST,#27'*'#32);           { 60x180 DPI}
  2,90:  write(LST,#27'*'#38);           { 90x180 DPI}
  3,180: write(LST,#27'*'#39);           {180x180 DPI}
  4,360: write(LST,#27'*'#40);           {360x180 DPI}
  else write(LST,#27'*'#39);             {180x180 DPI}
  end;
  write(LST,char(lo(bpos)),char(hi(bpos)));
  if ioresult<>0 then goto fehler;
  for x:=0 to bpos-1 do write(LST,char(b1^[x]),char(b2^[x]),char(b3^[x]));
  if ioresult<>0 then goto fehler;
  Writeln(LST);
  if ioresult<>0 then goto fehler;
  if keypressed and (readkey=#27) then goto fehler;
  inc(y,24);
  end; {y}
  write(LST,#27#64#12);          {Reset, Seitenvorschub}
  if ioresult<>0 then goto fehler;
  HardCopy24Nadler:=TRUE;
  freemem(b1,breite);
  freemem(b2,breite);
  freemem(b3,breite);
  exit;
Fehler:
  HardCopy24Nadler:=FALSE;
  write(LST,#27#64#12);          {Reset, Seitenvorschub}
  if ioresult<>0 then;
  if b1<>nil then freemem(b1,breite);
  if b2<>nil then freemem(b2,breite);
  if b3<>nil then freemem(b3,breite);
end;

function GetHardCopyPrinterName:String;
begin
  case HardCopyPrinterID of
  ptHPLaserJet: GetHardCopyPrintername:='HP LaserJet';
  ptHPDeskJet:  GetHardCopyPrintername:='HP DeskJet';
  pt9Nadler:    GetHardCopyPrintername:='9-Nadel-Drucker';
  pt24Nadler:   GetHardCopyPrintername:='24-Nadel-Drucker';
  ptlx800:      GetHardCopyPrintername:='EPSON LX-800';
  else GetHardCopyPrinterName:='unbekannt';
  end;
end;

function PrintWindow(x1,y1,x2,y2:Integer):Boolean;
begin
  case HardCopyPrinterID of
  ptHPLaserJet: PrintWindow:=HardCopyLaserJet(x1,y1,x2,y2);
  ptHPDeskJet:  PrintWindow:=HardCopyDeskJet(x1,y1,x2,y2);
  pt9Nadler:    PrintWindow:=HardCopy9Nadler(x1,y1,x2,y2);
  pt24Nadler:   PrintWindow:=HardCopy24Nadler(x1,y1,x2,y2);
  ptlx800:      PrintWindow:=HardCopylx800(x1,y1,x2,y2);
  else PrintWindow:=FALSE;
  end;
end;

begin end.