{$A+,B-,D+,E+,F+,I-,L+,N+,O+,R-,V-,X+}
unit hpglview;
{Darstellung von HPGL-Dateien in ZEIGWPG}


interface uses crt,dos,graph,general,viewprim,viewsl;

procedure ZEIGPLT(dir:dirstr;name:DateiNamenTyp;x1,y1,x2,y2:Word);

implementation

TYPE Stiftstatus=(oben,unten);
     Befehlsname=(unbekannt,PA,PD,PR,PU,CI,SP,XT,YT);
{$IFopt N+}
TYPE Real=Double;
{$ENDIF}
VAR PLT:Text;

function befehl(VAR a,b:LONGINT;VAR Hatparameter,fertig:Boolean):Befehlsname;
VAR
    s:String;
    valcode:Integer;
const Zeichen:Char='#';
const letzterbefehl:befehlsname=unbekannt;
{Das letzte Zeichen wird gemerkt, falls keine Befehlstrenner vorkommen.}

Procedure Lieszeichen;
BEGIN
  repeat
    Read(plt,zeichen);
    fertig:=eof(plt) or (ioresult<>0);
  until (zeichen>#32) or fertig;
END;

BEGIN
  Fertig:=True;
  While (Zeichen<'A')
    and ((zeichen<'0') or (zeichen>'9') or (zeichen='-'))
    and (Zeichen<>',')
    and not eof(plt) do
    LiesZeichen;

  {Weiter mit Parametern?}
  If Zeichen>='A' Then
  Case Zeichen of
  'P': begin
	 LiesZeichen;
	 case Zeichen of
	 'A':LetzterBefehl:=PA;
	 'D':LetzterBefehl:=PD;
	 'U':LetzterBefehl:=PU;
	 'R':LetzterBefehl:=PR;
	 else Letzterbefehl:=Unbekannt;
	 end;
       end;
  'C': begin
	 LiesZeichen;
	 If Zeichen='I' Then LetzterBefehl:=CI
	 else LetzterBefehl:=Unbekannt;
       end;
  'S': begin
	 LiesZeichen;
	 If Zeichen='P' Then LetzterBefehl:=SP
	 else LetzterBefehl:=Unbekannt;
       end;
  {Die ARC-Befehle haben drei Parameter und werden berlesen:}
  'A': begin
	 repeat
	 LiesZeichen;
	 until eof(plt)
	       or (zeichen<',')
	       or (zeichen=';');
	 LetzterBefehl:=PU;
       END;
  'X': begin
	 LiesZeichen;
	 If Zeichen='T' Then LetzterBefehl:=XT
	 else LetzterBefehl:=Unbekannt;
       end;
  'Y': begin
	 LiesZeichen;
	 If Zeichen='T' Then LetzterBefehl:=YT
	 else LetzterBefehl:=Unbekannt;
       end;
  ELSE LetzterBefehl:=Unbekannt;
  END; {CASE}

  Befehl:=Letzterbefehl;
  {Jetzt zwei Parameter lesen:}
  s:='';
  LiesZeichen;
  if (Zeichen='-') or ((Zeichen>='0') and (Zeichen<='9'))
  then
    begin
      hatparameter:=true;
      While (Zeichen='-')
	 or ((Zeichen>='0') and (Zeichen<='9')) DO
	BEGIN
	  inc(s[0]);
	  s[length(s)]:=zeichen;
	  LiesZeichen;
	END;
      VAL(s,a,valcode);
      If (Zeichen=',') or (Zeichen=' ') THEN
      BEGIN
	s:='';
	LiesZeichen;
	While (Zeichen='-')
	   or ((Zeichen>='0') and (Zeichen<='9')) DO
	  BEGIN
	    inc(s[0]);
	    s[length(s)]:=zeichen;
	    LiesZeichen;
	  END;
	VAL(s,b,valcode);
      END;
    end {hat parameter}
  else hatparameter:=false;
  FERTIG:=EOF(PLT);
END;

PROCEDURE ZEIGPLT(dir:dirstr;name:DateiNamenTyp;x1,y1,x2,y2:word);
var
  Stift:Stiftstatus;
  min_x,min_y,
  max_x,max_y:LongInt;
  v1,v2,varia:Real;
  xas,yas,
  x0,y0:Word;
  a,b,x,y,xa,ya:Longint;
  hatparameter,fertig:Boolean;
  puffer:^puffertyp;
  maxpuffer:word;
BEGIN
  ASSIGN(PLT,dir+Name);
  maxpuffer:=lmin(maxavail,sizeof(puffertyp));
  if maxpuffer>128 then
  begin
  getmem(puffer,maxpuffer);
  settextbuf(plt,puffer^,maxpuffer);
  end;
  RESET(PLT); if ioresult=0 then
BEGIN
  {Standard-Farben setzen}
  SETEGARGB;

  {Zuerst nur die Zeichnungsgrenzen holen}
  Stift:=Oben;
  Fertig:=KeyPressed;
  min_x:= 2000000000;
  max_x:=-2000000000;
  min_y:= 2000000000;
  max_y:=-2000000000;

  Repeat
    CASE BEFEHL(a,b,hatparameter,fertig) of
    PA:
      If HatParameter Then
      BEGIN
	x:=a;
	y:=b;
	IF Stift=unten
	THEN
	BEGIN
	  if x<min_x then min_x:=x;
	  if x>max_x then max_x:=x;
	  if y<min_y then min_y:=y;
	  if y>max_y then max_y:=y;
	END;
      END;
    PR:
      If HatParameter Then
      BEGIN
	inc(x,a);
	inc(y,b);
	IF Stift=unten
	THEN
	BEGIN
	  if x<min_x then min_x:=x;
	  if x>max_x then max_x:=x;
	  if y<min_y then min_y:=y;
	  if y>max_y then max_y:=y;
	END;
      END;
    PD:
      BEGIN
      Stift:=unten;
      If HatParameter Then
      BEGIN
	if x<min_x then min_x:=x;
	if x>max_x then max_x:=x;
	if y<min_y then min_y:=y;
	if y>max_y then max_y:=y;
	x:=a;
	y:=b;
	if x<min_x then min_x:=x;
	if x>max_x then max_x:=x;
	if y<min_y then min_y:=y;
	if y>max_y then max_y:=y;
      END;
      END;
    PU:
      BEGIN
	x:=a;
	y:=b;
	Stift:=oben;
      END;
    CI:
      BEGIN
	Stift:=oben;
	if x-a<min_x then min_x:=x-a;
	if x+a>max_x then max_x:=x+a;
	if y-a<min_y then min_y:=y-a;
	if y+a>max_y then max_y:=y+a;
      END;
    end; {CASE}
  Until Fertig or keypressed;

  CLOSE(PLT);if ioresult<>0 then;

  IF EinsZuEins
    THEN BEGIN Xas:=1; Yas:=1 END
  ELSE
    BEGIN
      GetAspectRatio(Xas,Yas);
      Xas:=round(Xas*10000.0/Breitenfaktor);
    END;
  if max_x=min_x then wpgbreite:=1 else wpgbreite:=max_x-min_x+1;
  if max_y=min_y then wpghoehe:=1 else wpghoehe:=max_y-min_y+1;
  v1:=1.0*(x2-x1+1)/wpgbreite;
  v2:=1.0*(y2-y1+1)/wpghoehe*Yas/Xas;

  {Je nachdem, ob das Bild zu hoch oder zu breit ist, wird
   v1 oder v2 genommen:}
  IF v1>v2 THEN
  BEGIN
    xvaria:=round(v2*Eins*0.95);
    yvaria:=round(v2*Xas/Yas*Eins*0.95);
  END
  ELSE
  BEGIN
    xvaria:=round(v1*Eins*0.95);
    yvaria:=round(v1*Xas/Yas*Eins*0.95);
  END;

  x0:=x1+((x2-x1)-hiword(xvaria*(max_x-min_x)))div 2; {links}

  y0:=y2-((y2-y1)-round(1.0*yvaria*(max_y-min_y)/eins))div 2; {unten}

  RESET(PLT);if ioresult=0 THEN
  BEGIN

  Stift:=Oben;
  Fertig:=Keypressed;
  IF infdatvorh
  THEN zeiginfozeile(name);
  IF NOT infogefunden THEN
  Writesl(name+', Originalgre: '+
	  ls(round((max_x-min_x)/40))+' x '+
	  ls(round((max_y-min_y)/40))+' mm.',true);

  SetViewport(0,0,maxx,maxy,TRUE);
  Repeat
    CASE BEFEHL(a,b,hatparameter,fertig) of
    PA:
      If Hatparameter then
      {Dieses blde Speicheroszi von Ristow schreibt den
       PA-Befehl ohne Koordinaten!}
      BEGIN
      x:=x0+hiword(xvaria*(a-min_x));
      y:=y0-hiword(yvaria*(b-min_y));
      IF   Stift=unten
      THEN lineto(x,y)
      ELSE moveto(x,y);
      xa:=a;
      xa:=b;
      END;
    PR:
      BEGIN
      inc(xa,a);
      inc(ya,b);
      x:=x0+hiword(xvaria*(xa-min_x));
      y:=y0-hiword(yvaria*(ya-min_y));
      IF   Stift=unten
      THEN lineto(x,y)
      ELSE moveto(x,y);
      END;
    PD:
      BEGIN
      Stift:=unten;
      If HatParameter
      THEN
      BEGIN
      x:=x0+hiword(xvaria*(a-min_x));
      y:=y0-hiword(yvaria*(b-min_y));
      lineto(x,y);
      xa:=a;
      ya:=b;
      END;
      END;
    PU:
      BEGIN
      Stift:=oben;
      If HatParameter
      THEN
      BEGIN
      x:=x0+hiword(xvaria*(a-min_x));
      y:=y0-hiword(yvaria*(b-min_y));
      moveto(x,y);
      xa:=a;
      ya:=b;
      END;
      END;
    CI:
      BEGIN
      Stift:=Oben;
      Circle(x,y,hiword(xvaria*a));
      END;
    XT:
      BEGIN
      Line(x,y-2,x,y+2);
      END;
    YT:
      BEGIN
      Line(x-2,y,x+2,y);
      END;
    SP:
      Setcolor((lmax(1,a)-1) mod hgfarbe);
      {Stift null ist schwarz und getmaxcolor als Stiftfarbe ist nicht
       erlaubt}
    ELSE Stift:=Oben;
    end; {CASE}
  Until Fertig or keypressed;
  END;
  SetViewport(0,0,getmaxx,getmaxy,false);
END;
  if maxpuffer>128 then FREEMEM(puffer,MAXPUFFER);
  CLOSE(PLT);if ioresult<>0 then;
END;

BEGIN END.

