{$A+,B-,D+,E+,F-,G+,I-,L+,N+,O+,P-,Q-,R-,S-,T-,V-,X+,Y+}
{alt $A+,B-,D+,E-,F+,G-,I-,L+,N-,O+,R-,S-,V-,X+}
UNIT Maus;

INTERFACE Uses DOS;

VAR MausDa:Boolean;

function  MsMouse : boolean; {Macht Treiberreset und ist TRUE wenn Maus da}
Procedure Show_mouse;       { displays the mouse cursor on the screen }
Procedure Hide_mouse;       { Hides the mouse cursor on the screen }
Procedure Get_mouse_status(Var m2, m3, m4 : integer);
Procedure Put_mouse ( x, y : integer);
Procedure Get_mouse_button_pressed (Var m1, m2, m3, m4 : integer);
Procedure Get_mouse_button_released (Var m1, m2, m3, m4 : integer);
Procedure Set_mouse_X_range (Min, Max : integer);
Procedure Set_mouse_Y_range (Min, Max : integer);
Procedure Set_Graphics_Icon (xspot, yspot, icon_pointer : integer);
Procedure Set_text_cursor (cursor_type, start, stop : integer);
Procedure Mouse_motion (Var xcounter, ycounter : integer);
Procedure mouse_mickeys (x, y : integer);
Procedure mouse_DST (mickeys : integer);
Procedure Mouse_Kreuzcursor;
Function Leftmousebutton:Boolean;
Function Rightmousebutton:Boolean;

IMPLEMENTATION

Var
  MouseR          : registers;
  m1, m2, m3, m4  : word;
  mouse           : boolean;

function MsMouse : boolean;
begin
  MouseR.ax:=0;
  intr($33,MouseR);
  MsMouse:=MouseR.ax<>0;
end;  { MsMouse }

Procedure Show_mouse;  { displays the mouse cursor on the screen }
begin
  Mouser.ax := 1;
  intr ($33, mouser);
end;

Procedure Hide_mouse;  { Hides the mouse cursor on the screen }
begin
  Mouser.ax := 2;
  intr ($33, mouser);
end;

Procedure Get_mouse_status (Var m2, m3, m4 : integer);
begin
  Mouser.ax := 3;
  intr ($33, mouser);
    m2 := mouser.bx;
    m3 := mouser.cx;
    m4 := mouser.dx;
end;

Procedure Put_mouse ( x, y : integer);
begin
    mouser.ax := 4;
    mouser.cx := x;
    mouser.dx := y;
  intr ($33, mouser);
end;

Procedure Get_mouse_button_pressed (Var m1, m2, m3, m4 : integer);
begin
    mouser.ax := 5;
    mouser.bx := m2;
  intr ($33, mouser);
    m1 := mouser.ax;
    m2 := mouser.bx;
    m3 := mouser.cx;
    m4 := mouser.dx;
end;

Procedure Get_mouse_button_released (Var m1, m2, m3, m4 : integer);
begin
    mouser.ax := 6;
    mouser.bx := m2;
  intr ($33, mouser);
    m1 := mouser.ax;
    m2 := mouser.bx;
    m3 := mouser.cx;
    m4 := mouser.dx;
end;

Procedure Set_mouse_X_range (Min, Max : integer);
begin
    mouser.ax := 7;
    mouser.cx := min;
    mouser.dx := max;
  intr ($33, mouser);
end;

Procedure Set_mouse_Y_range (Min, Max : integer);
begin
    mouser.ax := 8;
    mouser.cx := min;
    mouser.dx := max;
  intr ($33, mouser);
end;

Procedure Set_Graphics_Icon (xspot, yspot, icon_pointer : integer);
begin
    mouser.ax := 9;
    mouser.bx := xspot;
    mouser.cx := yspot;
    mouser.dx := icon_pointer;
  intr ($33, mouser);
end;

Procedure Set_text_cursor (cursor_type, start, stop : integer);
begin
    mouser.ax := 10;
    mouser.bx := cursor_type;
    mouser.cx := start;
    mouser.dx := stop;
  intr ($33, mouser);
end;

Procedure Mouse_motion (Var xcounter, ycounter : integer);
begin
  mouser.ax := 11;
  intr ($33, mouser);
    xcounter := integer(mouser.cx);
    ycounter := integer(mouser.dx);
end;

Procedure mouse_mickeys (x, y : integer);
begin
    mouser.ax := 15;
    mouser.cx := x;
    mouser.dx := y;
  intr ($33, mouser);
end;

Procedure mouse_DST (mickeys : integer);
begin
    mouser.ax := 19;
    mouser.dx := mickeys;
  intr ($33, mouser);
end;

Procedure Mouse_Kreuzcursor; Assembler;
{Weies Balkenkreuz und Schwarzes "X"}
Label L1, MKC;
ASM
 JMP L1
 MKC:
  {Gesetzte Bits behalten die Farbe:}
  DW $FFFF,$FFFF,$FFFF,$FFFF-4100
  DW $FFFF-320-2056,$FFFF-320-1040,$FFFF-320-544
  DW $FFFF-3640,$FFFF-0,$FFFF-3640
  DW $FFFF-320-544,$FFFF-320-1040,$FFFF-320-2056
  DW $FFFF-4100,$FFFF,$FFFF
  {Gesetzte Bits werden wei:}
  DW 0,0,0,0
  DW 320,320,320
  DW 3640,0,3640
  DW 320,320,320
  DW 0,0,0
 L1:
 MOV AX,9
 MOV BX,8
 MOV CX,8
 MOV DX, offset MKC
 PUSH CS
 POP ES
 INT $33
end;


Function Rightmousebutton:Boolean;
var m1,m2,m3:Integer;
begin
  get_mouse_status(m1,m2,m3);
  Rightmousebutton:=(m1 and 2)=2;
end;

Function Leftmousebutton:Boolean;
var m1,m2,m3:Integer;
begin
  get_mouse_status(m1,m2,m3);
  Leftmousebutton:=(m1 and 1)=1;
end;


{PC Software Interest Group (PC-SIG)
1030 E Duane, Suite J
Sunnyvale, CA 94086
(408) 730-9291}

begin end.
