{$A+,B-,D+,E+,F+,I-,L+,N+,O+,R-,V-,X+}
unit popwin;

INTERFACE USES CRT,DOS,GRAPH,VIEWPRIM;
{Flags:}
const LogoFlag=1;    {Regenbogenball}
const WarteFlag=2;   {Wartet auf Tastendruck}
const BehalteFlag=6; {Tastendruck wird nicht zurckgegeben}
		     {Schliet WarteFlag ein}
const QuickFlag=8;   {Fensterhintergrund wird nicht gesichert}
const KeepFlag=24;   {Fenster immer stehen lassen}
		     {Schliet QuickFlag ein}
const FuenfSekundenFlag=32;
		     {Fenster schliet sich nach 5 Sekunden von selbst}
var   popwintaste:char;
Function PopInit:Boolean;
Procedure PopWrite(S:String);
Procedure OpenPopWin(Titel:String;Flags:Word);
PROCEDURE Ausschnitthilfe(AusHauptMenue:Boolean);
PROCEDURE Palettenhilfe(AusHauptMenue:Boolean);
PROCEDURE NoPalHilfe;
PROCEDURE IntroFenster(version,lizenznehmer:string);
PROCEDURE File_Info(DIR:String;DN:Dateilistentyp;DateiAttr:Word;
		    Palpos:LongInt;Palfarben:Word);
PROCEDURE Font_Hilfe(Flag:Integer);
PROCEDURE HelpWindow;
PROCEDURE Disk_Info(DIR:Dirstr;markiertedateien:word;markierteKbyte:longint);
PROCEDURE Gruppen_Info(markiertedateien:word;markierteKbyte:longint);
PROCEDURE Programm_Info(Version:String;GrMode:Integer);
PROCEDURE Double_File_Info(n1,n2:pathstr);
PROCEDURE Zoomhilfe;
PROCEDURE DruckHilfe;
PROCEDURE NoZoomhilfe;
PROCEDURE TestBildHilfe;
PROCEDURE Inputhilfe(Hilfstext:Integer);
procedure PCXINFO(DN:Dateilistentyp;DateiZeit:DateTime);
procedure BMPINFO(DN:Dateilistentyp;DateiZeit:DateTime);
PROCEDURE Copy_Info;
PROCEDURE AbbruchHinweis;
PROCEDURE DummyFenster;
PROCEDURE SCRIPTERROR(ERRNR,ERRLN:INTEGER);

IMPLEMENTATION
USES GREXPORT,MAUS,VGABIOS,WPSHELL,
     GENERAL,VIEWSL,QWGIO,OVERLAY,
     SCRIPT,DISUNDAS;
VAR popline,
    popbreite   :integer;
    Poppuffer   :Pointer;	{Die Helpwindows knnen bei genug Heap auch}
    PopPufUsed  :Boolean;       {wieder restlos verschwinden}
    PopDateibenutzt
		:Boolean;	{Oder auf Platte!}
{  PopEMSbenutzt:Boolean;       {Und wann kommt das endlich?}
    PopImgSize  :LongInt;
    POPX,POPY   :WORD;          {Position des Fensters}

CONST MaxPopLine=40;
VAR PopZeile:Array[1..MaxPopline] of ^String;
CONST POPFensterOffen:Boolean=FALSE;
CONST FontName		:array[0..11]   {FontNamen}
			 of String[4] =
			 ('ROM','TRIP','LITT','SANS','GOTH',
			  'SCRI','SIMP','TSCR','LCOM','EURO',
			  'BOLD','USER');

Function Moname(nr:byte):Dateinamentyp; {String[13]}
begin
Case nr of
1:MoName:=' Januar ';
2:MoName:=' Februar ';
3:MoName:=' Mrz ';
4:MoName:=' April ';
5:MoName:=' Mai ';
6:MoName:=' Juni ';
7:MoName:=' Juli ';
8:MoName:=' August ';
9:MoName:=' September ';
10:MoName:=' Oktober ';
11:MoName:=' November ';
12:MoName:=' Dezember ';
else MoName:=ls(nr)+'.';
end;
end;

(*---------------------------------------------------------------------
		 INITIALISIERUNG DER POP-VARIABLEN
---------------------------------------------------------------------*)
Function PopInit:Boolean;
begin
  If PopFensterOffen
  then
  begin
    popinit:=false;
  end
  else
  begin
    PopLine:=0;
    PopBreite:=0;
    popfensteroffen:=true;
    popinit:=true;
  end;
end;

(*---------------------------------------------------------------------
		       SCHREIBEN EINER ZEILE
---------------------------------------------------------------------*)
Procedure PopWrite(S:String);
begin
  if s='' then s:=' ';
  If Maxavail<1+length(s) then FehlerAbbruch(KeinRam);
  inc(popline);
  If PopLine>MaxPopLine Then FehlerAbbruch(PopLineOverFlow);
  getmem(PopZeile[popline],1+length(s));
  PopZeile[popline]^:=s;
  PopBreite:=Lmax(PopBreite,TextWidth(s));
end;

(*---------------------------------------------------------------------
		     FFNEN DES POP-UP-FENSTERS
---------------------------------------------------------------------*)
Procedure OpenPopWin(Titel:string;Flags:Word);
Var i:Byte;
    n:integer;
    bh,bx,hy:integer;
    dx,dy:Integer;
    Grafikfehler:integer;
    zbvorher:Boolean;
    monobak:Boolean;       {Fr Regenbogenball}
    rbx0,rby0,rbr:integer; {Fr Regenbogenball}
    x:double;              {Fr Regenbogenball}
var Wartezeit:Word;
var ViewPort:ViewPortType;

    function flag(f:word):boolean;
    begin
      flag:=(f and Flags)=f;
    end;

BEGIN
  zbvorher:=Zeichnungbegonnen;

  bx:=lmin(PopBreite+2*TH+16,maxx);
  hy:=lmin(PopLine*(TH+1)+2*TH+16,maxy);

  {Ab Version 5.40: Fenster zentriert}
  if bx>maxx then popx:=0 else popx:=(maxx-bx) div 2;
  if hy>maxy then popy:=0 else popy:=(maxy-hy) div 2;

  if fontnr>0 then bh:=th*5 div 4 else bh:=th;
  getviewsettings(Viewport);
  setviewport(popx,popy,maxx,maxy,true);

  PopPufUsed:=False;
  PopDateiBenutzt:=False;

  if not flag(QuickFlag) then
  BEGIN {Hintergrund sichern}
    if getmaxcolor=255 then
      PopImgSize:=(longint(6)+bx+4)*(longint(6)+hy)+6
    else
    if getmaxcolor=15 then
      PopImgSize:=(longint(11)+bx)div 2*(longint(6)+hy)+6
    else
      PopImgSize:=imagesize(0,0,bx+5,hy+5);
    {Imagesize gibt nur WORD-Werte zurck. 640x480x256 oder 800x600x16
     sind aber grer als 64K}

    If (MaxAvail>PopImgSize) and (popimgsize<$10000) and not keypressed
    then
    begin
      getmem(PopPuffer,Popimgsize);
      graphresult; 	{Durch Dummy-Abfrage auf null setzen!}
      GetImage(0,0,bx+5,hy+5,poppuffer^);
      PopPufUsed:=(GraphResult=0);
      If Not PopPufUsed Then FREEMEM(PopPuffer,POPIMGSIZE);
    end else PopPufUsed:=FALSE;

    if not poppufused and not keypressed
    THEN
      Schreibe_QWG(0,bx+5,0,hy+5,programmpfad+exename+'.@@@',PopDateiBenutzt);
  END; {Hintergrund gesichert}

  setfillstyle(Solidfill,getmaxcolor);

  if (not keypressed)
  and (zeichnungbegonnen or hgreduziert)
  {Fensterhintergrund wei}
  then
  begin
    rectangle(0,0,0,0); {Hargrave-Patch!}
    bar(0,0,bx,hy);
  end;
  if not keypressed then
  begin {Rhmchen und Schatten}
  zeichnungbegonnen:=true;
  Setcolor(0);
  Setwritemode(copyput);
  SetLinestyle(SolidLn,0,thickwidth);
  rectangle(6,6,bx-6,hy-6);
  SetLinestyle(SolidLn,0,NormWidth);
  rectangle(2,2,bx-2,hy-2);
  If Titel<>'' then
  BEGIN
  bar((bx-textwidth(titel)) div 2-5,2,(bx+textwidth(titel)) div 2+5,7);
  graph.outtextxy((bx-textwidth(titel)) div 2,2,Titel);
  rectangle((bx-textwidth(titel)) div 2-4,0,(bx+textwidth(titel)) div 2+4,bh+3);
  END;
  If getmaxcolor=1
  then
    setfillstyle(CloseDotfill,1)
  else
    setfillstyle(Solidfill,darkgray);
  bar(5,hy+1,bx+5,hy+5);
  bar(bx+1,5,bx+5,hy+5);

  If flag(BehalteFlag) then
  BEGIN
  Setfillstyle(Solidfill,getmaxcolor);
  bar(bx-textwidth('TASTE')-13,hy-bh-5,bx-8,hy);
  graph.outtextxy(bx-textwidth('TASTE')-10,hy-bh-2,'TASTE');
  rectangle(bx-textwidth('TASTE')-12,hy-bh-4,bx-9,hy-1);
  END;
  graph.setrgbpalette(0,0,0,0);
  graph.setrgbpalette(getmaxcolor,63,63,63);
  graph.setrgbpalette(darkgray,21,21,21);
  end; {if not keypressed}

  for i:=1 to popline do
  begin
    if not keypressed then graph.outtextxy(8+th,8+(TH+1)*i,popzeile[i]^);
    FREEMEM(popzeile[i],Length(popzeile[i]^)+1);
  end;

  If Flag(LogoFlag) then
  {Regenbogenball}
  BEGIN          {....}
  rbr:=textwidth('    ');
  rbx0:=8+rbr+th;
  rby0:=8+9*th div 2;

  if getmaxcolor=255 then
  begin
    setlinestyle(solidln,0,ThickWidth);
    monobak:=monochrom;
    monochrom:=false;
    for n:=8 to 127 do
    if not keypressed then
    begin
      setcolor(2*n);
      outrgbpalette(2*n,round(127+127*sin((2*n+1.5)*pi/11.9))shr 2,
			round(127+127*sin((2*n+80+1.5)*pi/11.9))shr 2,
			round(127+127*sin((2*n+160+1.5)*pi/11.9))shr 2);
      line(rbx0,rby0,
	   rbx0+round(rbr*sin(2*n*pi/11.9)),
	   rby0+round(rbr*cos(2*n*pi/11.9)));
    end;
    monochrom:=monobak;
    setcolor(0);
  end
  else
  BEGIN
    SetWriteMode(XorPut);
    If MonoChrom Then SetColor(GetMaxColor)
    else setcolor(getmaxcolor xor blue);
    for n:=0 to 255 do if not keypressed then
    BEGIN
      line(rbx0,rby0,
	   rbx0+round(rbr*sin(n*pi/128)),
	   rby0+round(rbr*cos(n*pi/128)));
    END;
  END;
  SetColor(0);
  SetWriteMode(NormalPut);
  setlinestyle(solidln,0,NormWidth);
  END; {Regenbogenball}

  {*** Ende des Ausgabeteiles, jetzt auf Taste warten und Fenster lschen ***}
  WarteZeit:=50; {5 Sekunden}
  if Flag(WarteFlag) and not DiaShow Then
  BEGIN
    if mausda then Mouse_Motion(dx,dy);
    dx:=0;
    dy:=0;
    x:=0;
    repeat
      if Mausda then Mouse_Motion(dx,dy);
      if flag(LogoFlag) and (getmaxcolor=255) then
      begin
	for n:=8 to 127 do
	outrgbpalette(2*n,round(127+127*sin((2*n+1.5+x)*pi/11.9))shr 2,
			round(127+127*sin((2*n+80+1.5+x)*pi/11.9))shr 2,
			round(127+127*sin((2*n+160+1.5+x)*pi/11.9))shr 2);
	x:=x+0.25;
      end;
      Delay(100);
      If flag(FuenfSekundenFlag) Then dec(WarteZeit);
    until keypressed
       or (mausda and (rightmousebutton or leftmousebutton))
       or (dx<>0) or (dy<>0)
       or (WarteZeit=0);
  END;

  If Flag(BehalteFlag) then
  while keypressed do
  begin
    popwintaste:=readkey;
    if popwintaste=#0 then readkey;
    escapegedrueckt:=popwintaste=#27;
  end;

  if PopPufUsed then
   begin
     Graphresult;
     putimage(0,0,poppuffer^,Normalput);
     FREEMEM(PopPuffer,POPIMGSIZE);
     GrafikFehler:=Graphresult;
     if GrafikFehler=0 then Zeichnungbegonnen:=zbvorher;
   end
  ELSE
  if PopDateiBenutzt then
   begin
     LiesQWG(programmpfad+exename+'.@@@',0,0,FALSE,TRUE);
     GrafikFehler:=0;
   end;

  If (Not (PopPufUsed or PopDateibenutzt) or (GrafikFehler<>0))
     and not ineinanderzeichnen
     and not Flag(KeepFlag)
  then
  begin
     SetzeHintergrund;
     bar(0,0,bx+5,hy+5);
     zeichnungbegonnen:=zbvorher;
  end;
  If not Flag(KeepFlag)
  then
  begin
  setrgbpalette(0,RGBPalette[0,1],RGBPalette[0,2],RGBPalette[0,3]);
  setrgbpalette(DarkGray,RGBPalette[8,1],RGBPalette[8,2],RGBPalette[8,3]);
  setrgbpalette(GetMaxColor,
		RGBPalette[GetMaxColor,1],
		RGBPalette[GetMaxColor,2],
		RGBPalette[GetMaxColor,3]);
  end;
  With ViewPort do
  setviewport(x1,y1,x2,y2,clip);
  PopFensterOffen:=FALSE;
end;


(*---------------------------------------------------------------------
		     F1: ALLGEMEINES HILFEFENSTER
---------------------------------------------------------------------*)
PROCEDURE HelpWindow;
BEGIN
  if not popinit then exit;
  POPWRITE('"A" - "Z"     Zur ersten Datei mit diesem');
  POPWRITE('              Anfangsbuchstaben.');
  POPWRITE('Pfeil auf     Um eine Datei nach oben.');
  POPWRITE('Pfeil ab      Um eine Datei nach unten.');
  POPWRITE('Pos1          Zur obersten angezeigten Datei.');
  POPWRITE('Ende          Zur untersten angezeigten Datei.');
  POPWRITE('Bild auf      Eine Bildschirmseite nach oben.');
  POPWRITE('Bild ab       Eine Bildschirmseite nach unten.');
  POPWRITE('Strg-Bild auf Zur ersten Datei der Liste.');
  POPWRITE('Strg-Bild ab  Zur letzten Datei der Liste.');
  POPWRITE('');
  POPWRITE('Strg-A        Ausschnittfunktion (Grafikeditor).');
  POPWRITE('Strg-P        Paletteneditor (nur WPG).');
  POPWRITE('Shift-F7      Ausschnitt drucken.');
  OpenPopWin('Hilfe 1: Grundfunktionen',BehalteFlag);
  if escapegedrueckt or not popinit then exit;
  POPWRITE('+       Markiert Datei fr Gruppenaktionen.');
  POPWRITE('-       Entfernt Markierung.');
  POPWRITE('*       Kehrt die Markierung der aktuellen Datei um.');
  POPWRITE('Alt-F5  Markiert alle Dateien / lscht alle Markierungen.');
  POPWRITE('Einfg   Neues Unterverzeichnis anlegen.');
  POPWRITE('Entf    Lscht Datei(en) und leeres Unterverzeichnis.');
  POPWRITE('Strg-K  Kopiert Datei(en).');
  POPWRITE('Strg-V  Verschiebt Datei(en).');
  POPWRITE('Strg-U  Benennt Datei um.');
  POPWRITE('        Befindet sich die Cursorbox auf einer markierten');
  POPWRITE('        Datei, beziehen sich "Kopieren", "Lschen" und');
  POPWRITE('        "Verschieben" auf alle markierten Dateien.');
  POPWRITE('Strg-S  Sortiert Dateiliste.');
  POPWRITE('Strg-I  Infotext zur aktuellen Datei eingeben oder ndern.');
  if shellresident then
  popwrite('Strg-F1 Wechsele zu Shell, Clipboard');
  POPWRITE('Strg-F5 WordPerfect-Datei ver- oder entschlsseln.');
  POPWRITE('F2      Disk-Informationen.');
  POPWRITE('F3      Programm-Informationen.');
  POPWRITE('F5      Verzeichnis oder Suchmaske ndern.');
  POPWRITE('F7      Programm beenden.');
  OpenPopWin('Hilfe 2: Der Dateimanager',BehalteFlag);
  if escapegedrueckt or not popinit then exit;
  POPWRITE('Alt-1   1:1-Modus ohne Bildschirmanpassung an/aus.');
  POPWRITE('Alt-B   Breitdarstellung ohne Dateiliste an/aus.');
  popwrite('Alt-G   Graustufendarstellung an/aus');
  POPWRITE('Alt-I   Ineinanderzeichnen der Dateien an/aus.');
  POPWRITE('Alt-M   Monochromdarstellung an/aus.');
  POPWRITE('Alt-R   Reduzierte Hintergrundhelligkeit an/aus.');
  POPWRITE('Alt-W   WordPerfect-5.1-Druckraster verbieten/erlauben.');
  POPWRITE('Alt-Y   Floyd-Steinberg-Rasterung verbieten/erlauben.');
  POPWRITE('Alt-Z   Zoomen von Pixelgrafiken verbieten/erlauben.');
  POPWRITE('Strg-Z  Ausschnitt heranzoomen (nur WPG, DXF und HPGL).');
  POPWRITE('Strg-T  Aktuelle Datei als ASCII-Text darstellen.');
  POPWRITE('Strg-D  Aktuelle Datei als ASCII-Dump darstellen.');
  POPWRITE('Strg-F  Breitenfaktor fr Bildschirmanpassung eingeben.');
  POPWRITE('Strg-B  Breite fr Liniendarstellung setzen (nur WPG).');
  POPWRITE('Strg-F8 Schriftart whlen.');
  POPWRITE('F10     Testbild.');
  OpenPopWin('Hilfe 3: Wahl der Darstellung',BehalteFlag);
END;


(*---------------------------------------------------------------------
			 LISTE DER FONTS
---------------------------------------------------------------------*)
PROCEDURE Font_Hilfe(Flag:Integer);
BEGIN
  if not popinit then exit;
  popwrite(' 0: ROM      Standard-Font      (8 Punkte)');
  popwrite(' 1: TRIP.CHR Roman dreifach    (28 Punkte)');
  popwrite(' 2: LITT.CHR Kleinschrift       (8 Punkte)');
  popwrite(' 3: SANS.CHR Helvetica doppelt (28 Punkte)');
  popwrite(' 4: GOTH.CHR Englische Gotik   (28 Punkte)');
  popwrite(' 5: SCRI.CHR Schreibschrift    (33 Punkte)');
  popwrite(' 6: SIMP.CHR Helvetica einfach (28 Punkte)');
  popwrite(' 7: TSCR.CHR Roman kursiv      (28 Punkte)');
  popwrite(' 8: LCOM.CHR Roman doppelt     (28 Punkte)');
  popwrite(' 9: EURO.CHR Euro einfach      (52 Punkte)');
  popwrite('10: BOLD.CHR Helvetica fett    (47 Punkte)');
  OpenPopWin('Schriftarten',Flag);
END;

(*---------------------------------------------------------------------
			 VORGANG ABGEBROCHEN
---------------------------------------------------------------------*)
PROCEDURE AbbruchHinweis;
BEGIN
  if not popinit then exit;
  popwrite('');
  popwrite('Der Vorgang');
  popwrite('   wurde');
  popwrite('abgebrochen');
  popwrite('');
  OpenPopWin('Hinweis',BehalteFlag);
END;


(*---------------------------------------------------------------------
			    DATEI-INFO
---------------------------------------------------------------------*)
PROCEDURE File_Info(DIR:String;DN:Dateilistentyp;DateiAttr:Word;
		    Palpos:LongInt;Palfarben:Word);
var
    dx,dy,
    bx,hy:integer;
    i:Byte;
    zweifel:boolean;
    f:File;
    ps,fs:string;
    DateiZeit:DateTime;
    l:longint;
    header:WPCHeadertyp;
BEGIN
  IF NOT PopInit THEN EXIT;;

  if DN.F = Laufwerk
  Then
  Popwrite(DN.N)
  ELSE
  PopWrite(fexpand(DIR+DN.N));

  If DN.F=Datei then
  BEGIN
    filemode:=0; {Sonst haben R/O-Dateien 0 Byte}
    assign(f,DIR+DN.N);
    reset(f,1);
    getfattr(f,Dateiattr);
    getftime(f,l);
    unpacktime(l,DateiZeit);

    fillchar(header,16,#0);
    blockread(f,header,16);if ioresult<>0 then;
    with header do
    if wpcid=#255'WPC' then
    begin
    PopWrite('');
    case prtyp of
    1: ps:='WordPerfect';
    2: ps:='Shell';
    3: ps:='Datenbank';
    4: ps:='Calculator';
    5: ps:='Dateimanager';
    6: ps:='Kalender';
    7: ps:='Programmeditor';
    8: ps:='Makro-Editor';
    9: ps:='PlanPerfect';
    10:ps:='DataPerfect';
    11:ps:='WP-Mail';
    12:ps:='Druckerprogramm PTR';
    13:ps:='Scheduler';
    14:ps:='WP-Office';
    15:ps:='DrawPerfect';
    16:ps:='LetterPerfect';
    22:ps:='Tabellenkalkulation';
    25:ps:='Grafikeditor';
    else ps:='Programm '+ls(prtyp);
    end;
    case fltyp of
      1: FS:='Makro';
      2: FS:='Hilfstexte';
      3: FS:='Tastaturdefinition';
     10: FS:='Text';
     11: FS:='Wrterbuch';
     12: FS:='Thesaurus';
     13..15: FS:='Block';
     16: FS:='Druckertreiber';
     17: FS:='Konfigurationsdatei';
     19: FS:='Druckertreiberbibliothek';
     20: FS:='Anzeigehilfsmittel';
     21: FS:='Overlay';
     22: FS:='Grafik';
     23: FS:='Trennmodul';
     24: FS:='Daten des Trennmoduls';
     25: FS:='Makrohilfsmittel';
     26: FS:='Bildschirmfonts';
     27: FS:='Lexikon des Trennmoduls';
     29: FS:='Wortliste';
     30: FS:='Formelhilfsmittel';
     36: FS:='Bildschirmtreiber';
     41: FS:='Konfiguration des Installationsprogramms';
     42: FS:='Maustreiber';
     55,70: FS:='Grafikfont';
    else FS:='Dateityp '+ls(fltyp);
    end;
    PopWrite(PS+' - '+FS);
    if enkey<>0 then
    PopWrite('Verschlsselt (Code '+hexstr(enkey)+'h)');
    PopWrite('Version '+ls(maver)+'.'+ls(miver));
    end;
    if fexpand(DIR+DN.N)=LetzteWPGDatei then
    begin
    popwrite('');
    popwrite('Gre: '+ls(wpgbreite)+' x '+ls(wpghoehe)+' wpu ('+
		      +rs(2.54/1200*wpgbreite,0,2)+' x '+
		      +rs(2.54/1200*wpghoehe,0,2)+' cm)');
    If PalPos=0 then
    Popwrite('Datei hat keine Farbpalette!')
    else
    popwrite('Palette hat '+ls(Palfarben)+' Farben');
    end;
    PopWrite('');
    with dateiZeit do
    PopWrite('Erstellt: '+ls(day)+'.'+moname(month)+ls(year)+
		    +', '+ls0(hour,2)+':'+ls0(min,2)+' Uhr');
    PopWrite('');
    PopWrite('Dateigre: '+ls(filesize(f))+' Byte');
    close(f);
    filemode:=2;
  END {Normale Datei}
  ELSE
  IF DN.F = Verzeichnis
  THEN Popwrite('* Verzeichnis *')
  ELSE PopWrite('* Laufwerk *');
  if DN.F <> Laufwerk
  THEN
    if  (Dateiattr and Directory <>0)
      = (DN.F = Verzeichnis)
    then PopWrite('Attribute: '+attrstring(Dateiattr))
    else PopWrite('Attribute zweifelhaft.');
  OpenPopWin('Datei-Info',KeepFlag{+WarteFlag});
END;

(*--------------------------------------------------------------------
		 Gre/Zeit von ZWEI Dateien anzeigen
---------------------------------------------------------------------*)

PROCEDURE Double_File_Info(n1,n2:pathstr);
var
    bx,hy:integer;
    i:Byte;
    f:file;
    g1,g2,t1,t2:longint;
    dt1,dt2:datetime;
    warnung:Boolean;
BEGIN
  IF NOT PopInit THEN EXIT;;
  filemode:=0;
  assign(f,n1);
  reset(f,1);
  g1:=filesize(f);
  getftime(f,t1);
  unpacktime(t1,dt1);
  close(f);
  assign(f,n2);
  reset(f,1);
  g2:=filesize(f);
  getftime(f,t2);
  unpacktime(t2,dt2);
  close(f);
  filemode:=2;

  PopWrite('Quelldatei '+n1);
  PopWrite('    Gre: '+ls(g1)+' Byte');
  with dt1 do
  PopWrite(' Erstellt: '+ls(day)+'.'+moname(month)+ls(year)+
		    +', '+ls0(hour,2)+':'+ls0(min,2)+' Uhr');
  PopWrite('');
  PopWrite(' Zieldatei '+n2);
  PopWrite('    Gre: '+ls(g2)+' Byte');
  with dt2 do
  PopWrite(' Erstellt: '+ls(day)+'.'+moname(month)+ls(year)+
		    +', '+ls0(hour,2)+':'+ls0(min,2)+' Uhr');
  PopWrite('');
  if t1<t2 then
    begin
      warnung:=true;
      PopWrite('V O R S I C H T !   Zieldatei ist jnger!')
    end
  else
  if (t1=t2) and (g1=g2) then
    begin
      warnung:=false;
      PopWrite('Kein Unterschied in Alter und Gre.')
    end
  else
  if (g1=0) then
    begin
      warnung:=true;
      PopWrite('V O R S I C H T !   Quelldatei ist leer!')
    end
  else
    begin
      warnung:=false;
      PopWrite('Keine Bedenken.')
    end;
  OpenPopWin('Sicherheitsabfrage',KeepFlag{Quickflag+WarteFlag});
END;

(*---------------------------------------------------------------------
		     DISKETTEN- UND FESTPLATTEN-INFO
---------------------------------------------------------------------*)

PROCEDURE Disk_Info(DIR:Dirstr;markiertedateien:word;markierteKbyte:longint);
Var d:longint;
    i:integer;
    s:string;
    f:Text;
BEGIN
  IF NOT PopInit THEN EXIT;;
  PopWrite('Disketten: ');
  PopWrite('');
  For i:=1 to 2 do
  begin
    Writesl('Teste Diskette '+char(64+i)+': ...',true);
    d:=disksize(i);
    if d=-1 Then
      Popwrite(' '+char(64+i)+': Keine Diskette.')
    else
    begin
      PopWrite(' '+char(64+i)+': Kapazitt '+ls(d div 1024)+' KByte,');
      PopWrite('    '+ls(Diskfree(i) div 1024)+' KByte frei.');
      GetDir(i,s);
      Popwrite('    Angemeldetes Verzeichnis: '+s);
      assign(f,char(64+i)+':\TEST_150.$$$');
      Rewrite(f);
      if ioresult=150 Then
      PopWrite('    Die Diskette ist schreibgeschtzt.');
      close(f); if ioresult<>0 then;
      erase(f); if ioresult<>0 then;
    end;
    PopWrite('');
  end;
  Writesl('Teste Festplatten ...',true);
  i:=3;
  d:=disksize(i);
  if d>0 then PopWrite('Festplatten:')
  else popwrite('Festplatte C: nicht gefunden!');
  While d>0 do
  begin
    popWrite('');
    PopWrite(' '+char(64+i)+': Kapazitt '+ls((d+$80000) div $100000)+' MByte,');
    PopWrite('    '+ls(Diskfree(i) div 1024)+' KByte frei.');
    GetDir(i,s);
    Popwrite('    Angemeldetes Verzeichnis: '+s);
    inc(i);
    d:=disksize(i);
  end;
  PopWrite('');
  PopWrite('Aktuelles Verzeichnis: '+DIR);
  if markiertedateien>0 then
  begin
  popwrite(ls(markiertedateien)+' Datei(en) mit '+
	  ls(markierteKbyte)+' KByte Gesamtgre markiert.');
  end;
  Writesl('',True);
  OpenPopWin('Laufwerksbersicht',BehalteFlag);
END;

(*---------------------------------------------------------------------
		  INFO ZU SELEKTIERTEN DATEIEN
---------------------------------------------------------------------*)

PROCEDURE Gruppen_Info(markiertedateien:word;markierteKbyte:longint);
BEGIN
  IF NOT PopInit THEN EXIT;;
  Case MarkierteDateien of
  0: popwrite('Alle Markierungen gelscht.');
  1: BEGIN
       popwrite('Markiert ist eine Datei');
       popwrite('mit '+ls(markierteKbyte)+' KByte.');
     END;
  ELSE
     BEGIN
       popwrite('Markiert sind '+ls(markiertedateien)+' Dateien');
       popwrite('mit '+ls(markierteKbyte)+' KByte.');
     END;
  END;
  OpenPopwin('Aktionsgruppe',KeepFlag);
END;

(*---------------------------------------------------------------------
	      ALLGEMEINE PROGRAMM-INFOS, COPYRIGHT
---------------------------------------------------------------------*)

PROCEDURE Programm_Info(Version:String;grmode:integer);
var xa,ya:word;
var szeile,z:pathstr;
BEGIN
  IF NOT PopInit THEN EXIT;;
  popwrite(Programmname+' '+version+' von Martin Vogel');
  popwrite('');
  popwrite('Ausgefhrt als '+fexpand(paramstr(0)));
  if shellresident then
  popwrite('Shell Version '+Shellversion+' ist resident');
  popwrite('');
{$ifdef Testlauf}
  popwrite('VERSION NUR FR INTERNE ZWECKE!');
{$endif}
if not Lizenziert then
begin
  popwrite('Sharewareversion!');
  popwrite('Bitte registrieren Sie sich bei:');
  popwrite('');
  popwrite('       Computersoftware');
  popwrite('       Martin Vogel');
  popwrite('       Bodenborn 61');
  popwrite('       D-58452 Witten');
  popwrite('       Tel/Fax: 02302-31666');
end
else
begin
  PopWrite('Lizenznehmer:  '+Lizenznehmer);
end;
  popwrite('');
  szeile:=getdrivername;
  if szeile='' then szeile:=xdrivername;
  z:=getmodename(grmode);
  if z='' then z:=ls(grmode);
  popwrite('Grafiktreiber: '+szeile+' ('+z+')');
  getaspectratio(xa,ya);
  popwrite('Breitenfaktor: '+ls(Breitenfaktor)+':'+ls(xa));
  popwrite('Bildauflsung: '+ls(1+Getmaxx)+' x '+ls(1+Getmaxy)
	  +' x '+ls(1+getmaxcolor));
  xa:=min(11,fontnr);
  popwrite('Systemfont:    '+ls(fontnr)+' ('+FontName[xa]+'), '
	   +ls(TH)+' P.');
  popwrite('');
  popwrite('RAM: '+ls(memavail)+' Byte frei');
  Case OvrResult of
  0: popwrite('EMS: fr Overlay-Datei genutzt.');
  -5:popwrite('EMS: nicht vorhanden.');
  -4:popwrite('EMS: zu klein, um genutzt zu werden.');
  end;
  OpenPopWin('Programm-Info',BehalteFlag);
END;

(*---------------------------------------------------------------------
		   HILFE ZUM PALETTENEDITOR
---------------------------------------------------------------------*)

PROCEDURE Palettenhilfe(AusHauptMenue:Boolean);
BEGIN
  IF NOT PopInit THEN EXIT;;
  If ZuvieleFarben Then
  BEGIN
    popwrite('  Hm..., dieses Bild hat mehr');
    popwrite('Farben, als im aktuellen Grafik-');
    popwrite('modus darstellbar sind. Es wird');
    popwrite('deshalb nur mit Ersatzfarben.');
    popwrite('dargestellt. Sie knnen die');
    popwrite('Palette dieser Grafik daher');
    popwrite('nicht ndern.');
  END
  ELSE {Nicht zuviele Farben}
  BEGIN
    IF Monochrom then
    BEGIN
      popwrite('Cursor links/rechts: Farbe whlen');
      popwrite('Cursor auf/ab: Helligkeit ndern');
      popwrite('');
      popwrite(' K: Kontrast erhhen');
      popwrite(' k: Kontrast vermindern');
    END
    ELSE
    BEGIN
      popwrite('Mauszeiger oder Cursor links/rechts: Farbe whlen');
      popwrite('Maustasten oder Cursor auf/ab: Helligkeit ndern');
      popwrite('');
      popwrite('Kleinbuchstaben vermindern,');
      popwrite('Grobuchstaben verstrken die Komponenten:');
      popwrite(' R: Rot,      G: Grn,  B: Blau,  Y: Gelb,');
      popwrite(' M: Magenta,  C: Cyan,  W: Braun,');
      popwrite(' K: Kontrast, F: Farbintensitt');
    END;
    popwrite('');
    popwrite('Scroll-Lock bewirkt globale nderungen');
    popwrite('');
    popwrite('  Pos1: Palette zurcksetzen');
    popwrite('   Tab: 16- oder 256-Farben-Palette');
    popwrite('Strg-A: Ausschnitt speichern');
    popwrite('Strg-E: EGA-Standardfarben setzen');
    popwrite('Strg-G: Graustufen setzen (WP-Druckbild)');
    popwrite('Strg-N: Negativ erzeugen');
    popwrite('Strg-Z: Zwischenfarben erzeugen');
    popwrite('');
    popwrite('   Esc: nderungen stornieren');
    if AusHauptMenue then
    BEGIN
    popwrite('  LEER: Bild mit neuer Palette aufbauen');
    popwrite(' Enter: Neue Palette in Datei eintragen');
    popwrite('');
    popwrite('Strg-A: Bildausschnitt editieren und speichern')
    END
    else
    BEGIN
    popwrite('Enter oder');
    popwrite('Strg-A: Rckkehr zur Ausschnittfunktion');
    END;
  END; {Nicht Zuvielefarben}
  Openpopwin('Paletteneditor',WarteFlag);
END;

(*---------------------------------------------------------------------
	    HILFE, WENN PALETTENEDITOR NICHT AUFRUFBAR
---------------------------------------------------------------------*)

PROCEDURE NoPalHilfe;
BEGIN
  IF NOT PopInit THEN EXIT;;
  popwrite('Sie knnen die Palette einer');
  popwrite('bestehenden Grafik nur ndern,');
  popwrite('wenn diese im WPG-Format vor-');
  popwrite('liegt.');
  popwrite('');
  popwrite('Um die Farbpalette eines Bild-');
  popwrite('ausschnittes zu ndern, rufen');
  popwrite('Sie bitte zuerst mit [Strg-A]');
  popwrite('die Ausschnittfunktion und dann');
  popwrite('erst mit [Strg-P] den Paletten-');
  popwrite('editor auf.');
  Openpopwin('Paletteneditor',WarteFlag);
END;

(*---------------------------------------------------------------------
			HILFE ZUM TESTBILD
---------------------------------------------------------------------*)

PROCEDURE Testbildhilfe;
BEGIN
  IF NOT PopInit THEN EXIT;;
  popwrite('Das Testbild dient dem Abgleich von');
  popwrite('Programm und Monitor. Mit [Strg-F]');
  popwrite('knnen Sie den Faktor der Breiten-');
  popwrite('entzerrung so einstellen, da die');
  popwrite('Kreise rund dargestellt werden.');
  popwrite('');
  popwrite('Anzeige des Testbildes beenden: ENTER');
  OpenPopWin('Testbild',WarteFlag);
END;

(*---------------------------------------------------------------------
			HILFE ZUR ZOOMFUNKTION
---------------------------------------------------------------------*)

PROCEDURE Zoomhilfe;
BEGIN
  IF NOT PopInit THEN EXIT;;
  popwrite('Mit der Maus oder den Cursortasten knnen');
  popwrite('Sie das Zoomfenster auf dem Bildschirm ver-');
  popwrite('schieben. Wenn Sie die linke Maustaste ge-');
  popwrite('drckt halten, verndern Sie die Gre des');
  popwrite('Fensters.');
  popwrite('  Die maximale Vergrerung ist abhngig');
  popwrite('von der betrachteten Grafik und betrgt');
  popwrite('im Mittel rund 10000%');
  popwrite('');
  popwrite('Die Anzeige des gezoomten Bildes erfolgt');
  popwrite('nach Druck der rechten Maustaste oder [F7].');
  OpenPopWin('Zoomfunktion',BehalteFlag);
END;

(*---------------------------------------------------------------------
		  HILFE ZU NICHT ZOOMFHIGEN GRAFIKEN
---------------------------------------------------------------------*)

PROCEDURE NoZoomhilfe;
BEGIN
  IF NOT PopInit THEN EXIT;;
  popwrite('Die Zoomfunktion untersttzt');
  popwrite('die Grafikformate WPG, HPGL (PLT)');
  popwrite('und DXF.');
  popwrite('  Bei einfachen WPG-Bitmaps mu');
  popwrite('vor dem Aufruf der Zoom-Funktion');
  popwrite('mit [Alt-Z] der Zoom-Modus erlaubt');
  popwrite('werden. Der Eins-zu-eins-Modus darf');
  popwrite('nicht eingeschaltet sein.');
  popwrite('  Einfacher ausgedrckt: wenn das');
  popwrite('Bild mittig dargestellt wird, kann');
  popwrite('es gezoomt werden. Wird es in der');
  popwrite('linken oberen Ecke angezeigt, ist');
  popwrite('Zoomen nicht mglich.');
  OpenPopWin('Hinweis',BehalteFlag);
END;

(*---------------------------------------------------------------------
			HILFE ZUR ZOOMFUNKTION
---------------------------------------------------------------------*)

PROCEDURE Druckhilfe;
BEGIN
  IF NOT PopInit THEN EXIT;;
  popwrite('Mit der Maus oder den Cursortasten knnen Sie');
  popwrite('den zu druckenden Ausschnitt auf dem Bildschirm');
  popwrite('verschieben. Wenn Sie die linke Maustaste ge-');
  popwrite('drckt halten, verndern Sie die Gre des');
  popwrite('Ausschnitts.');
  popwrite('');
  popwrite('Der Druck des Ausschnitts erfolgt nach Bettigung');
  popwrite('der rechten Maustaste oder der Taste [F7].');
  popwrite('Mit [Esc] kann der Druck abgebrochen werden.');
  OpenPopWin('Druckfunktion',BehalteFlag);
END;

(*---------------------------------------------------------------------
      INFO BEIM VERSUCH, LAUFWERKE ODER VERZEICHNISSE ZU KOPIEREN
---------------------------------------------------------------------*)

PROCEDURE Copy_Info;
BEGIN
  IF NOT PopInit THEN EXIT;;

  PopWrite('In der aktuellen Version kann dieses Programm keine');
  PopWrite('Verzeichnisse und Disketten kopieren.');
  PopWrite('');
  PopWrite('Um ein komplettes Verzeichnis zu kopieren, wechseln Sie');
  PopWrite('bitte in das entsprechende Verzeichnis, markieren Sie');
  PopWrite('durch Druck auf [Alt-F5] alle Dateien und geben Sie dann');
  PopWrite('erneut [Strg-K] ein. Das Programm erfragt dann das Ziel-');
  PopWrite('verzeichnis fr die markierten Dateien. Dateien, die');
  PopWrite('nicht kopiert werden knnen, werden bersprungen und');
  PopWrite('bleiben markiert, bei kopierten Dateien werden die');
  PopWrite('Markierungen gelscht.');
  PopWrite('');
  PopWrite('Zum Kopieren von Disketten empfehlen wir Ulrich Feld-');
  PopWrite('mllers hervorragendes Programm QCOPY, das unter der');
  PopWrite('Katalognummer DS_0139 bei jedem Sharewarehndler');
  PopWrite('bestellt werden kann, der Mitglied der DS ist.');
  OpenPopWin('Hinweis',BehalteFlag);
END;

(*---------------------------------------------------------------------
		  HILFE ZUR AUSSCHNITTFUNKTION
---------------------------------------------------------------------*)

PROCEDURE Ausschnitthilfe(AusHauptMenue:Boolean);
BEGIN
  IF NOT PopInit THEN EXIT;;
  If MausDa Then
  begin
  popwrite('Editiertasten:');
  popwrite(' M: Malen und Sprayen');
  popwrite(' S: Stempeln');
  if not xterndriver then
  popwrite(' : Fllen, Farbfluten');
  popwrite(' T: Textzeile einpassen');
  popwrite(' Q: QWG-Datei einfgen');
  popwrite(' W: Weichzeichner');
  popwrite(' U: Umfrben');
  popwrite(' H: Heller');
  popwrite(' D: Dunkler');
  popwrite('');
  popwrite('Einstellungen:');
  popwrite(' F: Farbe whlen');
  popwrite(' L: Lineal definieren, umsetzen oder lschen');
  popwrite(' V: Vorgabe der Ausschnittgre');
  popwrite(' A: Anpassen der Ausschnittgre');
  popwrite('Strg-F8: Font fr Textausgaben setzen');
  popwrite('');
  if aushauptmenue
  then
  popwrite('Strg-P: Aufruf des Paletteneditors')
  else
  popwrite('Strg-P: Rckkehr zum Paletteneditor');
  popwrite('');
  popwrite('Die Editierfunktionen beziehen sich immer auf');
  popwrite('das gesamte Ausschnittfenster. Die Fenstergre');
  popwrite('sollte daher vor dem Aufruf der Funktion auf');
  popwrite('ein geeignetes Ma gesetzt werden.');
  end
  else
  begin
  popwrite('Die Bearbeitung der Grafiken ist nur mit einer');
  popwrite('Microsoft-kompatiblen Maus mglich. Wenn an');
  popwrite('diesem Rechner eine Maus angeschlossen ist, so');
  popwrite('wurde sie vom Programm nicht erkannt.');
  popwrite('Eventuell wurde der Maustreiber nicht geladen.');
  end;
  popwrite('');
  popwrite('Exportformate WPG, PCX, QWG, DXF, HPG, PLT, ICN:');
  popwrite(' F7: schreibt gewhlten Ausschnitt auf Disk');
  popwrite('');
  popwrite('Nur bei WPG-Export:');
  popwrite(' Strg-D: Drehen des Ausschnitts um 90');
  popwrite(' Strg-G: Graustufenkonvertierung der Palette');
  popwrite(' Strg-S: Sortierung der Palette nach Helligkeit');
  popwrite(' Strg-V: Verkleinerung auf 50%');
  popwrite(' Strg-Z: Zoomen auf 200% der Originalgre');
  OpenPopWin('Grafikexport',WarteFlag);
END;

(*---------------------------------------------------------------------
			TITELFENSTERCHEN
---------------------------------------------------------------------*)

PROCEDURE IntroFenster(version,lizenznehmer:string);
var bakx,baky:word;
    bakhg:Boolean;
BEGIN
  if not diashow then
BEGIN
  bakx:=maxx;maxx:=getmaxx;
  baky:=maxy;maxy:=getmaxy;
  bakhg:=hgreduziert;
  hgreduziert:=true;
  SetzeHinterGrund;
  bar(0,0,getmaxx,getmaxy);
  zeichnungbegonnen:=true;
  IF NOT PopInit THEN EXIT;;
	   {....,....-....,....-....,....-....,....-}
  popwrite('          '+ProgrammName+' V'+version);
  popwrite('          Copyright (c) 1994 by');
  popwrite('');
  popwrite('          Computersoftware');
  popwrite('          Martin Vogel');
  popwrite('          Bodenborn 61');
  popwrite('          D-58452 Witten');
  popwrite('');
If Not Lizenziert Then
  popwrite('Unregistrierte Sharewareversion')
ELSE
  popwrite('Lizenznehmer: '+lizenznehmer);

  popwrite('Alle Rechte vorbehalten.');
  popwrite('');
  popwrite('Bildauswahl mit Cursortasten,');
  popwrite('Hilfe mit [F1], Ende mit [F7].');
  popwrite('');
  popwrite('           Weiter mit [Enter]');
  OpenPopWin('',LogoFlag+WarteFlag+KeepFlag+FuenfSekundenFlag);
  if keypressed and (readkey=#27) then fehlerabbruch(Benutzerabbruch);
  maxx:=bakx;
  maxy:=baky;
  hgreduziert:=bakhg;
END; {Titelbild}
  SetzeHintergrund;
  bar(0,0,maxx,maxy)
END; {IntroFenster}

(*---------------------------------------------------------------------
		       HILFE ZU TEXTEINGABEN
---------------------------------------------------------------------*)
PROCEDURE Inputhilfe(Hilfstext:Integer);
var hs:string;
BEGIN
  if not popinit then exit;
  {Wenn schon ein Fenster vorhanden ist}
  hs:='';
  CASE Hilfstext of
  1:BEGIN hs:=' zum Infotext';
      popwrite('Der Infotext ist vollstndig editierbar.');
      popwrite('Mit den Cursortasten ['#27
				     +'] und ['#26
					     +'] bewegen ');
      popwrite('Sie die Einfgeposition nach links und rechts.');
      popwrite('');
      popwrite('Wenn Sie unmittelbar zu Beginn der Eingabe');
      popwrite('ein Zeichen eingeben, wird der ursprngliche');
      popwrite('Inhalt der Eingabezeile gelscht.');
      popwrite('');
      popwrite('[Enter] bernimmt die nderungen; mit [Esc]');
      popwrite('stornieren Sie die Eingabe und stellen den');
      popwrite('ursprnglichen Inhalt wieder her.');
      popwrite('');
      popwrite(programmname
		    +' speichert alle Infotexte in der Datei');
      popwrite(fexpand(programmpfad+exename+'.INF'));
    END;
  2:BEGIN hs:=' zum Breitenfaktor';
      popwrite('Der Breitenfaktor dient dazu, die Bildgeometrie');
      popwrite('des Monitors zu korrigieren. Wenn Ihr Monitor');
      popwrite('die Grafiken zu breit anzeigt, sollten Sie einen');
      popwrite('kleineren Wert eingeben. Bei zu schmalen Bildern');
      popwrite('entsprechend einen greren Wert. Standardvor-');
      popwrite('gabe ist der Breitenfaktor 10000.');
      popwrite('');
      popwrite('Eine Breitenkorrektur findet jedoch nur bei Vek-');
      popwrite('torgrafiken und WPG-Rastergrafiken statt.');
      popwrite('Im 1:1-Modus wird ein eingegebener Breitenfaktor');
      popwrite('ignoriert');
    END;
  3:BEGIN hs:=' zur Linienbreite';
      popwrite('Wenn Sie "0" eingeben, werden alle Linien');
      popwrite('einer WordPerfect-Grafik in Originalbreite');
      popwrite('wiedergegeben. Ein anderer Wert setzt alle');
      popwrite('Linien auf eine Breite. Die Einheit der');
      popwrite('Linienbreite ist WPU, 1/1200".');
      popwrite('');
      popwrite('Da WordPerfect-Grafiken unterschiedlicher');
      popwrite('Gre immer formatfllend auf dem Monitor');
      popwrite('dargestellt werden, kann die Linienbreite');
      popwrite('von Bild zu Bild unterschiedlich erscheinen.');
      popwrite('');
      popwrite('Werte von 10 bis 100 liefern in aller Regel');
      popwrite('recht ansprechende Ergebnisse.');
    END;
  4:BEGIN hs:=' zu den Schriftarten';
      popwrite('Wenn die Standardschriftart des Programms');
      popwrite('aufgrund der Monitorauflsung schwer zu le-');
      popwrite('sen ist, sollten Sie eine andere Schriftart');
      popwrite('whlen. Fr die Auflsung 320x200 bietet');
      popwrite('sich die Schriftart LITT (Nr. 2) in einer');
      popwrite('Hhe von 8 Punkten an. Ab 1024x768 Punkten');
      popwrite('sollten Sie entweder den ROM-Font in dop-');
      popwrite('pelter Hhe (16 Punkte) oder eine der grs-');
      popwrite('seren Vektorschriftarten benutzen.');
      popwrite('');
      popwrite('Es kann passieren, da Sie die Schriftart');
      popwrite('so gro whlen, da die Meldungen des Pro-');
      popwrite('gramms nicht mehr auf den Bildschirm pas-');
      popwrite('sen. Verlassen Sie das Programm dann mit');
      popwrite('[F7] und [J] oder stellen Sie die Schrift-');
      popwrite('art mit [Strg-C] [0] [8] wieder auf die');
      popwrite('Standardwerte zurck.');
    END;
  5:BEGIN hs:=' zum Ausschnittfenster';
      popwrite('Sie knnen die Gre des Ausschnitt-');
      popwrite('fensters frei whlen. Geben Sie dazu');
      popwrite('einfach die Breite und Hhe in Bild-');
      popwrite('punkten an.');
      popwrite('');
      popwrite('Die linke obere Ecke des Ausschnitt-');
      popwrite('fensters bleibt fest und die rechte');
      popwrite('untere Ecke wird gem Ihren Angaben');
      popwrite('versetzt.');
    END;
  6:BEGIN hs:=' zur Kennwortverschlsselung';
      popwrite('Sie knnen WordPerfect-Texte und -Grafiken');
      popwrite('ber ein Kennwort verschlsseln und diese');
      popwrite('Verschlsselung wieder aufheben.');
      popwrite('');
      popwrite('Damit die Verschlsselung vertrglich zu');
      popwrite('WordPerfect ist, sollten Sie im Kennwort');
      popwrite('nur die Buchstaben von "A" bis "Z" (ohne');
      popwrite('Umlaute) und die Ziffern "0" bis "9" ver-' );
      popwrite('wenden.');
      popwrite('');
      popwrite('Merken Sie sich Ihre Kennwrter gut und');
      popwrite('machen Sie vor der Verschlsselung Sicher-');
      popwrite('heitskopien Ihrer Dateien! Wenn Sie Ihr');
      popwrite('Kennwort vergessen, ist der Inhalt der Da-');
      popwrite('tei unrettbar verloren.');
    END;
  7:BEGIN hs:=' zur Suchmaske';
      popwrite('Geben Sie bitte ein gltiges Ver-');
      popwrite('zeichnis an, z.B. "A:\" oder');
      popwrite('"C:\WP51\GRAFIK".');
      popwrite('');
      popwrite('Zustzlich knnen Sie eine Datei-');
      popwrite('suchmaske anfgen: "A:\*M*.WPG"');
      popwrite('wechselt auf Laufwerk A: und zeigt');
      popwrite('alle WPG-Dateien an, die ein "M"');
      popwrite('im Dateinamen tragen.');
    END;
  8:BEGIN hs:=' zum QWG-Import';
      popwrite('Sie knnen hier den Namen einer');
      popwrite('QWG-Datei angeben, die Sie zuvor');
      popwrite('abgespeichert haben.');
      popwrite('');
      popwrite('Die QWG-Datei mu im selben Gra-');
      popwrite('fikmodus enstanden sein, wie er');
      popwrite('jetzt eingestellt ist ('+ls(getmaxcolor+1)+
					 ' Far-');
      popwrite('ben).');
    END;
  9:BEGIN hs:=' zum Ausschnittnamen';
      popwrite('Bevor Sie einen Bildausschnitt bearbeiten');
      popwrite('knnen, mssen Sie ihm einen gltigen Datei-');
      popwrite('namen zuweisen.');
      popwrite('');
      popwrite('Den Dateityp des Bildausschnitts bestimmen');
      popwrite('Sie mit der Dateinamenerweiterung:');
      popwrite('');
      popwrite('*.DXF: AutoCAD Zeichnungsaustauschformat');
      popwrite('*.HPG und');
      popwrite('*.PLT: HPGL-Plotdatei');
      popwrite('*.ICO und');
      popwrite('*.ICN: Windows-Sinnbild (Icon)');
      popwrite('*.PCX: ZSoft Paintbrush Format');
      popwrite('*.QWG: Quick Window Graphics Format');
      popwrite('*.WPG und');
      popwrite('alle anderen: WordPerfect Grafikformat');
      popwrite('');
      popwrite('QWG- und PCX-Dateien knnen nur in dem Grafik-');
      popwrite('modus wiedergeben werden, in dem sie erzeugt');
      popwrite('werden. (Ausnahme: monochrome PCX-Grafiken)');
      popwrite('');
      popwrite('DXF-Dateien werden  auer im Monochrom-Modus');
      popwrite(' als 3D-Masche geschrieben und bentigen dann');
      popwrite('zum Weiterverarbeiten AutoCAD 10 oder neuer.');
    END;
  10:BEGIN hs:=' zu den Zwischentnen';
      popwrite('Sie knnen die Palettenwerte zwischen');
      popwrite('zwei Farben flieend ineinander ber-');
      popwrite('gehen lassen: Wenn beispielsweise Farbe');
      popwrite('"0" schwarz ist, Farbe "15" wei und');
      popwrite('Farbe "6" ein schwaches braun, so knnen');
      popwrite('Sie die Farbstimmung einer alten Foto-');
      popwrite('grafie erzeugen, wenn Sie die Zwischen-');
      popwrite('farben von "0" bis "6" und von "6" bis');
      popwrite('"15" vom Programm erzeugen lassen.');
    END;
  11:BEGIN hs:=' zum Umbenennen';
      popwrite('Geben Sie bitte den neuen Namen');
      popwrite('fr die gewhlte Datei an. Der');
      popwrite('Name darf noch nicht vergeben');
      popwrite('sein. Die Benutzung der Joker-');
      popwrite('zeichen "*" und "?" ist erlaubt.');
      popwrite('');
      popwrite('Beispiel:');
      popwrite('');
      popwrite('Alter Name:   BONALISE.WPG');
      popwrite('Neuer Name:   MONALISA.WPG');
      popwrite('Ihre Eingabe: M*A.*');
    END;
  12,14:BEGIN hs:=' zum Kopieren';
      popwrite('Bitte geben Sie ein gltiges Verzeichnis an,');
      popwrite('in welches die Datei oder die markierten Da-');
      popwrite('teien kopiert werden sollen.');
      popwrite('');
      popwrite('Wenn nur eine Datei kopiert wird, kann das');
      popwrite('Kopierziel auch ein Dateiname sein.');
      popwrite('');
      popwrite('Falls das Programm entdeckt, da eine Ziel-');
      popwrite('datei schon existiert, erfolgt eine Sicher-');
      popwrite('heitsabfrage. Wenn Sie bei einer Gruppenaktion');
      popwrite('hier [Esc] drcken, werden keine weiteren Da-');
      popwrite('teien kopiert.');
      popwrite('');
      popwrite('Die Markierung jeder Datei wird bei einer');
      popwrite('Gruppenkopie gelscht, auch wenn eine evtl.');
      popwrite('vorhandene Zieldatei nicht berschrieben');
      popwrite('wird. Wenn die Datei jedoch aufgrund eines');
      popwrite('Fehlers (z.B. Diskette voll) nicht kopiert');
      popwrite('werden konnte, so bleibt die Markierung');
      popwrite('erhalten und die Gruppenaktion wird mit der');
      popwrite('nchsten Datei fortgesetzt.');
    END;
  13,15:BEGIN hs:=' zum Verschieben';
      popwrite('Bitte geben Sie ein gltiges Verzeichnis an,');
      popwrite('in welches die Datei oder die markierten Da-');
      popwrite('teien verschoben werden sollen.');
      popwrite('');
      popwrite('Wenn nur eine Datei verschoben wird, kann das');
      popwrite('Verschiebungsziel auch ein Dateiname sein.');
      popwrite('');
      popwrite('Falls das Programm entdeckt, da eine Ziel-');
      popwrite('datei schon existiert, erfolgt eine Sicher-');
      popwrite('heitsabfrage. Wenn Sie bei einer Gruppenaktion');
      popwrite('hier [Esc] drcken, werden keine weiteren Da-');
      popwrite('teien verschoben.');
      popwrite('');
      popwrite('Die Markierung jeder Datei wird bei einer');
      popwrite('Verschiebung gelscht, auch wenn eine evtl.');
      popwrite('vorhandene Zieldatei nicht berschrieben');
      popwrite('wird. Wenn die Datei jedoch aufgrund eines');
      popwrite('Fehlers (z.B. Diskette voll) nicht verschoben');
      popwrite('werden konnte, so bleibt die Markierung');
      popwrite('erhalten und die Gruppenaktion wird mit der');
      popwrite('nchsten Datei fortgesetzt.');
    END;
  16:BEGIN hs:=' zum Textfenster';
      popwrite('Sie knnen hier einen beliebigen Text eingeben,');
      popwrite('welcher bndig in das definierte Fenster eingepat');
      popwrite('wird. Vor dem Aufruf der Textfunktion knnen Sie');
      popwrite('mit [C] einen der neun CHR-Vektorfonts und mit [F]');
      popwrite('eine beliebige Textfarbe whlen. Die Funktion wirkt');
      popwrite('als Pinsel: Fettschrift erzielen Sie, indem Sie die');
      popwrite('Maus etwas bewegen, whrend Sie einen Mausknopf');
      popwrite('niedergedrckt halten.');
      popwrite('');
      popwrite('Wenn Sie anstelle einer Textzeile den Namen einer');
      popwrite('DOS-Textdatei angeben, pat das Programm den Inhalt');
      popwrite('der Datei bndig in das aktive Ausschnittfenster');
      popwrite('ein.');
    END;
  17:BEGIN hs:=' zur Druckausgabe';
      popwrite('Whlen Sie bitte Druckertyp und Auflsung,');
      popwrite('indem Sie die beiden Kennziffern eingeben.');
      popwrite('');
      popwrite('Druckertyp:');
      popwrite(' 1 = HP LaserJet und kompatible');
      popwrite(' 2 = HP DeskJet, Olivetti JP 350');
      popwrite(' 3 = Standard-9-Nadel-Drucker');
      popwrite(' 4 = Standard-24-Nadel-Drucker');
      popwrite(' 5 = EPSON LX-800');
      popwrite('');
      popwrite('Auflsung:');
      popwrite(' 1...4 = niedrigste...hchste Auflsung');
      popwrite(' 0 = Standardauflsung');
      popwrite('');
      popwrite('Beispiel: 2,4 fr HP DeskJet mit 300 DPI');
    END;
  18:BEGIN hs:=' zum Anlegen von Verzeichnissen';
      popwrite('Geben Sie bitte den Namen eines Unterverzeichnisses');
      popwrite('an, das im aktuellen Verzeichnis angelegt werden');
      popwrite('soll. Der Name darf maximal acht Zeichen lang sein');
      popwrite('und darf keines der folgenden Zeichen enthalten:');
      popwrite('');
      popwrite('  <  >  \  |  .  ,  +  *  ?');
      popwrite('');
      popwrite('Verzeichnisnamen, die Leerzeichen enthalten, sind');
      popwrite('auf DOS-Ebene nicht mehr zugnglich.');
    END;
  ELSE {Sollte eigentlich schon alles abgedeckt sein}
    BEGIN hs:=' zur Eingabezeile';
      popwrite('Die Eingabezeile ist vollstndig editierbar.');
      popwrite('Mit den Cursortasten ['#27
				     +'] und ['#26
					     +'] bewegen ');
      popwrite('Sie die Einfgeposition nach links und rechts.');
      popwrite('');
      popwrite('Wenn Sie unmittelbar zu Beginn der Eingabe');
      popwrite('ein Zeichen eingeben, wird der ursprngliche');
      popwrite('Inhalt der Eingabezeile gelscht.');
      popwrite('');
      popwrite('[Enter] bernimmt die nderungen; mit [Esc]');
      popwrite('stornieren Sie die Eingabe und stellen den');
      popwrite('ursprnglichen Inhalt wieder her.');
    END;
END; {CASE}
  OpenPopWin('Hilfe'+hs,BehalteFlag);
END;

Function ntezeileaus(name:pathstr;n:integer):string;
var i:integer;
var t:text;
var s:string;
begin
  assign(t,name);
  reset(t);
  for i:=1 to n do readln(t,s);
  if ioresult=0
  then ntezeileaus:=s
  else ntezeileaus:='';
  close(t);
  if ioresult<>0 then;
end;

(*---------------------------------------------------------------------
                  Fehlermeldung der Unit SCRIPT
---------------------------------------------------------------------*)
PROCEDURE SCRIPTERROR(ERRNR,ERRLN:INTEGER);
BEGIN
  maxy:=statusline_on;
  if not popinit then exit;
  {Wenn schon ein Fenster vorhanden ist}
  popwrite('In Zeile '+ls(errln)+' trat ein Fehler auf:');
  popwrite('');
  popwrite('"'+lrstrip(ntezeileaus(scriptname,errln))+'"');
  popwrite('');

  CASE ERRNR OF
  seNoScriptFile:
    begin
    popwrite('Die Scriptdatei konnte nicht gefunden werden.');
    end;
  seLabelNotFound:
    begin
    popwrite('Das hinter GOTO oder GOSUB angegebene');
    popwrite('Sprungziel konnte nicht gefunden werden.');
    popwrite('');
    popwrite('Tippfehler?');
    end;
  seCallStackOverflow:
    begin
    popwrite('Das war das 33. GOSUB ohne RETURN.');
    popwrite('');
    popwrite('Beenden Sie ein irgendein');
    popwrite('Unterprogramm mit GOTO?');
    end;
  seReturnWithoutGosub:
    begin
    popwrite('Zu diesem RETURN gibt es kein GOSUB.');
    popwrite('');
    popwrite('Haben Sie ein Unterprogramm mit GOTO');
    popwrite('aufgerufen?');
    end;
  seUnknownCommand:
    begin
    popwrite('Diesen Befehl habe ich nicht verstanden.');
    popwrite('');
    popwrite('Bitte nehmen Sie Rcksicht auf meinen');
    popwrite('schmalen Wortschatz:');
    popwrite('BEEP ELSE EXIT GOSUB GOTO RETURN');
    end;
  ELSE
    begin
    popwrite('Unbekannter Fehler.');
    popwrite('');
    popwrite('Oh, h, h... ich meine... ach, was wei ich!');
    end;
  END; {CASE}
  popwrite('');
  popwrite('Abbruch der Scriptverarbeitung mit [Esc]');
  popwrite('oder weiter auf eigene Gefahr mit [Enter]:');
  OpenPopWin('Fehler in der Scriptdatei!',WarteFlag);
  if readkey=#27 then scriptaktiv:=FALSE;
  While Keypressed do if ReadKey=#0 then readkey;
END;

(*---------------------------------------------------------------------
		    INFO ZU PCX-DATEIEN AUSGEBEN
---------------------------------------------------------------------*)

procedure PCXINFO(DN:Dateilistentyp;DateiZeit:DateTime);
type pcxheadertyp=Record
       id:byte; 	{10=PCX} {205=SCR}
       version:byte;    {0=2.5, 2=2.8 m.Pal, 3=2.8 o.Pal, 5=3.0}
       rle:byte;        {1=RLE-Kompression}
       bipp:Byte;	{Bits pro Pixel}
       xmin,
       ymin,
       xmax,
       ymax:Word;	{Fensterkoordinaten}
       xdpi,
       ydpi:Word;	{Auflsung}
       pal:array[0..15,1..3] of Byte;
       reserviert:Byte;
       Farbebenen:Byte;	{1 oder 4}
       BpZ:Word;	{Gerade Anzahl Bytes pro Bildzeile}
       PalTyp:Word;	{1=Mono/Col, 2=Grau}
       Muell:Array[1..58] of Byte;
     end;
var s:string;
var i:integer;
var header:pcxheadertyp;
begin
  falschertyp:=TRUE;
  seek(wpg,0);
  blockread(wpg,header,128);
  if ioresult<>0 then exit;
  with header do begin
  if (id<>10) and (id<>205) then exit;
  falschertyp:=false;
  popinit;
  popwrite(fexpand(DN.N));
  popwrite('');
  if id=205 then
  popwrite('Screen Capture File Format')
  ELSE
  popwrite('ZSoft Paintbrush File Format');
  case version of
  0: s:='2.5';
  2: s:='2.8 mit Palette';
  3: s:='2.8 ohne Palette';
  5: s:='3.0';
  else s:='unbekannt (Kennzahl ist '+ls(version)+')';
  end;
  Popwrite('Version '+s);
  if rle=1
  then
  begin
    popwrite('RLE-Kodierung');
    popwrite('Kompressionsfaktor '+
    rs(0.125*bipp*Farbebenen*(1.0+xmax-xmin)*(1.0+ymax-ymin)/(filesize(wpg)-128),0,3));
  end
  else popwrite('Keine Komprimierung');
  if PalTyp=2 then s:=' Graustufen'
  else s:=' Farben';
  Popwrite(ls(1+xmax-xmin)+' x '+ls(1+ymax-ymin)+' Punkte in '+
	   ls(1 shl(bipp) shl(Farbebenen-1))+s);
  popwrite('');
  with dateiZeit do
  PopWrite('Erstellt: '+ls(day)+'.'+moname(month)+ls(year)+
		  +', '+ls0(hour,2)+':'+ls0(min,2)+' Uhr');
  PopWrite('');
  PopWrite('Dateigre: '+ls(filesize(wpg))+' Byte');

  openpopwin('PCX-Informationen',keepflag+warteflag);
  end; {with header}
end;

(*---------------------------------------------------------------------
		    INFO ZU BMP-DATEIEN AUSGEBEN
---------------------------------------------------------------------*)

procedure BMPINFO(DN:Dateilistentyp;DateiZeit:DateTime);
type bmpfheadertyp=Record
       id:word; 	{'BM', 19778}
       bfSize:Longint;
       reserviert1:word;
       reserviert2:word;
       bfOffs:Longint;  {Offset Datenbereich}
     end;
type bmpiheadertyp=Record
       biSize:Longint;
       biWidth:LongInt;
       biHeight:LongInt;
       Farbebenen:Word;
       Bipp:Word;
       biCompr:LongInt;
       biSizeIm:LongInt;
       bixpixperm:LongInt;
       biypixperm:LongInt;
       biColUsed:LongInt;
       biColImpt:LongInt;
     end;


var s:string;
var i:integer;
var bmpfheader:bmpfheadertyp;
var bmpiheader:bmpiheadertyp;
var farbenzahl:longint;
begin
  falschertyp:=TRUE;
  seek(wpg,0);
  blockread(wpg,bmpfheader,sizeof(bmpfheader));
  if ioresult<>0 then exit;
  if (bmpfheader.id<>19778) then exit;
  falschertyp:=false;

  blockread(wpg,bmpiheader,sizeof(bmpiheader));
  falschertyp:=false;
  popinit;
  popwrite(fexpand(DN.N));
  popwrite('');
  popwrite('Windows Bitmap File Format');
  case bmpiheader.bipp of
    1: Farbenzahl:=2;
    4: Farbenzahl:=16;
    8: Farbenzahl:=256;
   24: Farbenzahl:=16777216;
   else farbenzahl:=0;
  end;
  with bmpiheader do
  begin
  popwrite(ls(biwidth)+' x '+ls(biheight)+' Punkte in '+ls(farbenzahl)+
           ' Farben');
  popwrite('Palette hat '+ls(bmpfheader.bfoffs
                             -sizeof(bmpfheader)
                             -sizeof(bmpiheader))+' Byte');
  case bicompr of
    0: popwrite('Keine Komprimierung der Bilddaten');
    1: popwrite('RLE-Komprimierung fr 256-farbige Bitmaps');
    2: popwrite('RLE-Komprimierung fr 16-farbige Bitmaps');
  else popwrite('Komprimierung unbekannt. (Typ '+ls(bicompr)+')');
  end;
  end;
  PopWrite('');
  with dateiZeit do
  PopWrite('Erstellt: '+ls(day)+'.'+moname(month)+ls(year)+
		  +', '+ls0(hour,2)+':'+ls0(min,2)+' Uhr');
  PopWrite('Dateigre: '+ls(filesize(wpg))+' Byte');

  openpopwin('BMP-Informationen',keepflag+warteflag);
end;

PROCEDURE DummyFenster;
begin
  if not popinit then exit;
  openpopwin('',keepflag);
end;

BEGIN END.
