{$A+,B-,D+,E+,F+,I-,L+,N+,O+,R-,V-,X+}
unit QWGIO;

interface uses graph,dos,crt,viewprim,viewsl;
type QWGheadertyp=Record
       id:word; 	{'MV'=QWG}
       Maxcolor:Word;
       dx:Word;
       dy:word;
       bpz:word;
       reserviert:array[1..6]of Byte;
     end;

CONST QWGPfad:Pathstr='';{Pfad der zuletzt gelesenen QWG-Datei}
procedure LiesQWG(QWGName:PathStr;
		  Xoffset,Yoffset:Integer;
		  ZeigAufloesung:Boolean;
		  Loeschen:Boolean);

implementation

procedure liesQWG(qwgname:pathstr;
		  XOffset,Yoffset:integer;
		  ZeigAufloesung:Boolean;
		  Loeschen:Boolean);
Label Fehler;
var qwg:File;
var i:integer;
var dx,dy:integer;
var bpz:integer; {Byte pro Zeile}
var zeile:bytefeldtyp;
var header:qwgheadertyp;

begin {liesQWG}
  assign(qwg,qwgname);
  reset(qwg,1);if ioresult<>0 then;
  blockread(qwg,header,16);if ioresult<>0 then goto fehler;
  if header.id<>22093 then goto fehler;
  if getmaxcolor<>header.MaxColor then
  begin
    Writesl(' wurde nicht in diesem Grafikmodus erstellt.',false);
    EXIT;
  end;
  falschertyp:=false;
  If ZeigAufloesung then
  writesl(', '+ls(header.dx+1)+' x '+ls(header.dy+1)+' Punkte',false);
  Move(header.dx,zeile,2);
  Zeile[2]:=0;
  Zeile[3]:=0;
  for i:=0 to lmin(maxy,header.dy) do
  if not ((keypressed and not loeschen) or (ioresult<>0)) then
  begin
    blockread(qwg,Zeile[4],header.bpz);
    putimage(Xoffset,i+Yoffset,Zeile,copyput);
  end; {schleife ber zeilen}
  ZeichnungBegonnen:=not ineinanderzeichnen;
  close(qwg); if ioresult<>0 then;
  If Loeschen Then Erase(qwg); if ioresult<>0 then;
Exit;
Fehler:
  writesl('Ist keine darstellbare QWG-Datei,',true);
  Falschertyp:=True;
  close(qwg); if ioresult<>0 then;
end; {LiesQWG}

begin
end.

