{$A+,B-,D+,E+,F+,I-,L+,N+,O+,R-}
{G und S ber IDE schalten}
{$V-,X+}

UNIT TXTVIEW;
{Der Teil von VIEW, der fr die Anzeige von ASCII-Dateien zustndig ist.}
INTERFACE
USES
  DOS,
  CRT,
  GRAPH,
  GENERAL,
  VGABIOS,
  VIEWPRIM,
  VIEWSL,
  DREHFONT;

{$IFOPT N+}
TYPE REAL=DOUBLE;
{$ENDIF}

FUNCTION ISASCII(txtname:pathstr):boolean;
PROCEDURE ZEIGTXT(txtname:pathstr);
PROCEDURE ASCIIDUMP(txtname:pathstr);

IMPLEMENTATION
FUNCTION ISASCII(txtname:pathstr):boolean;
VAR F:FILE;
VAR C:CHAR;
VAR B:Array[1..4096] of Byte;
VAR gelesen:integer;
VAR i:integer;
BEGIN
  if ioresult<>0 then;
  assign(f,txtname);
  filemode:=0;
  RESET(F,1);
  filemode:=2;
  blockread(f,b,sizeof(b),gelesen);
  isascii:=true;
  for i:=1 to gelesen-1 do
    if (b[i]=26)    {EOF hat im Text nichts verloren}
    or (b[i]=0)     {NUL kann nicht eingegeben werden}
    or (b[i]=255)   {sollte nie vorkommen}
    or (b[i]=7)     {BEL sollte auch nie vorkommen}
  then isascii:=false;
  close(f);
END;

PROCEDURE ZEIGTXT(txtname:pathstr);
VAR TXT	  :TEXT;
VAR S     :String;
VAR Zeile :Integer;
VAR Fehler:Boolean;
VAR test_a,test_b,test_c,test_d:Integer;
VAR Zeilenhoehe:Integer;
BEGIN
  setviewport(0,0,maxx,maxy,TRUE);
  setfillstyle(userfill,HGFarbe);
  setfillPattern(HGMuster,HGfarbe);
  setcolor(0);
  if zeichnungbegonnen
  and not ineinanderzeichnen
  then bar(0,0,maxx,maxy);
  Zeilenhoehe:=maxy div 25;
  Assign(txt,txtname);
  filemode:=0;
  reset(txt);
  filemode:=2;
  zeile:=0;
  Fehler:=false;
  SettextStyle(2,horizdir,4);
  {Jetzt folgt eine programmiertechnische Kapriole:
   Die iterative Textgrenermittlung, weil die Skalierung
   bei Turbo Pascal manchmal derben Mist produziert.}
  test_a:=1;
  test_b:=1;
  test_c:=1;
  test_d:=1;
  repeat
    setusercharsize(test_a,test_b,test_c,test_d);
    if textheight('A')<maxy div 30 then inc(test_c) else inc(test_d);
    if maxx div 10>textwidth('Standard') then inc(test_a) else inc(test_b);
  until (maxx div 10=textwidth('Standard'))
    and (textheight('A')=maxy div 30)
    or (test_a=255)
    or (test_b=255)
    or (test_c=255)
    or (test_d=255);
  repeat
    readln(txt,s);
    fehler:=ioresult<>0;
    if not fehler then outtextxy(0,zeile*Zeilenhoehe,s);
    inc(zeile);
  until (Zeile=25) or eof(txt) or fehler or keypressed;
  close(txt);
  zeichnungbegonnen:=true;
  SETVIEWPORT(0,0,getmaxx,getmaxy,false);
  {Font zurcksetzen}
  IF fontnr=0 THEN
    SetTextstyle(0,0,Charsize div 8)
  ELSE
  BEGIN
    SetTextStyle(Fontnr,0,4);
    SetUserCharSize(Charsize,TextHeight('A'),Charsize,TextHeight('A'));
  END;
  repeat until keypressed;
END;

PROCEDURE ASCIIDUMP(txtname:pathstr);
VAR TXT	  :FILE;
VAR S     :String;
VAR Zeile :Integer;
VAR Fehler:Boolean;
VAR test_a,test_b,test_c,test_d:Integer;
VAR Zeilenhoehe:Integer;
VAR pp:integer;
VAR gelesen:Integer;
VAR Puffer:ARRAY[1..4096] of CHAR;

BEGIN
  setviewport(0,0,maxx,maxy,TRUE);
  setfillstyle(userfill,HGFarbe);
  setfillPattern(HGMuster,HGfarbe);
  setcolor(0);
  if zeichnungbegonnen
  and not ineinanderzeichnen
  then bar(0,0,maxx,maxy);
  Zeilenhoehe:=maxy div 25;
  Assign(txt,txtname);
  filemode:=0;
  reset(txt,1);
  filemode:=2;
  zeile:=0;
  Fehler:=false;
  SettextStyle(2,horizdir,4);
  {Jetzt folgt eine programmiertechnische Kapriole:
   Die iterative Textgrenermittlung, weil die Skalierung
   bei Turbo Pascal manchmal derben Mist produziert.}
  test_a:=1;
  test_b:=1;
  test_c:=1;
  test_d:=1;
  repeat
    setusercharsize(test_a,test_b,test_c,test_d);
    if textheight('A')<maxy div 30 then inc(test_c) else inc(test_d);
    if maxx div 10>textwidth('Standard') then inc(test_a) else inc(test_b);
  until (maxx div 10=textwidth('Standard'))
    and (textheight('A')=maxy div 30)
    or (test_a=255)
    or (test_b=255)
    or (test_c=255)
    or (test_d=255);
  pp:=sizeof(puffer)+1;
  repeat
    s:='';
    repeat
      if pp>sizeof(puffer)
      then
      begin
        blockread(txt,puffer,sizeof(puffer),gelesen);
        fehler:=ioresult<>0;
        pp:=1;
      end;
      if puffer[pp]>=#32 then s:=s+puffer[pp];
      inc(pp);
    until (length(s)=80) or (pp>gelesen) or fehler;
    if not fehler then outtextxy(0,zeile*Zeilenhoehe,s);
    inc(zeile);
  until (Zeile=25) or (pp>gelesen) or fehler or keypressed;
  close(txt);
  zeichnungbegonnen:=true;
  SETVIEWPORT(0,0,getmaxx,getmaxy,false);
  {Font zurcksetzen}
  IF fontnr=0 THEN
    SetTextstyle(0,0,Charsize div 8)
  ELSE
  BEGIN
    SetTextStyle(Fontnr,0,4);
    SetUserCharSize(Charsize,TextHeight('A'),Charsize,TextHeight('A'));
  END;
  repeat until keypressed;
END;

BEGIN END.
