{$A+,B-,D+,E+,F+,I-,L+,N+,O+,R-,V-,X+}
UNIT VIEWCFG;

INTERFACE uses dos;
PROCEDURE Schreibkonfiguration
	  (Nullbreite,
	   EinsZuEins,
	   Breitzwang,
	   EGAZwang,
	   VGAZwang,
	   Hercules,
	   XTernDriver,
	   MonoChromZwang,
	   GrauStufen,
	   HGReduziert,
	   Ineinanderzeichnen,
	   Ausblenden,
	   NimmFloyd,
	   ZoomBitMap,
	   DiMatWPDimat,
           EMSerlaubt		:Boolean;
	   XDriverMode,
	   FontNr,
	   Charsize,
           DruckerID,
           DruckerRes	        :Integer;
	   Breitenfaktor	:LongInt;
	   Programmname,
	   SuchMaske,
	   Programmpfad,
	   XDriverName,
	   BGIPfad		:PathStr;
	   EXEName		:NameStr);

IMPLEMENTATION uses disundas;
(*---------------------------------------------------------------------
		 SCHREIBEN DER KONFIGURATION
---------------------------------------------------------------------*)



PROCEDURE Schreibkonfiguration;
Label Fehler;
VAR cfg:text;
VAR Jahr,Monat,Tag,Wochentag:Word;
VAR h,m,s,s100:Word;
VAR ior:integer;
VAR f:File;

  Procedure Linie;
  BEGIN
  Writeln(cfg,';===============');
  end;
BEGIN
  {Der folgende Test auf den Schreibschutz eines Laufwerkes ist
   ungeheuer wichtig, denn sonst holt DOS den Diskettenzugriff nach, wenn
   ZEIGWPG beendet wird! Warum das so ist, ist eines der Ge-
   heimnisse zwischen DOS 5.0 und TP 6.0 ... ich habe jedenfalls
   keine Idee, was der Grund sein knnte.}
  IF ioresult<>0 THEN;
  assign(f,Programmpfad+EXENAME+'.$$$');
  rewrite(f);
  ior:=ioresult;                    {Diskette beschreibbar?}
  close(f); IF ioresult<>0 THEN;
  erase(f); IF ioresult<>0 THEN;

  IF ior=0 THEN
  BEGIN
  assign(cfg,programmpfad+exename+'.CFG');
  rewrite(cfg);IF IORESULT<>0 THEN GOTO Fehler;
  getdate(jahr,monat,tag,Wochentag);
  gettime(h,m,s,s100);
  Writeln(cfg,'; Konfigurationsdatei ',programmpfad+exename+'.CFG');
  Writeln(cfg,'; Angelegt nach dem ',Programmname,'-Programmlauf am ',
	       Tag,'.',Monat,'.',Jahr,' um ',h,':',nullfuell(m,2),' Uhr.');
  Writeln(cfg,'; Zeilen, die mit ";" beginnen, dienen der Erluterung.');
  LINIE; IF IORESULT<>0 THEN GOTO Fehler;
  Writeln(cfg,';        Breite zu zeichnender Linien:');
  Writeln(cfg,';        /0      so dnn wie mglich');
  Writeln(cfg,';        /-0     Originalbreite');
  IF Nullbreite then
    writeln(cfg,'/0')
  ELSE
    writeln(cfg,'/-0');
  LINIE; IF IORESULT<>0 THEN GOTO Fehler;
  Writeln(cfg,';        Breitenentzerrung:');
  Writeln(cfg,';        /Fx     x>10000 Darstellung wird breiter');
  Writeln(cfg,';                x<10000 Darstellung wird schmaler');
  Writeln(cfg,';        /1      Breitenentzerrung ignorieren,');
  Writeln(cfg,';                Rastergrafiken werden nicht gezoomt');
  Writeln(cfg,';        /-1     Breitenentzerrung beachten');
  writeln(cfg,'/F',Breitenfaktor);
  IF EinsZuEins then
    writeln(cfg,'/1')
  ELSE
    writeln(cfg,'/-1');
  LINIE; IF IORESULT<>0 THEN GOTO Fehler;
  Writeln(cfg,';        Ausnutzung der Bildbreite:');
  Writeln(cfg,';        /B     Breitdarstellung, keine Dateiliste');
  Writeln(cfg,';        /-B    Normaldarstellung mit Dateiliste');
  IF Breitzwang then
    writeln(cfg,'/B')
  ELSE
    writeln(cfg,'/-B');
  LINIE; IF IORESULT<>0 THEN GOTO Fehler;
  writeln(cfg,';        CHR-Schriftart und Schriftgre:');
  writeln(cfg,';        /Cn,p');
  writeln(cfg,';         nDateiBeschreibung      p (Standard)');
  writeln(cfg,';        ');
  writeln(cfg,';         0-    Standard-Font     8');
  writeln(cfg,';         1TRIP Roman dreifach   28');
  writeln(cfg,';         2LITT Kleinschrift      8');
  writeln(cfg,';         3SANS Helvetica doppelt28');
  writeln(cfg,';         4GOTH Englische Gotik  28');
  writeln(cfg,';         5SCRI Schreibschrift   33');
  writeln(cfg,';         6SIMP Helvetica einfach28');
  writeln(cfg,';         7TSCR Roman kursiv     28');
  writeln(cfg,';         8LCOM Roman doppelt    28');
  writeln(cfg,';         9EURO Euro einfach     52');
  writeln(cfg,';        10BOLD Helvetica fett   47');
  writeln(cfg,'/C',FontNr,',',CharSize);
  LINIE; IF IORESULT<>0 THEN GOTO Fehler;
  Writeln(cfg,';        Grafiktreiber:');
  Writeln(cfg,';        /E      EGA      (EGAVGA.BGI)');
  Writeln(cfg,';        /H      Hercules (HERC.BGI)');
  Writeln(cfg,';        /V      VGA      (EGAVGA.BGI)');
  Writeln(cfg,';        /Xname,modus     (name.BGI)');
  Writeln(cfg,';                "modus" ist eine Zahl von 0 bis 7. Je hher die');
  Writeln(cfg,';                Modus-Nummer, desto besser die Auflsung. Jedoch');
  Writeln(cfg,';                sind fast nie alle 8 Modi belegt.');
  Writeln(cfg,';        Wird kein Grafiktreiber gewhlt, bestimmt das Programm');
  Writeln(cfg,';        automatisch, welchen es bentigt.');
  IF EGAZwang then
    writeln(cfg,'/E');
  IF Hercules then
    writeln(cfg,'/H');
  IF VGAZwang then
    writeln(cfg,'/V');
  IF XTernDriver then
    writeln(cfg,'/X',Xdrivername,',',XDriverMode);
  LINIE; IF IORESULT<>0 THEN GOTO Fehler;
  Writeln(cfg,';        EMS-Speicher:');
  Writeln(cfg,';        /-E     Nutzung von EMS-Speicher verbieten');
  Writeln(cfg,';        ',Programmname,' ldt normalerweise Programmteile, auf die');
  Writeln(cfg,';        es nicht stndig zugreifen mu, in den EMS-Speicher, um sie');
  Writeln(cfg,';        von dort schnell nachladen zu knnen. Falls es zu unerklrlichen');
  Writeln(cfg,';        Abstrzen kommt, verbieten Sie zunchst die Nutzung von EMS.');
  IF not emserlaubt then
    writeln(cfg,'/-E');
  LINIE; IF IORESULT<>0 THEN GOTO Fehler;
  Writeln(cfg,';        Ausgabegert - Druckertyp');
  Writeln(cfg,';        Standardmig untersttzt das Programm die Druckausgabe');
  Writeln(cfg,';        auf dem HP LaserJet und dazu kompatiblen Druckern. Mit');
  Writeln(cfg,';        /An,a knnen Sie den Druckertyp und die Auflsung whlen:');
  Writeln(cfg,';          n  Druckertyp');
  Writeln(cfg,';        ');
  Writeln(cfg,';          1  HP LaserJet und PCL-Level-III-kompatible');
  Writeln(cfg,';          2  HP DeskJet, Olivetti JP 350 und kompatible');
  Writeln(cfg,';          3  9-Nadel-Drucker');
  Writeln(cfg,';          4  24-Nadel-Drucker, z.B. EPSON LQ 870/1170');
  Writeln(cfg,';          5  EPSON LX-800 und kompatible 9-Nadel-Drucker');
  Writeln(cfg,';        Fehlt der Parameter a, wird eine Standardauflsung einge-');
  Writeln(cfg,';        stellt. Andere Werte hngen vom Druckertyp ab. Folgende');
  Writeln(cfg,';        Tabelle zeigt, welche Auflsungen (in DPI) fr welche Drucker');
  Writeln(cfg,';        mglich sind:');
  Writeln(cfg,';        Drucker     a=1  a=2  a=3  a=4  a=0 (Standard)');
  Writeln(cfg,';        ');
  Writeln(cfg,';        LaserJet     75  100  150  300  150');
  Writeln(cfg,';        DeskJet      75  100  150  300  150');
  Writeln(cfg,';        LX-800   1)  60   72  120  240   72');
  Writeln(cfg,';        9-Nadeldr.    ?    ?    ?    ?  120?');
  Writeln(cfg,';        24-Nadel 2)  60   90  120  180  180');
  Writeln(cfg,';        Bei Nadeldruckern ist nur die horizontale Auflsung vernderbar.');
  Writeln(cfg,';        1) Vertikal immer 72 DPI.');
  Writeln(cfg,';        2) Vertikal immer 180 DPI.');
  Writeln(cfg,'/A',DruckerID,',',DruckerRes);
  LINIE; IF IORESULT<>0 THEN GOTO Fehler;
  Writeln(cfg,';        Pfad fr Grafiktreiber und Vektorfonts');
  Writeln(cfg,';        BGI-Treiber und CHR-Schriften werden standardmig im');
  Writeln(cfg,';        Programmverzeichnis (',Programmpfad,') gesucht. Wahlweise');
  Writeln(cfg,';        knnen Sie mit /Ppfad ein anderes Verzeichnis angeben:');
  IF BGIPFAD<>'' then
    writeln(cfg,'/P',BGIPfad);
  LINIE; IF IORESULT<>0 THEN GOTO Fehler;
  Writeln(cfg,';        Ineinanderzeichnen');
  Writeln(cfg,';        /I      Bilder werden ineinandergezeichnet');
  Writeln(cfg,';        /I     256-Farben-Palette wird weich berblendet');
  Writeln(cfg,';        /-I     Bildschirm wird vor jedem Bild gelscht');
  IF Ineinanderzeichnen then
    IF ausblenden then
      writeln(cfg,'/I')
    ELSE
      writeln(cfg,'/I')
  ELSE writeln(cfg,'/-I');
  LINIE; IF IORESULT<>0 THEN GOTO Fehler;
  Writeln(cfg,';        Graustufen');
  Writeln(cfg,';        /G      Farbige Bilder werden in Graustufen dargestellt');
  Writeln(cfg,';                Monochrome PCX- und IMG- Grafiken werden in 16');
  Writeln(cfg,';                Graustufen dargestellt.');
  IF Graustufen then
    writeln(cfg,'/G')
  ELSE
    writeln(cfg,'/-G');
  LINIE; IF IORESULT<>0 THEN GOTO Fehler;
  Writeln(cfg,';        Monochromdarstellung auf Farbmonitoren');
  Writeln(cfg,';        /M      Farbige Bilder werden schwarz-wei gerastert');
  Writeln(cfg,';        /W      WordPerfect-5.1-Rasterung (grob)');
  Writeln(cfg,';        /Y      Floyd-Steinberg-Rasterung (fein)');
  Writeln(cfg,';        /W und /Y beziehen sich auch auf das Rastern 256-farbiger');
  Writeln(cfg,';        Grafiken auf 16-Farb-Systemen. /Y ist nur bei nicht gezoomten');
  Writeln(cfg,';        Rastergrafiken anwendbar.');
  IF Monochromzwang then
    writeln(cfg,'/M')
  ELSE
    writeln(cfg,'/-M');
  IF DimatWPDimat then
    writeln(cfg,'/W')
  ELSE
    writeln(cfg,'/-W');
  IF NimmFloyd then
    writeln(cfg,'/Y')
  ELSE
    writeln(cfg,'/-Y');
  LINIE; IF IORESULT<>0 THEN GOTO Fehler;
  Writeln(cfg,';        Rastergrafiken standardmig zoomen');
  Writeln(cfg,';        /Z      immer zoomen');
  Writeln(cfg,';        /-Z     kleine Grafiken klein lassen');
  IF ZoomBitMap then
    writeln(cfg,'/Z')
  ELSE
    writeln(cfg,'/-Z');
  LINIE; IF IORESULT<>0 THEN GOTO Fehler;
  Writeln(cfg,';        Helligkeit der Zeichenflche');
  Writeln(cfg,';        /R      Reduzierte Helligkeit');
  Writeln(cfg,';        /-R     Hintergrund wei');
  IF HGReduziert then
    writeln(cfg,'/R')
  ELSE
    writeln(cfg,'/-R');
  LINIE; IF IORESULT<>0 THEN GOTO Fehler;
  writeln(cfg,';        Datei-Suchmaske:');
  writeln(cfg,Suchmaske);
  LINIE; IF IORESULT<>0 THEN GOTO Fehler;
  Writeln(cfg,';        Speichern der Konfiguration:');
  Writeln(cfg,';        /S      Nach jedem Programmlauf');
  Writeln(cfg,';        /-S     Nie');
  writeln(cfg,'/S');
Fehler:
  if ioresult<>0 then;
  close(cfg);
  if ioresult<>0 then;
  END; {Diskette beschreibbar}
END; {Parameter schreiben}

begin end.
