{$A+,B-,D+,E+,F+,I-,L+,N+,O+,R-,V-,X+}
UNIT VIEWDALI; {Die Dateileiste}

INTERFACE
USES
	VIEWPRIM,
	DOS;
Const UpdateCursor=0;	{Cursor neu zeichnen}
Const UpdateName=1;     {Nur aktuellen Namen neu schreiben}
Const UpdateDown=2;     {Von Cursor bis Seitenende neu}
Const UpdateAll=3;      {Dateiliste ganz neu}
VAR
    Dnamenfeld	:NamenFeldTyp;  {Die sortierte Liste aller Dateinamen}
    Dateienzahl	:word;
    Dateinummer	:word;          {Nummer des aktuellen Bildes in der Liste}
    MarkierteDateien:word;	{Anzahl markierter Dateien}
    MarkierteKByte:Longint;	{GesamtGre markierter Dateien}
    Suchmaske_Eindeutig
		:Boolean;       {Suchmaske ist Dateiname}
    NurEineDateiAnzuzeigen
		:Boolean;	{Fr Aufruf aus Fremdprogramm}
    suchmaske	:pathstr;    	{Aktuelle Suchmaske}
    Liste_von,
    Liste_bis	:Integer;       {Differenz hngt vom Font und der
				 Auflsung ab}
    DateiAttr   :WORD;          {Fr's Kopieren und die Statusanzeige}
    DateiZeit   :DateTime;

procedure Qsort_Dateinamen(von,bis: integer);
PROCEDURE Setze_Font(FontNr:Integer; VAR Charsize:Integer);
Procedure Hole_Dateien(Suchmaske:PathStr;
		       VAR name:Namenfeldtyp; VAR anzahl:Word);
Procedure ErrechneMaxx;
PROCEDURE LoescheDateinamen(VAR DN:WORD);
PROCEDURE HoleSuchmaske;
PROCEDURE SucheErsteDatei;
PROCEDURE SucheVerzeichnis(Verzeichnisname:PathStr);
PROCEDURE SucheDatei(DateiName:Pathstr);
PROCEDURE ZeigDateiliste(VAR von,bis:INTEGER;
			 Dateinummer:WORD;Update:Integer);
procedure LoescheAlleDateinamen(VAR Dateinamenfeld:namenfeldtyp;
				VAR anzahl:word);
CONST Loeschen=False;
CONST Setzen=TRUE;
CONST Anzeigen=TRUE;
PROCEDURE Markierung(DN:Word;Aktion,Zeigen:Boolean);


IMPLEMENTATION
uses
	GRAPH,
	CRT,
	DISK,
	VIEWSL,
	VIEWSLIN,
	POPWIN;
(*---------------------------------------------------------------------
	 WIE BREIT IST DER FR DIE ZEICHNUNG NUTZBARE BEREICH?
---------------------------------------------------------------------*)

Procedure ErrechneMaxx;
  {Platz fr Dateileiste freihalten. Auch bei Proportionalfonts reicht die
   Breite aus. "WWWWWWWW.WWW" ist theoretisch zwar richtiger, aber
   erfahrungsgem bertrieben.}
BEGIN
IF BreitDarstellung THEN
  Maxx:=GetMaxx
ELSE
  maxx:=getmaxx-TextWidth('STANDARD.WPG')-5;
  IF maxx<0
  THEN
  BEGIN
    fontnr:=0;
    Charsize:=8;
    SetTextStyle(0,0,1);
    TH:=8;
    maxx:=getmaxx-TextWidth('STANDARD.WPG')-5;
  END;
END;


(*---------------------------------------------------------------------
	   SETZEN DES ALLGEMEINEN FONTS FR MENS UND MELDUNGEN
---------------------------------------------------------------------*)
PROCEDURE Setze_Font(FontNr:Integer; VAR Charsize:Integer);
{Seiteneffekte:
 MAXX und TH werden neu berechnet}
begin
  IF Charsize=0 THEN
    BEGIN
      SetTextstyle(fontnr,0,4);
      IF graphresult<>0 THEN      {Fehler -11: Unbekannter Fehler}
	SetTextStyle(Fontnr,0,4); {Jetzt klappt's meist...}
      setusercharsize(1,1,1,1);
      Charsize:=Textheight('A');
    END;

    IF fontnr=0 THEN
      SetTextstyle(0,0,Charsize div 8)
    ELSE
    BEGIN
      SetTextStyle(Fontnr,0,4);
      IF graphresult<>0 THEN      {Fehler -11: Unbekannter Fehler}
	SetTextStyle(Fontnr,0,4); {Jetzt klappt's meist...}
      SetUserCharSize(Charsize,TextHeight('A'),Charsize,TextHeight('A'));
    END;

    SetTextJustify(lefttext,toptext);
    TH:=textheight('A');

    ErrechneMAXX;
    IF fontnr=0 THEN maxy:=getmaxy-TH-4
		else maxy:=getmaxy-TH*5 div 4-4; {fr Statuszeile freihalten}
end;
(*---------------------------------------------------------------------
		    SORTIEREN DER DATEILISTE
---------------------------------------------------------------------*)

procedure Qsort_Dateinamen(von,bis: integer);
{QSORT, sehr Stackintensiv}
VAR
  i,j,m: integer;
  y:Pointer;
  x:String[13];
BEGIN
  {Schnelle Abfrage auf Sonderfall:}
  if bis=von+1 then
  begin
    if char(dnamenfeld[von]^.F)+Dnamenfeld[von]^.N
      >char(dnamenfeld[bis]^.F)+Dnamenfeld[bis]^.N
    then
    begin
      y:=Dnamenfeld[von];
      Dnamenfeld[von]:=Dnamenfeld[bis];
      Dnamenfeld[bis]:=y;
    end;
    exit;
  end;
  i:=von;
  j:=bis;
  m:=(i+j) div 2;
  x:=char(dnamenfeld[m]^.F)+Dnamenfeld[m]^.N;
  repeat
    while x>char(dnamenfeld[i]^.F)+Dnamenfeld[i]^.N do inc(i);
    while x<char(dnamenfeld[j]^.F)+Dnamenfeld[j]^.N do dec(j);
    IF i<j THEN
    BEGIN
      y:=Dnamenfeld[i];
      Dnamenfeld[i]:=Dnamenfeld[j];
      Dnamenfeld[j]:=y;
      inc(i); dec(j);
    END
      else IF i=j THEN BEGIN inc(i);dec(j) END;
  until i>j;
  {Martin Vogel Special:}
  {Unter Umstnden ist X so unglcklich gewhlt,
   da er jetzt endlos weitermachen wrde.
   z.B bei 31 29 30}
  IF (i=von) then
  BEGIN
      y:=Dnamenfeld[m];
      Dnamenfeld[m]:=Dnamenfeld[von];
      Dnamenfeld[von]:=y;
  END
  ELSE
  IF (j=bis) then
  BEGIN
      y:=Dnamenfeld[m];
      Dnamenfeld[m]:=Dnamenfeld[bis];
      Dnamenfeld[bis]:=y;
  END;

  IF von<j THEN Qsort_Dateinamen(von,j);
  IF bis>i THEN QSort_Dateinamen(i,bis);
END;

procedure Qsort_Dateinamen_bubble(von,bis: integer);
{BUBBLESORT}
VAR
  i,j: integer;
  y:Pointer;
BEGIN
  for i:=von to bis do
  for j:=bis downto i+1 do
  if char(dnamenfeld[i]^.F)+Dnamenfeld[i]^.N
    >char(dnamenfeld[j]^.F)+Dnamenfeld[j]^.N
    then
    begin
      y:=Dnamenfeld[i];
      Dnamenfeld[i]:=Dnamenfeld[j];
      Dnamenfeld[j]:=y;
    end;
END;

(*---------------------------------------------------------------------
		     DATEILISTE AUFBAUEN
---------------------------------------------------------------------*)


Procedure Hole_Dateien(Suchmaske:PathStr;
		       VAR name:Namenfeldtyp; VAR anzahl:Word);
VAR f		:Searchrec;
    pfad	:DirStr;
    dname	:NameStr;
    ext		:ExtStr;
    drive:Char;
BEGIN
  fsplit(fexpand(suchmaske),pfad,dname,ext);
  findfirst(pfad+'*.*',anyfile,f);
  Anzahl:=0;
  MarkierteDateien:=0;
  MarkierteKByte:=0;
  for drive:='A' to LastDrive do
  if maxavail>sizeof(Dateilistentyp) then
  BEGIN
    inc(anzahl);
    new(name[anzahl]);
    name[anzahl]^.F:=Laufwerk;
    name[anzahl]^.N:='[-'+drive+'-]';
    name[anzahl]^.Markiert:=FALSE;
  END;
  while (doserror=0 {frher: <>18} ) and (anzahl<maxdateinummer) do
  BEGIN
    IF      (f.attr and VolumeID=0)
	AND (DateinameGleich(dname+ext,f.name)
	     or((f.attr and Directory=Directory)
		 and NOT (diashow or Suchmaske_eindeutig)))
	AND NOT (f.name='.')
	AND (anzahl<MaxDateiNummer)
	AND (maxavail>sizeof(Dateilistentyp))
    THEN
    BEGIN
      inc(anzahl);
      new(name[anzahl]);
      IF f.attr and $10=$10 THEN {Directory}
      BEGIN
	name[anzahl]^.N:=LowStr(f.name);
	name[anzahl]^.F:=Verzeichnis;
	name[anzahl]^.Markiert:=FALSE;
      END
      else
      BEGIN
	name[anzahl]^.N:=f.name;
	name[anzahl]^.F:=Datei;
	name[anzahl]^.Markiert:=FALSE;
      END
    END;
    findNext(f);
  END;
  BreitDarstellung:=(Anzahl=1) or BreitZwang;

  if ioresult=0 then;
  infdatvorh:=fileexist(ProgrammPfad+EXENAME+'.INF');
  infogefunden:=FALSE;
END;{Hole Dateien()}

(*---------------------------------------------------------------------
	     DATEILISTE AUF DEM GRAFIKBILDSCHIRM ANZEIGEN
		   UND CURSORBOX NACHFHREN
---------------------------------------------------------------------*)

PROCEDURE ZeigDateiliste(VAR von,bis:INTEGER;
			 Dateinummer:WORD;Update:Integer);
CONST VerzFarb=0; {Directories knnen auch in einer anderen Farbe
		   dargestellt werden, Nachteil ist, da sich durch
		   die stndigen Palettennderungen recht blde Effekte
		   ergeben.}
VAR i:integer;
    anz:integer;
    ns:Dateinamentyp;
    BH:Integer; {Buchstabenhhe}
const zei:integer=0;

      PROCEDURE ZeigZeile(i:integer);
      VAR CH:CHAR;
      BEGIN
	{Outtext ist so langsam, da der Rechner
	 bei einer bestndig gedrckten Taste zu piepsen beginnt}
	while keypressed do
        begin
          ch:=readkey;
          if ch=#0 then readkey;
          Escapegedrueckt:=ch=#27;
        end;
	ns:=dirformat(DnamenFeld[i]^.N);
	if Dnamenfeld[i]^.Markiert then ns[9]:='*';
	SetTextJustify(Righttext,Toptext);
	outtextxy(getmaxx-4,(i-von)*(BH+1)+2,
		  copy(ns,10,3));
	SetTextJustify(Lefttext,Toptext);
	IF DNamenFeld[i]^.F<>Datei THEN {fett}
	BEGIN
	outtextxy(maxx+5,(i-von)*(BH+1)+2,
		  copy(ns,1,9));
	setcolor(VerzFarb);
	END;
	outtextxy(maxx+4,(i-von)*(BH+1)+2,
		  copy(ns,1,9));
	setcolor(0);
      END;

BEGIN

  IF BreitDarstellung or (dateinummer=0) THEN Exit;

  IF NOT Palignore
  THEN
  BEGIN
    SetRGBPalette(0,0,0,0);
    SetRGBPalette(GetMaxColor,255,255,255);
  END;

  IF Fontnr=0
  THEN BH:=TH
  else BH:=TH*5 div 4; {Die Vektorfonts liegen sonst auf.}
  setcolor(GetMaxColor);
  setwritemode(xorput);
  setlinestyle(solidLn,0,normwidth);
  Rectangle(maxx+2,(zei-1)*(BH+1),getmaxx,zei*(BH+1));
  setwritemode(copyput);
  line(maxx+2,0,maxx+2,maxy); {ggf. Mll lschen}
  setcolor(0);
  line(maxx+1,0,maxx+1,maxy);

  IF    (Update=Updateall)
     or (von>dateinummer)
     or (bis<dateinummer)
     or ((bis>dateienzahl) and (Update<>UpdateDown))
  THEN
    BEGIN
      anz:=min(maxy div (BH+1),DateienZahl);
      von:=dateinummer-anz div 2;
      bis:=von+anz-1;
      IF bis>DateienZahl THEN
	BEGIN
	  von:=Dateienzahl-anz+1;
	  bis:=Dateienzahl;
	END;
      IF von<1 THEN
	BEGIN
	  bis:=anz;
	  von:=1;
	END;
      setfillstyle(solidfill,getmaxcolor);
      bar(maxx+2,0,getmaxx,maxy);

      for i:=von to bis do ZeigZeile(i);

    END {IF UpDateAll}
    ELSE
    If Update=Updatedown
    then
    begin
      IF bis>DateienZahl THEN bis:=Dateienzahl;

      setfillstyle(solidfill,getmaxcolor);
      bar(maxx+2,(Dateinummer-von)*(BH+1),getmaxx,maxy);

      for i:=Dateinummer to bis do ZeigZeile(i);

    end;

    Zei:=Dateinummer-Von+1;

    If UpDate=UpDateName then
    begin
      setfillstyle(solidfill,getmaxcolor);
      BAR(maxx+2,(zei-1)*(BH+1),getmaxx,zei*(BH+1));
      ZeigZeile(Dateinummer);
    end;

    Setcolor(getmaxcolor);
    setwritemode(xorput);
    Rectangle(maxx+2,(zei-1)*(BH+1),getmaxx,zei*(BH+1));
    setwritemode(copyput);


END;


(*---------------------------------------------------------------------
	     SPEICHER DER DATEILISTE WIEDER FREIGEBEN
---------------------------------------------------------------------*)

procedure LoescheAlleDateinamen(VAR Dateinamenfeld:namenfeldtyp;
				VAR anzahl:word);
VAR n:word;
BEGIN
 for n:=anzahl downto 1 do
   DISPOSE(dateinamenfeld[n]);
 anzahl:=0;
 MarkierteDateien:=0;
 MarkierteKByte:=0;
END;

(*---------------------------------------------------------------------
       Erste Datei hinter Laufwerken und Verzeichnissen whlen
---------------------------------------------------------------------*)
PROCEDURE SucheErsteDatei;
BEGIN
  DateiNummer:=1;
  While (dnamenfeld[Dateinummer]^.F<>Datei)
    and (Dateinummer<=Dateienzahl)
  do inc(Dateinummer);
  NurEineDateiAnzuzeigen:=Dateinummer=Dateienzahl;
  If Dateinummer>Dateienzahl then
  begin
    Dateinummer:=1;
    While (dnamenfeld[Dateinummer]^.F=LaufWerk)
      and (Dateinummer<=Dateienzahl)
    do inc(Dateinummer);
    Dateinummer:=lmin(Dateinummer,Dateienzahl);
  end;
END;

(*---------------------------------------------------------------------
       Verzeichnis mit bestimmten Namen suchen
---------------------------------------------------------------------*)
PROCEDURE SucheVerzeichnis(Verzeichnisname:PathStr);
var dir:dirstr;
var name:namestr;
var ext:extstr;
BEGIN
  fsplit(chdirformat(Verzeichnisname),dir,name,ext);
  if name+ext=''
  then SucheErsteDatei
  else
  begin
    Dateinummer:=1;
    While (dnamenfeld[Dateinummer]^.F=LaufWerk)
      and (Dateinummer<=Dateienzahl)
    do inc(Dateinummer);
    While (upstr(dnamenfeld[Dateinummer]^.N)<>upstr(name+ext))
      and (dnamenfeld[Dateinummer]^.F=Verzeichnis)
      and (Dateinummer<=Dateienzahl)
    do inc(Dateinummer);
    Dateinummer:=lmin(Dateinummer,Dateienzahl);
  end;
END;

(*---------------------------------------------------------------------
       Datei mit bestimmten Namen suchen
---------------------------------------------------------------------*)
PROCEDURE SucheDatei(Dateiname:PathStr);
BEGIN
  SucheErsteDatei;
  While (dnamenfeld[Dateinummer]^.N<Dateiname)
    and (Dateinummer<=Dateienzahl)
  do inc(Dateinummer);
  Dateinummer:=lmin(Dateinummer,Dateienzahl);
END;

(*---------------------------------------------------------------------
		      NEUE DATEI-SUCHMASKE ERFRAGEN
---------------------------------------------------------------------*)

PROCEDURE HoleSuchmaske;
var szeile:pathstr;
var name:namestr;
var ext:extstr;
BEGIN
  WriteSL('Neue Suchmaske: ',true);
  Szeile:=Suchmaske;
  IF InputSL(szeile,7)
  THEN
  BEGIN
    if ist_verzeichnis(szeile) then szeile:=szeile+'\*.*';
    LoescheAlleDateinamen(Dnamenfeld,Dateienzahl);
    Fsplit(fexpand(SZeile),AKT_dir,name,ext);
    CHdir(Akt_dir);
    Hole_Dateien(SZeile,Dnamenfeld,Dateienzahl);
    IF Dateienzahl>0 THEN suchmaske:=sZeile
    ELSE
      BEGIN
	sound(2000);
	WriteSL('Keine Dateien mit "'+SZeile+'" gefunden.',true);
	nosound;
	delay(2000);
	while keypressed do if readkey=#0 then readkey;
	Fsplit(fexpand(Suchmaske),akt_dir,name,ext);
	chdir(akt_dir);
	Hole_Dateien(Suchmaske,Dnamenfeld,Dateienzahl);
      END;
    IF Dateienzahl>0 THEN
    BEGIN
      QSort_Dateinamen(1,Dateienzahl);
      Dateinummer:=1;
      SucheErsteDatei;
      Zeichnungbegonnen:=TRUE; {Altes Bild stimmt nicht mehr!}
      setfillpattern(HGmuster,HGfarbe);
      Bar(maxx,0,getmaxx,maxy);
      ErrechneMaxx;
      ZeigDateiliste(liste_von,liste_bis,Dateinummer,UpDateAll);
    END;
  END; {InputSL nicht mit ESC abgebrochen}
END; {HoleSuchmaske}

(*---------------------------------------------------------------------
	  EINEN EINZELNEN DATEINAMEN AUS DER LISTE ENTFERNEN
---------------------------------------------------------------------*)

PROCEDURE LoescheDateinamen(VAR DN:WORD);
VAR i:Word;
BEGIN
 IF DN>0 THEN
 BEGIN
 DISPOSE(Dnamenfeld[DN]);
 dec(Dateienzahl);
 IF DN>Dateienzahl           {Letzte Datei gelscht}
 THEN
   dec(DN)
 ELSE
 for i:=dn to dateienzahl
 do Dnamenfeld[i]:=dnamenfeld[i+1];
 {MOVE(Dnamenfeld[DN+1],
      Dnamenfeld[DN],
      (Dateienzahl-DN+1)*4);
 {Ein Pointer = 4 Byte}
 END;
 ZeigDateiliste(Liste_von,Liste_bis,DN,UpDateDown);
END;

PROCEDURE Markierung(DN:Word;Aktion,Zeigen:Boolean);
BEGIN
IF (Dnamenfeld[DN]^.F=Datei) THEN
BEGIN
CASE Aktion of
Setzen:
  if not Dnamenfeld[DN]^.Markiert then
  begin
    Dnamenfeld[DN]^.Markiert:=TRUE;
    inc(MarkierteDateien);
    inc(MarkierteKByte,(Dateigroesse(AKT_DIR+DNamenFeld[DN]^.N)+1023) div 1024);
  END;
Loeschen:
  if Dnamenfeld[DN]^.Markiert then
  begin
    Dnamenfeld[DN]^.Markiert:=FALSE;
    dec(MarkierteDateien);
    dec(MarkierteKByte,(Dateigroesse(AKT_DIR+DNamenFeld[DN]^.N)+1023) div 1024);
  END;
END; {Case}
END;{Datei}
If zeigen then begin
  ZeigDateiliste(liste_von,liste_bis,DN,UpDateName);
  Gruppen_Info(MarkierteDateien,MarkierteKByte);
END;
END;{Markierung Setzen/Lschen}


begin end.
