{$A+,B-,D+,E+,F+,I-,L+,N+,O+,R-,V-,X+}
unit VIEWprim;
{Alles, was berall gebraucht wird, vor allem
 haufenweise globale Variablen und Konstanten}

interface uses crt,dos,graph,vgabios,general,drehfont;
{$IFOPT N+}
TYPE REAL=DOUBLE;
{$ENDIF}

{CONST ProgrammName='VIEW!';}
{CONST ProgrammName='ZEIGWPG';}
{CONST ProgrammName='SEWVIEW';}
CONST ProgrammName='VEXURY';

CONST
      MaxDateinummer=1024;{Soviel Dateien werden in die Liste aufgenommen}
      Eins=$10000;        {Ersatz von Real-Arithmetik durch LongInt.
			   HiWord sind Vorkommastellen,
			   LoWord "Nachkommastellen"}
CONST
      WPG_Normal=0;       {Modusbyte fr zu schreibende WPG-Dateien}
      WPG_Gedreht=1;
      WPG_Grau=2;
      WPG_Sortiert=3;
TYPE
     puffertyp=array[1..$8000] of Byte;
     DateiNamentyp=String[12];
     Dateientyp=(Laufwerk,Verzeichnis,Datei);
     Dateilistentyp=Record
		      N:Dateinamentyp;
		      F:Dateientyp;
		      Markiert:Boolean;
		    end;
     NamenFeldTyp=Array[1..MaxDateinummer] of ^Dateilistentyp;
     DiMatTyp=ARRAY[0..7,0..7] of Byte;
     str24=string[24];
type bytefeldtyp=array[0..2048] of byte;
TYPE WPCheadertyp=record     {16 Byte Header einer WPC-Datei}
		 wpcid	:array[1..4]of char;   {mu #255'WPC' sein}
		 start	:longint;              {sollte 16 sein}
		 prtyp	:Byte;                 {1=WordPerfect}
		 fltyp	:Byte;                 {22=WPG}
		 maver	:Byte;                 {sollte 1 sein}
		 miver	:Byte;                 {sollte 0 sein}
		 enkey	:Word;                 {mu 0 sein}
		 resvd	:Word;                 {beliebig}
	       END;

(*---------------------------------------------------------------------
		 VORBELEGTE GLOBALE VARIABLEN
---------------------------------------------------------------------*)
CONST
      Closedots	:Fillpatterntype=(85,170,85,170,85,170,85,170);
      Fulldots	:Fillpatterntype=(255,255,255,255,255,255,255,255);
      BreitDarstellung  :Boolean=FALSE; {Darstellung ohne Dateileiste am
					 rechten Rand.}
      BreitZwang        :Boolean=FALSE; {Vom Benutzer gewnscht. Sonst ist
					 Breitdarstellung automatisch, wenn
					 nur eine Datei in der Dateiliste ist.}
      IneinanderZeichnen:Boolean=FALSE; {Kein Bildschirmlschen zwischen zwei
					 Bildern.}
      Ausblenden        :Boolean=FALSE; {Sanfter Palettenbergang zwischen
					 zwei VGA-Bildern.}
      Abgebrochen	:Boolean=FALSE; {Flag fr Taste gedrckt und sowas.}
      Escapegedrueckt	:Boolean=FALSE; {z.B. bei JaNein-Abfragen}
      Programmende	:Boolean=FALSE; {ESC gedrckt oder Demo-Modus und
					 letzte Datei dargestellt.}
      Hercules		:Boolean=FALSE; {Herculeskarte gefunden oder gewnscht.}
      EGAgefunden	:Boolean=FALSE; {}
      VGAKarte          :Boolean=FALSE; {VGA-Karte gefunden}
      MonoChrom	        :Boolean=FALSE;	{Farben werden gerastert}
      MonoChromZwang	:Boolean=FALSE; {Alle Bilder werden gerastert}
      VGAzwang		:Boolean=FALSE; {Falls Autodetect versagt}
      EGAZwang		:Boolean=FALSE; {Zum Testen des EGA-Modus}
      DiaShow		:Boolean=FALSE; {Wartet nach jedem Bild und geht dann
					 weiter}
      RandomShow	:BOOLEAN=FALSE; {Zeigt endlos alle Bilder an.}
      SaveConfig	:BOOLEAN=TRUE;	{Konfigurationsdatei speichern}
      Graustufen	:BOOLEAN=FALSE; {Darstellung mit WP-Palette}
      NullBreite	:BOOLEAN=FALSE; {Keine Strichstrken}
      ZoomBitMap	:BOOLEAN=FALSE; {Zoom gewnscht}
      ZoomDiesBitMap	:BOOLEAN=FALSE; {Bitmap klein genug zum zoomen?}
      NimmFloyd         :BOOLEAN=FALSE; {Standard ist ordered Dithering}
      EinszuEins	:Boolean=FALSE; {Alle Pixel werden dargestellt.}
      Zeichnungbegonnen	:Boolean=TRUE;  {Dann mu z.B. beim nchsten Bild
					 der Bildschirm gelscht werden.}
      Xterndriver       :Boolean=FALSE; {/X war in der Kommandozeile}
      XdriverName       :PathStr='';
      XdriverMode       :Integer=-1;
      BGIPfad           :PathStr='';    {entweder hinter /X, /P, oder
					 aus der Environment-Var. BGI}
      HGreduziert       :Boolean=FALSE; {Reduzierte Hintergrundhelligkeit}
      PalIgnore		:Boolean=FALSE; {Wenn Palette gendert, wird Palette
					 beim nchsten Lesen nicht gesetzt.}
      EGAPALgeaendert   :Boolean=FALSE; {Verbot, die Palette zu ndern, da
					 sie fr das Farbdithering neu gesetzt
					 werden mute.}
      Zuvielefarben     :Boolean=FALSE; {Bild hat zu viele Farben fr die
					 Karte,Darstellung erfolgt durch
					 Dithering.}
      Breitenfaktor     :Longint=10000; {Anpassung an Bildschirm von Hand,
					 denn Graph.GetAspectratio kann nicht
					 alles wissen, schon gar nicht, wie
					 ein Monitor eingestellt ist.}
      m1		:integer=0;     {Universelles Mausbyte...}
      FontNR		:Integer
			=DefaultFont;   {Standard 8x8-Font}
      CharSize          :Integer=0;     {Standard fr DefaultFont}
      Linienbreite	:Word=0;	{Wenn <>0 werden alle Linien
					mit dieser Dicke gezeichnet}
      emserlaubt        :Boolean=true;  {Fr Overlays}

 {Matrix fr 64stufiges Dithering}
const MVDiMat:DiMatTyp=
	((  0,128, 32,160,  8,136, 40,168),
	 (192, 64,224, 96,200, 72,232,104),
	 ( 48,176, 16,144, 56,184, 24,152),
	 (240,112,208, 80,248,120,216, 88),
	 ( 12,140, 44,172,  4,132, 36,164),
	 (204, 76,236,108,196, 68,228,100),
	 ( 60,188, 28,156, 52,180, 20,148),
	 (252,124,220, 92,244,116,212, 84));

 {Grobe WP-Dithermatrix}
const WPDiMat:DiMatTyp=
	((132,164,228,140, 96, 72, 64,120),
	 (180,220,252,244, 80, 16, 24, 48),
	 (188,212,236,196, 88,  0,  8, 56),
	 (148,204,172,156,112, 32, 40,104),
	 (100, 76, 68,124,128,160,224,136),
	 ( 84, 20, 28, 52,176,216,248,240),
	 ( 92,  4, 12, 60,184,208,232,192),
	 (116, 36, 44,108,144,200,168,152));

      DiMat:^DiMatTyp=@MVDiMat;


VAR
  RGBPalette  :RGBPalType;
  maxx,
  maxy,
  th          :Integer;
  GrauPalette :Array[Byte]of Byte;
	       {Fr die Fllmuster: Helligkeiten der 256 Farben}
  BorderSave  :Byte;
  xvaria,
  yvaria      :LongInt; 	{65536=1, so werden Nachkommastellen simuliert}
  wpghoehe,
  wpgbreite   :word;      	{In WPG-Units (1"/1200)}
  PalGesetzt  :Boolean; 	{Wenn FALSE, werden lineare
				 Standardgrauwerte gesetzt}
  ende	      :boolean;         {Datei zuende oder Taste gedrckt}
  wpg	      :file;    	{Die zu lesende WPG-Datei}
  FalscherTyp :Boolean; 	{Keine WPG-Datei}
  HGFarbe     :Byte;            {Hintergrund grau oder wei}
  HGMuster    :Fillpatterntype; {Wenn Monochromzwang auf Farbkarte,
				 ist der Hintergrund gleichmig grau oder wei,
				 sonst eng gerastert}
  MonoPattern :ARRAY[0..64] of FillPatternType;
  EGAVGABreite:Word;            {Breite in Byte}
  EGAVGA16    :Boolean;         {16-Farbmodus fr direktes Schreiben}
  IOR	      :WORD;		{letztes IORESULT}
  ProgrammPfad:PathStr;		{Hier stehen auch ZEIGWPG.INF, ZEIGWPG.CFG,
				 und es wird hier nach *.BGI und *.CHR
				 gesucht.}
  exename     	:namestr;       {Name der EXE-Datei, ZEIGWPG oder MVIEW}
  Lizenziert  	:Boolean;	{Wird anhand der Datei ZEIGWPG.LIZ entschieden}
  LastDrive   	:Char;
CONST
  LetzteWPGDatei:Pathstr='';    {Dann sind die Infos noch OK}
  Lizenznehmer	:Str24='';
VAR
  HGAddress	:ARRAY[0..347] OF Word;
				{Array fr die Startadressen der
				 Hercules-Rasterzeilen}
  AKT_DIR	:DirStr;	{Das aktuelle Verzeichnis}
  StartPfad	:DirStr;
Const  Benutzerabbruch=1;
       FalscheDOSVersion=2;
       KeinRAM=3;
       PopLineOverFlow=4;
       OvrFehler=5;
       DPI=longint(300); {Auflsung exportierter Ausschnitte}

PROCEDURE Fehlerabbruch(Nr:Byte);
FUNCTION MIN(a,b:Word):Word;
FUNCTION LMIN(a,b:Longint):Longint;
FUNCTION LMAX(a,b:Longint):Longint;
FUNCTION rs(r:real;l,n:Byte):string;
FUNCTION ls(l:longint):string;
FUNCTION sl(s:string):longint;
PROCEDURE si2(s:string;var a,b:integer);
FUNCTION ls0(l:longint;n:byte):string;
FUNCTION GLEICH(SuchIn,SuchWas:PathStr):BOOLEAN;
Function DateiNameGleich(a,b:String):Boolean;
FUNCTION UpChar(C:Char):Char;
FUNCTION UpStr(S:PathStr):PathStr;
FUNCTION LowStr(S:PathStr):PathStr;
Procedure Incname(var ns:string);
Function Zufall(Bereich:Word):WORD;
Function AttrString(a:Byte):Pathstr;
PROCEDURE SETTEXTSTYLE(Font,Direction,Charsize:Word);
Procedure Outstringxy(x,y:integer;s:string);
PROCEDURE SETRGBPalette(i,r,g,b:integer);
Function Grauwert(n:Integer):Integer;
Function Rlim(rmin:real;r:real;rmax:real):real;
PROCEDURE InitMonoPattern;
Procedure SetEGARGB;
Function ist_Verzeichnis(var s:pathstr):boolean;
Function IstWPGDatei(name:pathstr):Boolean;
Function IstWPCDatei(name:pathstr):Boolean;
function chdirformat(s:string):string;
function singlebackslashformat(s:string):string;
Function getLastDrive:Char;
Procedure WildCardExpand(VAR name:Pathstr;Vorgabe:Pathstr);
Procedure Setzfarbe(color:Byte);
Procedure SetzeHintergrund;

implementation

VAR n:Byte;
    es:extstr;
    s:string;


(*---------------------------------------------------------------------
		   SETTEXTSTYLE MIT ALTERNATIVEN
---------------------------------------------------------------------*)
PROCEDURE SETTEXTSTYLE(Font,Direction,Charsize:Word);
VAR gresult:Integer;
BEGIN
  gresult:=graphresult; {Zurcksetzen}
  Drehfont.settextstyle(Font,direction,charsize);
  gresult:=graphresult;

  if -gresult in [
	8, {CHR-Datei nicht gefunden}
	9, {Kein Speicher fr Font}
	11, {unbekannter Fehler}
	13] {CHR-Datei ungltig}
  THEN {Ersatzfont suchen (rekursiver Aufruf)}
  BEGIN
  {Durch irgendwas zerschiet er sich manchmal
   seinen geladenen Font, daher wird er durch die
   willkrliche nderung hier zum Nachladen gezwungen}
  Drehfont.settextstyle(SmallFont,direction,charsize);
  gresult:=graphresult;
  CASE Font of
  1: {Roman Triplex -> Roman Duplex}
     Settextstyle(8,Direction,Charsize);
  2: {Kleinschrift -> ROM-Font}
     Settextstyle(0,Direction,Charsize div 8);
  3: {Helvetica duplex -> Helvetica Simplex}
     Settextstyle(6,Direction,Charsize);
  4: {Gothic English -> Euro Style}
     Settextstyle(9,Direction,Charsize);
  5: {Script -> Roman Kursiv}
     Settextstyle(7,Direction,Charsize);
  6: {Helvetica Simplex -> Kleinschrift}
     Settextstyle(2,Direction,Charsize);
  7: {Roman Kursiv -> Roman doppelt}
     Settextstyle(8,Direction,Charsize);
  8: {Roman doppelt -> Helvetica Simplex}
     Settextstyle(6,Direction,Charsize);
  9: {Euro Style -> Kleinschrift}
     Settextstyle(2,Direction,Charsize);
  10:{Helvetica bold -> Helvetica duplex}
     Settextstyle(3,Direction,Charsize);
  END;
  END;
  gresult:=graphresult; {Zurcksetzen}
END;

(*---------------------------------------------------------------------
		   DER KLEINERE ZWEIER WORD-WERTE
---------------------------------------------------------------------*)

FUNCTION MIN(a,b:Word):Word;
BEGIN
  if a<b THEN MIN:=a ELSE MIN:=b;
END;

(*---------------------------------------------------------------------
		DER KLEINERE ZWEIER LONGINT-WERTE
---------------------------------------------------------------------*)

FUNCTION LMIN(a,b:Longint):Longint;
BEGIN
  if a<b THEN LMIN:=a ELSE LMIN:=b;
END;

(*---------------------------------------------------------------------
		DER GRSSERE ZWEIER LONGINT-WERTE
---------------------------------------------------------------------*)

FUNCTION LMAX(a,b:Longint):Longint;
BEGIN
  if a>b THEN LMAX:=a ELSE LMAX:=b;
END;

(*---------------------------------------------------------------------
		    STRING AUS REAL-ZAHL
---------------------------------------------------------------------*)

FUNCTION rs(r:real;l,n:Byte):string;
{Real nach String}
var s	:string;
BEGIN
  STR(r:l:n,s);
  RS:=s;
END;

(*---------------------------------------------------------------------
		    STRING AUS LONGINT-ZAHL
---------------------------------------------------------------------*)

FUNCTION ls(l:longint):string;
{Longint nach String}
var s	:string;
BEGIN
  STR(l,s);
  Ls:=s;
END;

(*---------------------------------------------------------------------
		    LONGINT-ZAHL AUS STRING
---------------------------------------------------------------------*)

FUNCTION sl(s:string):longint;
var L:Longint;
    Valcode:Integer;
BEGIN
  VAL(s,l,valcode);
  If Valcode=0 then sL:=L else sl:=0;
END;

(*---------------------------------------------------------------------
		    ZWEI INTEGER-ZAHLEN AUS STRING
---------------------------------------------------------------------*)

PROCEDURE si2(s:string;var a,b:integer);
VAR i,ValCode:Integer;
BEGIN
   {Ein beliebiges Trennzeichen ist zwischen Fontnummer und -Gre
    zugelassen. Die Position wird mit VAL ermittelt}
   VAL(s,a,Valcode);
   If ValCode=0          {Kein zweiter Parameter}
   then b:=0             {Standard}
   else
   begin
     i:=Valcode; {Wo ist das Trennzeichen?}
     VAL(copy(s,1,i-1),a,valcode);
     VAL(copy(s,i+1,255),b,valcode);
   end;
END;


(*---------------------------------------------------------------------
	    STRING AUS LONGINT-ZAHL MIT FHRENDEN NULLEN
---------------------------------------------------------------------*)

FUNCTION ls0(l:longint;n:byte):string;
{Longint nach String mit n Stellen, fhrende Nullen werden gesetzt.}
var s	:string;
BEGIN
  STR(l,s);
  while length(s)<n do s:='0'+s;
  Ls0:=s;
END;

(*---------------------------------------------------------
  GLEICH Stellt fest, ob der Dateiname SUCHWAS mit dem
  Dateinamen SUCHIN bereinstimmt.
  SUCHWAS darf Wildcards enthalten.
---------------------------------------------------------*)
FUNCTION GLEICH(SuchIn,SuchWas:PathStr):BOOLEAN;
VAR n,m		:Byte;
    BisjetztGleich	:Boolean;
BEGIN
  SuchWas[Length(Suchwas)+1]:=' ';

  if SuchWas[1]='.' then delete(SuchWas,1,1);
  if SuchIn[1]='.' then delete(SuchIn,1,1);

  If (SuchWas='') or (Suchwas='*') Then
  BEGIN
    GLEICH:=TRUE;EXIT;
  END;

  n:=1;
  While (n<=length(SuchIn)) or (n<=length(SuchWas)) do
  BEGIN
  CASE CHAR(suchWas[n]) of
  '?':  INC(n);
  '*':  BEGIN
       {Die folgende Zeile soll den Sonderfall erschlagen, da
        ein '*' auch fr einen Leerstring zutrifft}
       BisJetztGleich:=(Length(SuchIn)<n) and (length(Suchwas)=n);
       FOR M:=n to length(SuchIn) do
       BisJetztGleich:=
           BisJetztGleich
           {Eine Prise Rekursion...}
        OR Gleich(Copy(SuchIn,m,255),Copy(SuchWas,n+1,255));
       Gleich:=BisjetztGleich;
       EXIT;
     END;

  ELSE  if  (n<=length(SuchWas))
     and (n<=length(SuchIn))
     and (SuchWas[n]=SuchIn[n])
     Then inc(n)
     ELSE BEGIN
          GLEICH:=FALSE;
          EXIT;
          END;
  END; {CASE}
  END; {While}
  Gleich:=TRUE; {Nun ist n>length(suchIn) und n>length(SuchWas)}
END;

(*---------------------------------------------------------------------
		   VERGLEICH ZWEIER DATEINAMEN
---------------------------------------------------------------------*)

Function DateiNameGleich(a,b:String):Boolean;
{a darf wildcards enthalten}
VAR p,n1,x1,n2,x2	:string;
BEGIN
  fsplit(a,p,n1,x1);
  if x1='.' then x1:='. ';
  fsplit(b,p,n2,x2);
  DateiNameGleich:=Gleich(n2,n1)and Gleich(x2,x1);
END;


(*---------------------------------------------------------------------
	   STRING MIT UMLAUTEN IN GROSSBUCHSTABEN WANDELN
---------------------------------------------------------------------*)

FUNCTION UpChar(C:Char):Char;
BEGIN
    IF
      C<#128 then C:=Upcase(C)
    ELSE
      CASE C of
       '':C:='';
       '':C:='';
       '':C:='';
      END;
  UpChar:=C;
END;


FUNCTION UpStr(S:PathStr):PathStr;
VAR N	:Byte;
BEGIN
  FOR N:=1 to Length(s) do s[n]:=UpChar(s[n]);
  UpStr:=s;
END;

(*---------------------------------------------------------------------
	   STRING MIT UMLAUTEN IN KLEINBUCHSTABEN WANDELN
---------------------------------------------------------------------*)


FUNCTION LowStr(S:PathStr):PathStr;
VAR N	:Byte;
BEGIN
  FOR N:=1 to Length(s) do
    IF
      (s[n]>='A') and (s[n]<='Z') then inc(s[n],byte('a')-byte('A'))
    ELSE
      CASE Char(s[n]) of
       '':s[n]:='';
       '':s[n]:='';
       '':s[n]:='';
      END;
  LowStr:=s;
END;

(*---------------------------------------------------------------------
	    Dateinamen mit Nummer ergnzen, evtl. hochzhlen.
----------------------------------------------------------------------*)

Procedure Incname(var ns:string);
var       i:byte;
  fertig:Boolean;
begin
while length(ns)<8 do ns:=ns+'0';
i:=8;
fertig:=false;
repeat
  if ns[i] in ['0'..'8'] then
   begin
    inc(ns[i]);
    fertig:=true;
   end
  else
   if ns[i]='9' then
    begin
      ns[i]:='0';
      if i>1 then dec(i) else fertig:=true;
    end
   else
    begin
     ns[i]:='0';
     fertig:=true;
    end;
until fertig;
end;

(*---------------------------------------------------------------------
	    Zufallsfunktion ohne direkte Wiederholung.
----------------------------------------------------------------------*)

Function Zufall(Bereich:Word):WORD;
Const Alt:word=0;
Var Z:Word;
BEGIN
  If   Bereich=1
  Then Z:=1
  ELSE REPEAT Z:=Random(Bereich)+1 UNTIL Z<>Alt;
  Zufall:=Z;
  Alt:=Z;
END;

(*---------------------------------------------------------------------
		    Attributbyte als String darstellen.
----------------------------------------------------------------------*)

Function AttrString(a:Byte):Pathstr;
VAR s:Pathstr;
  Function MitKomma(S:PathStr):PathStr;
  begin
    if s='' Then Mitkomma:=''
    else MitKomma:=s+', ';
  end;

BEGIN
  S:='';
  IF (A and SYSFILE   )<>0 THEN s:=MitKomma(s)+'Systemdatei';
  IF (A and ARCHIVE   )<>0 THEN s:=MitKomma(s)+'unarchiviert';
  IF (A and HIDDEN    )<>0 THEN s:=MitKomma(s)+'versteckt';
  IF (A and READONLY  )<>0 THEN s:=MitKomma(s)+'schreibgeschtzt';
  IF (A and $40       )<>0 THEN s:=MitKomma(s)+'(6)';
  IF (A and $80       )<>0 THEN s:=MitKomma(s)+'(7)';
  IF s='' Then s:='keine';
  AttrString:=S+'.';
END;

(*---------------------------------------------------------------------
	   Editierbare Textausgabe mit definierter Breite:
---------------------------------------------------------------------*)
Procedure Outstringxy(x,y:integer;s:string);
VAR n:Byte;
    T:TextSettingstype;
begin
  gettextsettings(T);
  MoveTo(x,y);
  {Wenn nicht jedes Zeichen einzeln ausgegeben wird,
   stimmt TextWidth nicht!}
  if (t.horiz=lefttext) and (t.direction=horizdir)
  then
    for n:=1 to length(s) do graph.Outtext(s[n])
  else graph.outtext(s);
end;

(*---------------------------------------------------------------------
	       ABGEFANGENER ABBRUCH DES PROGRAMMS
---------------------------------------------------------------------*)

PROCEDURE Fehlerabbruch(Nr:Byte);
var frei1,frei2,frei3:longint;
BEGIN
  exitproc:=NIL;
  frei1:=memavail;
  CloseGraph;
  Restorecrtmode;
  NormVideo;
  Window(1,1,80,25);
  ClrScr;
  If not (Hercules or egagefunden) Then Setborder(Bordersave);
  Writeln(Programmname,' wurde abgebrochen.');
  Writeln;
  frei3:=memavail;

  CASE Nr of
  Benutzerabbruch:
     Writeln('Abbruch erfolgte durch Benutzer.');
  FalscheDOSVersion:
     begin
     Writeln('Dieses Programm bentigt DOS 3.3 oder eine neuere Version.');
     Writeln('Ihr Betriebssystem identifiziert sich mit: "Version ',lo(dosversion),
	     '.',hi(dosversion),'".');
     end;
  KeinRam:
     BEGIN
	Writeln('Zuwenig freier Speicher!');
	Writeln;
	Writeln('       Verfgbarer Speicher: ',frei3:6,' Byte');
	Writeln('  Fr Grafiktreiber benutzt: ',frei3-frei1:6,' Byte');
	Writeln('----------------------------------------');
	Writeln('Freier Speicher bei Abbruch: ',frei1:6,' Byte');
     END;
  PopLineOverFlow:
     BEGIN
	Writeln('Interner Fehler: Zuviele Zeilen im Pop-up-Fenster.');
     END;
  Ovrfehler:
     BEGIN
	writeln('Zugriff auf Overlay-Datei "',EXENAME,'.OVR" nicht mglich!');
     END;
  end;
  Writeln;
  Chdir(StartPfad);
  Halt(Nr);
END;


(*---------------------------------------------------------------------
	   SETZEN DER RGB-PALETTE FR ALLE GRAFIKKARTEN
---------------------------------------------------------------------*)

PROCEDURE SETRGBPalette(i,r,g,b:integer);
{R, G und B sind gltig von von 0 bis 255!}
{Bei Monochrom- oder Farbdithering werden die Farbwerte nur gespeichert,
 jedoch nicht in die Karte geschrieben. An anderer Stelle sind die Farben
 0, 1 und getmaxcolor dann auf schwarz und wei zu setzen}
BEGIN
  rgbPalette[i,1]:=r;
  rgbPalette[i,2]:=g;
  rgbPalette[i,3]:=b;

  if monochrom or zuvielefarben then EXIT;

  if ausblenden then
  begin
    if (i<16) and not egagefunden then setpalette(i,i);
  end
  else
  if i<=getmaxcolor then
  begin
    if (i<16) and not egagefunden then setpalette(i,i);
    if vgakarte then outrgbpalette(i,r shr 2,g shr 2,b shr 2)
    else
    if egagefunden then
      setpalette(i,wasegargb(r,g,b,FALSE)) {FALSE: alte Graustufenoption}
    else
      graph.setrgbpalette(i,r shr 2,g shr 2,b shr 2);
  end;
END;

Function Grauwert(n:Integer):Integer;
begin
  GrauWert:=round(0.1*sqrt(
		  longint(rofak)*RGBPalette[n,1]*RGBPalette[n,1]
		 +longint(grfak)*RGBPalette[n,2]*RGBPalette[n,2]
		 +longint(blfak)*RGBPalette[n,3]*RGBPalette[n,3]));
end;


Function Rlim(rmin:real;r:real;rmax:real):real;
{Stutzt Real-Zahl in Intervall}
begin
  if r<rmin then rlim:=rmin
  else
  if r>rmax then rlim:=rmax
  else
  rlim:=r;
end;

Procedure initMonoPattern;
var i,j,n:Byte;
    f:integer;
BEGIN
for n:=0 to 64 do
  begin
    f:=round(255.0*n/63);
    for i:=0 to 7 do
    begin
     MonoPattern[n][i+1]:=0;
     for j:=0 to 7 do
      inc(MonoPattern[n][i+1],ord(f>DiMat^[i,j])shl j);
    end;
  end;
END;

Procedure SetEGARGB;
BEGIN
  setrgbpalette(0,0,0,0);
  setrgbpalette(1,0,0,170);
  setrgbpalette(2,0,170,0);
  setrgbpalette(3,0,170,170);
  setrgbpalette(4,170,0,0);
  setrgbpalette(5,170,0,170);
  setrgbpalette(6,170,85,0);
  setrgbpalette(7,170,170,170);
  setrgbpalette(8+0,85+0,85+0,85+0);
  setrgbpalette(8+1,85+0,85+0,85+170);
  setrgbpalette(8+2,85+0,85+170,85+0);
  setrgbpalette(8+3,85+0,85+170,85+170);
  setrgbpalette(8+4,85+170,85+0,85+0);
  setrgbpalette(8+5,85+170,85+0,85+170);
  setrgbpalette(8+6,85+170,85+170,85+0);
  setrgbpalette(8+7,85+170,85+170,85+170);
END;

(*---------------------------------------------------------------------
			TEST AUF VERZEICHNIS
----------------------------------------------------------------------*)
Function ist_Verzeichnis(var s:pathstr):boolean;
var cd:dirstr;
begin
  if s[length(s)]='\' then dec(s[0]);
  getdir(0,cd);
  {if ioresult<>0 then; {Dummy wegen Geister-103}
  chdir(s);
  ist_verzeichnis:=ioresult=0;
  chdir(cd);
end;


Function IstWPGDatei(name:pathstr):Boolean;
label fehler;
var f:File;
var header:WPCHeadertyp;
BEGIN
  istwpgdatei:=false;
  assign(f,name);
  filemode:=0;
  reset(f,1); if ioresult<>0 then goto fehler;
  blockread(f,header,16);
  with header do
  IstWPGDatei:= (wpcid=#255'WPC')
	    and (prtyp=1)
	    and (fltyp=$16)
            and (maver=1)  {WordPerfect 5.0 und 5.1}
	    and (enkey=0)
	    and (ioresult=0);
  close(f); if ioresult<>0 then goto fehler;
fehler:
  filemode:=2;
END;

Function IstWPCDatei(name:pathstr):Boolean;
label fehler;
var f:File;
var header:WPCHeadertyp;
BEGIN
  istwpcdatei:=false;
  assign(f,name);
  filemode:=0;
  reset(f,1); if ioresult<>0 then goto fehler;
  blockread(f,header,16);
  with header do
  IstWPCDatei:= (wpcid=#255'WPC')
	    and (ioresult=0);
  close(f); if ioresult<>0 then goto fehler;
fehler:
  filemode:=2;
END;

function chdirformat(s:string):string;
{DummDOS-Patch!
 CHDIR verbietet ein angehngtes "\":
 "CHDIR C:\DOS" ist korrekt, "CHDIR C:\DOS\"
 fhrt zu einer Fehlermeldung. Um ins Wurzelverzeichnis
 zu wechseln, MUSS der "\" aber vorhanden sein! "CHDIR C:\"}
begin
if ((length(s)>3) or (s[2]<>':')) and (s[length(s)]='\') then dec(s[0]);
chdirformat:=s;
end;

function singlebackslashformat(s:string):string;
{DummDOS-Patch!
 Normalerweise ignoriert DOS doppelte "\",
 bei RENAME kommt aber eine Fehlermeldung!}
var n:Byte;
begin
repeat
n:=pos('\\',s);
if n>0 then delete(s,n,1);
until n=0;
singlebackslashformat:=s;
end;


Function getLastDrive:Char;
VAR
s,startpfad:pathstr;
ok:Boolean;
BEGIN
  if ioresult<>0 then;
  GetDir(0,Startpfad);
  LastDrive:='B';
  OK:=TRUE;
  REPEAT
    INC(LastDrive);
    GETDIR(ORD(LastDrive)-64,s);
    IF IORESULT=0 THEN CHDIR(LastDrive+':\') ELSE OK:=FALSE;
    IF IORESULT<>0 THEN BEGIN OK:=FALSE;DEC(LastDrive) END;
  UNTIL not OK;
  CHDIR(chdirformat(StartPfad));
  GetLastDrive:=LastDrive;
END;

Procedure WildCardExpand(VAR name:Pathstr;Vorgabe:Pathstr);
VAR i:Integer;
    nd,vd:dirstr;
    nn,vn:namestr;
    ne,ve:extstr;
BEGIN
  fsplit(name,nd,nn,ne);
  fsplit(vorgabe,vd,vn,ve);
  i:=pos('*',nn);
  if i>0 then
  begin
    delete(nn,i,1);
    while length(vn)>length(nn) do insert('?',nn,i);
  end;
  if ne='' then ne:='.*';
  i:=pos('*',ne);
  if i>0 then
  begin
    delete(ne,i,1);
    while length(ve)>length(ne) do insert('?',ne,i);
  end;
  for i:=1 to length(nn) do
    if (nn[i]='?') and (i<=length(vn)) then nn[i]:=vn[i];
  for i:=1 to length(ne) do
    if (ne[i]='?') and (i<=length(ve)) then ne[i]:=ve[i];
  name:=nd+nn+ne;
END;

(*---------------------------------------------------------------------
		  SETCOLOR AUCH FR MONOCHROM
---------------------------------------------------------------------*)

Procedure Setzfarbe(color:Byte);
BEGIN
  IF MonoChrom THEN
    if graustufen then
      setcolor(0)
      {WP-konform}
    else
      setcolor(ord(GrauPalette[Color]>207)*getmaxcolor)
      {  Ganz helles bleibt wei, weil ich es hbscher finde.
       WordPerfect dagegen malt immer schwarze Linien, was
       manchmal unmglich aussieht. Wer sehen will, wie das Druck-
       bild aussieht, sollte sowieso die Graustufenoption einge-
       schaltet lassen.
	 207 ist die hchste Farbnummer, die von WP selbst noch
       gerastert wird. Alle Farben ab 208 bleiben bei BitMaps wei.}
  ELSE
    setcolor(color);
END;

(*---------------------------------------------------------------------
		     HINTERGRUNDMUSTER SETZEN
---------------------------------------------------------------------*)
Procedure SetzeHintergrund;
BEGIN
  IF HGreduziert THEN
    IF getmaxcolor=1 THEN
      BEGIN
	HGMuster:=closedots;
	HGFarbe:=GetMaxColor;
      END
    ELSE
      BEGIN
	HGMuster:=fulldots;
	HGFarbe:=LightGray;
	IF NOT palignore THEN Graph.SetRGBPalette(7,170,170,170);
      END
  ELSE
    BEGIN
      HGMuster:=FullDots;
      HGFarbe:=GetMaxColor;
    END;
  SetFillpattern(hgmuster,hgfarbe);
END;

(*---------------------------------------------------------------------
  FR SCHNELLEN HERCULES-BILDAUFBAU EIN FELD MIT BILDSCHIRMADRESSEN
---------------------------------------------------------------------*)

PROCEDURE InitHG;
   VAR i	:Word;
BEGIN
  FOR i := 0 TO 347 DO
    HGAddress[i] := (i AND 3) SHL 13 + (i SHR 2) * 90;
END;


begin
  if 256*lo(dosversion)+hi(dosversion)<3*256+3 then fehlerabbruch(FalscheDosVersion);
  GetDir(0,StartPfad);
  FSPLIT(fexpand(paramstr(0)),Programmpfad,ExeName,es);
  INITHG;
end.
