{$A+,B-,D+,E+,F+,I-,L+,N+,O+,R-,V-,X+}
Unit VIEWslin;
{Texteingaben in der Statuszeile}

Interface
Type Dateinamentyp=String[12];

FUNCTION JaneinSL:Boolean;
FUNCTION inputSL(var s:string;Hilfstext:Integer):BOOLEAN;
PROCEDURE INPUTINFO(name:Dateinamentyp;var infdatvorh:Boolean);
PROCEDURE Hole_Breitenfaktor;
PROCEDURE Hole_Linienbreite;
PROCEDURE Hole_Font(VAR FontNr,Charsize:Integer);
PROCEDURE Hole_FontNr(VAR FontNr:integer);
Procedure TestBild;

Implementation uses popwin,graph,dos,crt,VIEWprim,maus,viewsl;
VAR inf:text;

(*---------------------------------------------------------------------
		  JA/NEIN-ABFRAGE IN DER STATUSZEILE
---------------------------------------------------------------------*)

FUNCTION JaneinSL:Boolean;
VAR c:Char;
BEGIN
  WriteSL('? Ja (Nein) ',false);
  repeat
    c:=Upcase(Readkey);
    EscapeGedrueckt:=c=#27;
    if c in [#27,'0','-'] then c:='N';
    if c in [#13,'1','+','Y','O','S'] then c:='J';
  until c in['J','N'];
  if c='J' then
  begin
    janeinsl:=true;
    writesl('JA',false);
  end
  else
  begin
    janeinsl:=false;
    writesl('NEIN',false);
  end;
END; {JaNeinSL}

(*---------------------------------------------------------------------
		 STRINGEINGABE IN DER STATUSZEILE
---------------------------------------------------------------------*)

FUNCTION inputSL(var s:string;Hilfstext:Integer):BOOLEAN;
var zeichen,z2:char;
    alts:string;
    ch,		{Cursorhhe}
    cp:integer; {CursorPosition im String}
    x:integer; {CursorPosition in Pixeln}
    vp:Viewporttype;
var nichtseingegeben:boolean;

  procedure zeigzeile;
  {Alten Inhalt an Cursorpos lschen (TH als Zuschlag fr evtl.
   gerade gelschtes Zeichen und neuen String ausgeben}
    begin
      bar(x,1,x+TextWidth(copy(s,cp,255))+th,getmaxy-maxy);
      outstringxy(x,2,copy(s,cp,255));
    end;

  procedure cursor;
  var b:byte;
      x1:integer;
    begin
      b:=th div 4; {Seitlicher berstand}
      x1:=x-1; {x-Position}
      setwritemode(xorput);
      setcolor(getmaxcolor);
      line(x1,1,x1,ch);
      line(x1-b,1,x1+b,1);
      line(x1-b,ch,x1+b,ch);
      setwritemode(normalput);
      setcolor(0);
      line(0,1,0,1); {Damit Hargraves SVGA256-Treiber das NormalPut mitkriegt!}
    end;

begin
  getviewsettings(vp);
  setviewport(0,maxy+1,getmaxx,getmaxy,true);
  ch:=getmaxy-maxy-2; {Cursorhhe}
  nichtseingegeben:=true;


  alts:=s; {Inhalt sichern, falls Ausgang mit ESC}

  {Ganz wichtiger Hinweis: OUTstringXY ist meine eigene Routine,
   die die Zeichen des Strings einzeln ausgibt. GRAPH.OUTTEXTXY
   liefert nicht dieselbe Breite wie TEXTWIDTH, so da eine
   Lokalisierung der einzelnen Zeichen unmglich wird.}

  outstringxy(SL_Xpos,2,s);
  x:=getx; {Position des nchsten zu schreibenden Zeichens}
  cp:=length(s)+1;

  repeat
    if not nichtseingegeben then cursor;

    repeat
    until keypressed or mausda and (leftmousebutton or rightmousebutton);

    if mausda and (leftmousebutton or rightmousebutton)
    then zeichen:=#13
    else zeichen:=readkey;

    if not nichtseingegeben then cursor;

    case zeichen of
      #32..#255:
	begin
	if nichtseingegeben then
	  begin
	    x:=SL_XPos;
	    cp:=1;
	    bar(x,1,x+TextWidth(s),getmaxy-maxy);
	    s:='';
	    nichtseingegeben:=false;
	  end;
	insert(zeichen,s,cp);
	zeigzeile;
	inc(x,textwidth(zeichen));
	inc(cp);
	end;
      ^H: if cp>1 then
	begin
	nichtseingegeben:=false;
	dec(cp);
	dec(x,TextWidth(s[cp]));
	delete(s,cp,1);
	zeigzeile;
	end;
      #0: begin
	    nichtseingegeben:=false;
	    zeichen:=readkey;
	    while keypressed do Escapegedrueckt:=readkey=#27;
	    case zeichen of
	    #59: {F1}
		InputHilfe(Hilfstext);
	    #75: {links}
		if cp>1 then
		begin
		  dec(cp);
		  dec(x,textwidth(s[cp]));
		end;
	    #77: {rechts}
		if cp<=length(s) then
		begin
		  inc(x,textwidth(s[cp]));
		  inc(cp);
		end;
	    #83: {entf.}
		begin
		  delete(s,cp,1);
		  zeigzeile;
		end;
	    #117: {Ctrl-End}
		begin
		  bar(x,1,x+TextWidth(copy(s,cp,255)),getmaxy-maxy);
		  s[0]:=char(cp-1);
		end;
	    #71: {Home}
		begin
		  cp:=1;
		  x:=SL_Xpos;
		end;
	    #79: {End}
		begin
		  cp:=length(s)+1;
		  x:=SL_Xpos+textwidth(s);
		end;
	    end;
	    zeichen:=#0;
	  end;
      #27: s:=alts;
    end; {case}
  until zeichen in [#13,#27];
  InputSL:=Zeichen=#13;
  inc(SL_xpos,textwidth(s));
  with vp do setviewport(x1,y1,x2,y2,clip);
end;

(*---------------------------------------------------------------------
			  INFO-ZEILE EINGEBEN
---------------------------------------------------------------------*)
PROCEDURE INPUTINFO(name:Dateinamentyp;Var infdatvorh:Boolean);
label fehler;
var s,z:string;
    gefunden:boolean;
    aus:text;
    einpuf,auspuf:^puffertyp;
    maxpuf:word;

BEGIN
  maxpuf:=lmin(maxavail div 2,sizeof(puffertyp));
  getmem(einpuf,maxpuf);
  getmem(auspuf,maxpuf);

  assign(inf,ProgrammPfad+exename+'.INF');
  if maxpuf>128 then settextbuf(inf,einpuf^,maxpuf);
  if ioresult<>0 then;
  reset(inf);
  if ioresult<>0 then
  begin
    rewrite(inf);
    Writeln(inf,exename,'.EXE');
    Writeln(inf,'Copyright (c) 1990-1993 by Martin Vogel');
    close(inf);
    reset(inf);
  end;

  assign(aus,ProgrammPfad+'$KAPUTT$.$$$');
  if maxpuf>128 then settextbuf(inf,auspuf^,maxpuf);
  rewrite(aus);
  if ioresult<>0 then
  begin
    Writesl('Fehler beim Schreibzugriff!',true);
    close(inf); if ioresult<>0 then;
    goto fehler;
  end;

  s:='';
  repeat
    readln(inf,s); if ioresult<>0 then;
    readln(inf,z);
    gefunden:=name=s;
    if not gefunden then
    begin
      writeln(aus,s);
      writeln(aus,z);
    end;
  until (ioresult<>0) or eof(inf) or gefunden;

  if not gefunden then z:='';

  writesl('Info: ',true);
  inputsl(z,1);

  if z<>'' then
  begin
    writeln(aus,name);
    writeln(aus,z);
  end;

  while not eof(inf) do
  begin
    readln(inf,s);
     if ioresult=0 then
     begin
      readln(inf,z);
      if ioresult=0 then
      begin
	writeln(aus,s);
	writeln(aus,z);
      end;
     end;
  end;

  close(inf);
  close(aus);

  erase(inf);
  rename(aus,ProgrammPfad+exename+'.INF');
  infdatvorh:=TRUE;
Fehler:
  FREEMEM(einpuf,maxpuf);
  FREEMEM(auspuf,maxpuf);
END;

(*---------------------------------------------------------------------
		    NEUEN BREITENFAKTOR EINGEBEN
---------------------------------------------------------------------*)

PROCEDURE Hole_Breitenfaktor;
var s:string;
    bp:Longint;
    valcode:word;
BEGIN
  bp:=Breitenfaktor;
  s:=ls(bp);
  WRITESL('Neuer X-Faktor: ',TRUE);
  IF InputSL(s,2)
  THEN
  BEGIN
   val(s,bp,valcode);
   if valcode=0 then Breitenfaktor:=lmax(lmin(bp,100000),1000)
   else BreitenFaktor:=10000;
   WRITESL('Neuer X-Faktor: '+ls(Breitenfaktor),TRUE);
   if (valcode<>0) or (bp<1000) or (bp>100000)
   then
     begin
       writesl(' (mu zwischen 1000 und 100000 sein!)',false);
       delay(2000);
     end;
  END;  {Wenn InputSL nicht mit ESC abgebrochen wurde}
END; {Hole_Breitenfaktor}


(*---------------------------------------------------------------------
		 NEUE BREITE FR ALLE LINIEN EINGEBEN
---------------------------------------------------------------------*)

PROCEDURE Hole_Linienbreite;
var s:string;
    lb:longint;
    valcode:word;
BEGIN
  lb:=Linienbreite;
  s:=ls(lb);
  WRITESL('Neue Linienbreite in WPU (1..10000, 0=Standard): ',TRUE);
  IF InputSL(s,3)
  THEN
  BEGIN
   val(s,lb,valcode);
   if valcode=0 then Linienbreite:=lmax(lmin(lb,10000),0)
   else Linienbreite:=0;
   WRITESL('Neue Linienbreite: '+ls(Linienbreite),TRUE);
   if (valcode<>0) or (lb<0) or (lb>10000)
   then
     begin
       writesl(' (mu zwischen 0 und 10000 sein!)',false);
       delay(2000);
     end;
  END;  {Wenn InputSL nicht mit ESC abgebrochen wurde}
END; {Hole_Linienbreite}



(*---------------------------------------------------------------------
			  NEUEN FONT WHLEN
---------------------------------------------------------------------*)

PROCEDURE Hole_Font(VAR FontNr,Charsize:Integer);
var s:string;
    bp:Longint;
    valcode:word;
BEGIN
  bp:=Fontnr;
  s:=ls(bp);
  WRITESL('Neuer Font (0..10): ',TRUE);
  IF InputSL(s,4)
  THEN
  BEGIN
   val(s,bp,valcode);
   if valcode=0 then FontNr:=lmax(lmin(bp,10),0);
  END;  {Wenn InputSL nicht mit ESC abgebrochen wurde}
  bp:=CharSize;
  s:=ls(bp);
  WRITESL('Neue Gre (0..99): ',TRUE);
  IF InputSL(s,4)
  THEN
  BEGIN
   val(s,bp,valcode);
   if valcode=0 then CharSize:=lmax(lmin(bp,99),0);
  END;  {Wenn InputSL nicht mit ESC abgebrochen wurde}
END; {Hole_Font}

(*---------------------------------------------------------------------
			  NEUEN FONT WHLEN
---------------------------------------------------------------------*)

PROCEDURE Hole_FontNr(VAR FontNr:integer);
var s:string;
    bp:Longint;
    valcode:word;
BEGIN
  bp:=Fontnr;
  s:=ls(bp);
  WRITESL('Stil (1..10): ',TRUE);
  IF InputSL(s,4)
  THEN
  BEGIN
   val(s,bp,valcode);
   if valcode=0 then FontNr:=lmax(lmin(bp,10),0);
  END;  {Wenn InputSL nicht mit ESC abgebrochen wurde}
END; {Hole_FontNr}


(*---------------------------------------------------------------------
			       TESTBILD
---------------------------------------------------------------------*)

Procedure TestBild;
Var N,
    xa,ya,xm,ym:word;
    xy:double;
    zeichen,zeichen2:char;

BEGIN
  xm:=maxx div 2;
  ym:=maxy div 2;
  SetEGARGB;

REPEAT
  SetViewport(0,0,maxx,maxy,true);
  SetLineStyle(SolidLn,0,1);
  Setfillstyle(SolidFill,HgFarbe);
  BAR(0,0,maxx,maxy);
  Getaspectratio(xa,ya);
  xy:=0.0001/xa*Breitenfaktor*ya;
  SetColor(0);
  Graph.Ellipse(xm,ym,0,360,round(maxy*xy/2),maxy div 2);
  Writesl('TESTBILD   Mit [Strg-F] knnen Sie den Breitenfaktor korrigieren.',true);
  if getmaxcolor=255 then
  begin
    SetLineStyle(SolidLn,0,3);
    for n:=254 downto 16 do if not keypressed then
    begin
      setcolor(n);
      {Durch die Sinus-Funktion werden die Farbbergnge
       wundervoll weich und sind fast gar nicht mehr zu
       erkennen!}
      setrgbpalette(n,round(127+127*sin((-55.0+n+80)*pi/119.5)),
		      round(127+127*sin((-55.0+n+160)*pi/119.5)),
		      round(127+127*sin((-55.0+n+0)*pi/119.5)));
      line(xm,ym,xm+round(0.5*xy*maxy*sin(n*pi/119.5)),
		 ym+round(0.5*maxy*cos(n*pi/119.5)));
    end;
    SetLineStyle(SolidLn,0,1);
  end
  else
  for n:=1 to 12 do if not keypressed then
  BEGIN
    line(xm-round(25*xy),ym-n*2,xm+round(25*xy),ym+n*2);
    line(xm-round(n*2*xy),ym-25,xm+round(n*2*xy),ym+25);
  END;
  if getmaxcolor=255 then
  begin
  setcolor(15);
  setlinestyle(solidln,0,3);
  for n:=1 to maxy div 50 do if not keypressed then
  BEGIN
    Graph.Ellipse(xm,ym,0,360,round(n*25*xy),n*25);
    Rectangle(xm-round(n*25*xy),ym-n*25,xm+round(n*25*xy),ym+n*25);
  END;
  setcolor(0);
  setlinestyle(solidln,0,1);
  end;
  for n:=0 to 15 do if not keypressed then
  BEGIN
    Setfillstyle(SolidFill,n);
    BAR(round(maxx/16.0*n),maxy*7 div 10,
	round(maxx/16.0*(n+1)),maxy*9 div 10);
    BAR(round(maxx/16.0*(15-n)),maxy div 10,
	round(maxx/16.0*(16-n)),maxy*3 div 10);
  END;
  for n:=1 to maxy div 50 do if not keypressed then
  BEGIN
    Graph.Ellipse(xm,ym,0,360,round(n*25*xy),n*25);
    Rectangle(xm-round(n*25*xy),ym-n*25,xm+round(n*25*xy),ym+n*25);
  END;
  zeichen:=readkey;
  ende:=false;
  Case Zeichen of
    ^F: Hole_BreitenFaktor;
    #0: begin
	  zeichen2:=readkey;
          case Zeichen of
          #59: {F1} TestBildHilfe;
	  else ende:=true;
          end;
	end;
    else ende:=true;
  end;
until ende;
Zeichnungbegonnen:=true;
SetViewport(0,0,getmaxx,getmaxy,false);
END;

begin end.


