{$A+,B-,D+,E+,F+,I-,L+,N+,O+,R-,V-,X+}
Unit WPGPaint; {ZEIGWPG 5.50}

interface uses dos;
{$IFOPT N+} TYPE REAL=DOUBLE;
{$ENDIF}
VAR
    AusSchnt_x1,
    AusSchnt_x2,
    AusSchnt_y1,
    AusSchnt_y2 :WORD;		{Ausschnittfenster ndert sich nicht}

const malfarbe:integer=0;
const linx1:Integer=0; {Lineal}
const liny1:Integer=0; {Lineal}
const linx2:Integer=0; {Lineal}
const liny2:Integer=0; {Lineal}
const LinealBenutzen:Boolean=False;

Procedure Rahmenangleichen(VAR x1,y1,x2,y2:Integer);
Procedure Rahmenangleichen2(VAR x1,y1,x2,y2:Integer);
Procedure Stempel(var x1,y1,x2,y2:Integer);
Procedure QWGEinfuegen(qwgname:pathstr;
		       var x1,y1,x2,y2:Integer);
Procedure Faerben(var x1,y1,x2,y2,von,bis,neu:Integer);
Procedure Malen(var x1,y1,x2,y2,malfarbe:Integer);
Procedure Wintext(var x1,y1,x2,y2:Integer;
		  malfarbe:Integer;
		  stil,Richtung:Integer;
		  Zeile:String);
Procedure Heller(var x1,y1,x2,y2:integer;maxfarbe:Integer);
Procedure Dunkler(var x1,y1,x2,y2:integer;maxfarbe:Integer);
Procedure Weichzeichner(var x1,y1,x2,y2,fv,fb:Integer);
PROCEDURE UpDateRaehmchen(VAR x1,y1,x2,y2:INTEGER);
procedure farbleiste(maxfarbe:integer;
		     var breite,offset:integer;
		     var farbleisteneu:Boolean);
Procedure Fadenkreuz(x,y:word);
PROCEDURE MausFadenKreuz(var x,y,n:integer);
FUNCTION Hole_Raehmchen(var x1,y1,x2,y2:integer;
			 modus:integer):Boolean;
Procedure Palette_aendern(Dateiname:PathStr;PalPos:LongInt;
			  PalFirst,PalFarben:Integer);
Procedure Bildausschnitt(maxfarbe:integer;
			 clipboardzwang,AusHauptMenue:boolean;
			 dir:dirstr;originalname:namestr);

implementation
uses
	maus,
	graph,
	viewprim,
	crt,
	viewsl,
	viewslin,
	qwgio,
	popwin,
	grexport,
	disk,
	vgabios,
	wpshell,
	wpgview;

var szeile:string;
    dx,dy:Integer;

Procedure Raehmchen(x1,y1,x2,y2:integer);
begin
    setlinestyle(solidln,0,normwidth);
    setwritemode(xorput);
    setcolor(getmaxcolor);
    rectangle(x1-1,y1-1,x2+1,y2+1);
    setwritemode(normalput); line(0,maxy+1,0,maxy+1); {HARGRAVE!}
end;


PROCEDURE UpDateRaehmchen(VAR x1,y1,x2,y2:INTEGER);
{Das Rhmchen bei Stempel, Weichzeichner usw. ist ein Pixel grer
 als der aktive Ausschnitt}
VAR bx,hy,dx,dy,x0,y0:integer;
BEGIN
  mouse_motion(dx,dy);
  {Wenn die Maus bewegt wurde, Rhmchen nachfhren:}
  if (dx<>0) or (dy<>0) then
  BEGIN
    bx:=x2-x1;
    hy:=y2-y1;
    Raehmchen(x1,y1,x2,y2);
    inc(x2,dx); inc(y2,dy);
    inc(x1,dx); inc(y1,dy);
    if linealbenutzen then
    begin
      if abs(liny2-liny1)<abs(linx2-linx1)
      then
      begin {flach}
	x0:=x1+bx div 2;
	if linx2=linx1
	then y0:=liny1
	else y0:=liny1+round((x0-linx1)/(linx2-linx1)*(liny2-liny1));
      end
      else
      begin {steil}
	y0:=y1+hy div 2;
	if liny2=liny1
	then x0:=linx1
	else x0:=linx1+round((y0-liny1)/(liny2-liny1)*(linx2-linx1));
      end;
      x1:=x0-bx div 2;
      x2:=x1+bx;
      y1:=y0-hy div 2;
      y2:=y1+hy;
    end; {Linealbenutzen}

    {Rohes Clipping ohne Linealbercksichtigung}
    x1:=min(lmax(0,x1),maxx);
    x2:=min(lmax(0,x2),maxx);
    y1:=min(lmax(0,y1),maxy);
    y2:=min(lmax(0,y2),maxy);

    if x1=0 then x2:=bx else if x2=maxx then x1:=maxx-bx;
    if y1=0 then y2:=hy else if y2=maxy then y1:=maxy-hy;
    Raehmchen(x1,y1,x2,y2);
  END; {Maus bewegt}
END; {UpdateRaehmchen}

Procedure Weichzeichner(var x1,y1,x2,y2,fv,fb:Integer);
type wzeilentyp=array[-4..2048] of Byte;
var x,y:integer;
    zeile:array[0..3] of ^Wzeilentyp;
    tu_es:Boolean;
    i,j,s:integer;
{Die Farbe der Umgebung geht gewichtet in die neue Pixelfarbe ein:}
const gewicht:array[-1..1,-1..1] of integer
	     =((1,2,1),
	       (2,4,2),
	       (1,2,1));

  procedure action(x,y:integer);
  var f:array[-1..1,-1..1] of integer;
      tu_es:Boolean; {Nur bestimmte Farben werden behandelt}
      i,j,s:integer;
  begin
    tu_es:=true;
    s:=0;
    for i:=-1 to 1 do
      for j:=-1 to 1 do
      begin
	f[i,j]:=getpixel(x+i,y+j);
	inc(s,f[i,j]*gewicht[i,j]);
	tu_es:=tu_es and (f[i,j]>=fv) and (f[i,j]<=fb);
      end;
    if tu_es then putpixel(x,y,(s+8) div 16);
  end;

BEGIN
  if maxavail<4*(5+x2-x1) then
  begin
    writesl('Zuwenig freier Speicher! [Enter]',true);
    sound(50);
    delay(200);
    nosound;
    repeat readkey until not keypressed;
    exit;
  end;
  for i:=0 to 3 do
  getmem(zeile[i],5+x2-x1);
  raehmchen(x1,y1,x2,y2);
  While not keypressed do
  begin
    UpDateRaehmchen(x1,y1,x2,y2);
    if leftmousebutton then
      action(x1+random(x2-x1-1)+1,y1+random(y2-y1-1)+1)
    else
    if rightmousebutton then
    begin
      if getmaxcolor=255 then
      begin
	getimage(x1,y1,x2,y1,zeile[2]^);
	getimage(x1,y1+1,x2,y1+1,zeile[3]^);
	for y:=y1+1 to y2-1 do
	if not keypressed then
	begin
	  {Hier wre es eleganter, nur die Pointer zu ndern...}
	  move(zeile[2]^,zeile[1]^,x2-x1+5);
	  move(zeile[3]^,zeile[2]^,x2-x1+5);
	  move(zeile[3]^,zeile[0]^,x2-x1+5);
	  getimage(x1,y+1,x2,y+1,zeile[3]^);
	  for x:=1 to x2-x1-1 do
	  BEGIN
	    tu_es:=true;
	    s:=0;
	    for i:=-1 to 1 do
	      for j:=-1 to 1 do
	      begin
		inc(s,zeile[i+2]^[j+x]*gewicht[i,j]);
		tu_es:=tu_es and
		       (zeile[i+2]^[j+x]>=fv) and
		       (zeile[i+2]^[j+x]<=fb);
	      end;
	    if tu_es then zeile[0]^[x]:=(s+8) div 16;
	  END;
	  Putimage(x1,y,zeile[0]^,normalput);
	end {not KeyPressed}
      end {256 Farben}
      else
	for y:=y1+1 to y2-1 do
	if not keypressed then
	for x:=x1+1 to x2-1 do
	action(x,y);
    end; {RightMouseButton}
  end; {While not Keypressed}
  raehmchen(x1,y1,x2,y2);
  for i:=3 downto 0 do
  freemem(zeile[i],5+x2-x1);
END; {Weichzeichner}


Procedure Dunkler(var x1,y1,x2,y2:integer;maxfarbe:Integer);
var
    x,y,f:Integer;
    zeile:array[-4..1023] of Byte;
BEGIN
  raehmchen(x1,y1,x2,y2);
  While not keypressed do
  begin
    UpDateRaehmchen(x1,y1,x2,y2);

    if Leftmousebutton then
    begin
      x:=x1+random(x2-x1+1);
      y:=y1+random(y2-y1+1);
      f:=lmin(maxfarbe,getpixel(x,y));
      if f>0 then putpixel(x,y,f-1);
    end
    else
    if Rightmousebutton then
    begin
      for y:=y1 to y2 do
      if not keypressed then
      if getmaxcolor=255 then
      begin
	getimage(x1,y,x2,y,Zeile);
	for x:=0 to x2-x1 do if Zeile[x]>0 then dec(Zeile[x]);
	putimage(x1,y,zeile,normalput);
      end
      else
      for x:=x1 to x2 do
      begin
	f:=lmin(maxfarbe,getpixel(x,y));
	if f>0 then putpixel(x,y,f-1);
      end;
    end

  end; {While not Keypressed}
  raehmchen(x1,y1,x2,y2);
END; {Dunkler}


Procedure Heller(var x1,y1,x2,y2:integer;maxfarbe:Integer);
var
    x,y,f:Integer;
    zeile:array[-4..1023] of Byte;
BEGIN
  raehmchen(x1,y1,x2,y2);
  While not keypressed do
  begin
    UpDateRaehmchen(x1,y1,x2,y2);
    if Leftmousebutton then
    begin
      x:=x1+random(x2-x1+1);
      y:=y1+random(y2-y1+1);
      f:=getpixel(x,y);
      if f<maxfarbe then putpixel(x,y,f+1);
    end
    else
    if Rightmousebutton then
    begin
      for y:=y1 to y2 do
      if not keypressed then
      if getmaxcolor=255 then
      begin
	getimage(x1,y,x2,y,Zeile);
	for x:=0 to x2-x1 do if Zeile[x]<maxFarbe then inc(Zeile[x]);
	putimage(x1,y,zeile,normalput);
      end
      else
      for x:=x1 to x2 do
      begin
	f:=getpixel(x,y);
	if f<maxFarbe then putpixel(x,y,f+1);
      end;
    end
  end; {While not Keypressed}
  raehmchen(x1,y1,x2,y2);
END; {Heller}

Procedure Malen(var x1,y1,x2,y2,malfarbe:Integer);
var
  rx,ry:Integer;
  winkel,radius,
  dx,dy,sdx,sdy,
  a2,b2,xquadrat:real;
  rxr,rr:real;
  durchmesser,
  x1a,y1a,x2a,y2a,xt,yt:integer;
  i,abstand:longint;
  p:Array[1..5] of Pointtype; {Eckpunkte des Rechtecks}
BEGIN
  rx:=(x2-x1) div 2;if rx=0 then rx:=1; {Wegen Division unten}
  ry:=(y2-y1) div 2;
  rxr:=0.5*(x2-x1);if rx=0 then rx:=1; {Wegen Division unten}
  rr:=0.5*(y2-y1)/rxr;
  durchmesser:=round(sqrt(sqr(1.0*y2-y1)+sqr(1.0*x2-x1)));
  raehmchen(x1,y1,x2,y2);
  While not keypressed do
  begin
    x1a:=x1;y1a:=y1;x2a:=x2;y2a:=y2;
    UpDateRaehmchen(x1,y1,x2,y2);
    if Leftmousebutton then {Sprayen}
    begin
      abstand:=round(sqrt(sqr(1.0*x1-x1a)+sqr(1.0*y1-y1a)));
      if abstand=0 then
      begin
	dx:=0;
	dy:=0;
      end
      else
      begin
	dx:=(x1-x1a)/abstand;
	dy:=(y1-y1a)/abstand;
	raehmchen(x1,y1,x2,y2);
      end;
      sdx:=0;
      sdy:=0;
      for i:=0 to abstand do
      begin
	winkel:=random*2*pi;
	radius:=random*rxr;
	putpixel(x1a+rx+round(sdx+cos(winkel)*radius),
		 y1a+ry+round(sdy+sin(winkel)*radius*rr),
		 malfarbe);
	sdx:=sdx+dx;
	sdy:=sdy+dy;
      end;
      if abstand<>0 then raehmchen(x1,y1,x2,y2);
    end
    else
    if Rightmousebutton then
    begin
      raehmchen(x1,y1,x2,y2);
      setcolor(malfarbe);
      setfillstyle(solidfill,malfarbe);
      if durchmesser<4 then
      BEGIN
	if durchmesser>1 then setlinestyle(solidln,0,thickwidth);
	Line(x1a,y1a,x1,y1);
	setlinestyle(solidln,0,normwidth);
      END
      ELSE
      BEGIN
      Fillellipse(x1+rx,y1+ry,rx,ry);
      IF (x1<>x1a) or (y1<>y1a) THEN
      BEGIN
      {Ellipsen verbinden}
	if y1=y1a
	then
	  begin
	    yt:=ry;
	    xt:=0;
	  end
	else
	if x1=x1a
	then
	  begin
	    xt:=rx;
	    yt:=0;
	  end
	else
	begin
	  {Tangente an eine Ellipse, die komplizierteste Berechnung
	   im ganzen Programm...}
	  a2:=sqr(1.0*rx);
	  b2:=sqr(1.0*ry);
	  xquadrat:=sqr(a2)/(a2+b2/sqr(1.0*(y1-y1a)/(x1-x1a)));
	  xt:=(y1-y1a)div abs(y1-y1a)*round(sqrt(xquadrat));
	  yt:=(x1-x1a)div abs(x1-x1a)*round(ry*sqrt(1-xquadrat/a2));
	end;
	p[1].x:=x1a+rx+xt;  p[1].y:=y1a+ry-yt;
	p[2].x:=x1+rx+xt;   p[2].y:=y1+ry-yt;
	p[3].x:=x1+rx-xt;   p[3].y:=y1+ry+yt;
	p[4].x:=x1a+rx-xt;  p[4].y:=y1a+ry+yt;
	p[5]:=p[1];
	Fillpoly(4,P);
      end;
      end;
      raehmchen(x1,y1,x2,y2);
    end
  end;
  raehmchen(x1,y1,x2,y2);
END; {Malen}

Procedure Wintext(var x1,y1,x2,y2:Integer;
		  malfarbe:Integer;stil,Richtung:Integer;Zeile:String);
var x1a,x2a,y1a,y2a:Integer;
var hoehe,Breite,unterlaenge:Integer;
BEGIN
  SetTextstyle(STIL,Richtung,4);
  IF graphresult<>0 THEN      {Fehler -11: Unbekannter Fehler}
    SetTextStyle(STIL,Richtung,4); {Jetzt klappt's meist...}
  {Jetzt folgt eine programmiertechnische Kapriole:
   Die iterative Textgrenermittlung, weil die Skalierung
   bei Turbo Pascal manchmal derben Mist produziert.}
  x1a:=1;
  y1a:=1;
  x2a:=1;
  y2a:=1;
  If Richtung=Horizdir
  THEN
    BEGIN
      Hoehe:=y2-y1;
      Breite:=x2-x1;
    END
  ELSE
    BEGIN
      Hoehe:=x2-x1;
      Breite:=y2-y1;
    END;
  repeat
    setusercharsize(x1a,y1a,x2a,y2a);
    if textheight('A') <Hoehe  then inc(x2a) else inc(y2a);
    if textwidth(Zeile)<Breite then inc(x1a) else inc(y1a);
  until (textwidth(Zeile)=Breite)
    and (textheight('A')=Hoehe)
    or (x1a=255)
    or (y1a=255)
    or (x2a=255)
    or (y2a=255);

  Case Stil of
  0: Unterlaenge:=0;
  5: Unterlaenge:=Hoehe div 3;
  9: Unterlaenge:=Hoehe div 5;
  ELSE Unterlaenge:=Hoehe div 4;
  END;

  {Bei negativen Farbnummern wird nur der Textstil und die Gre gesetzt}
  if malfarbe>=0 then
  begin
  raehmchen(x1,y1,x2,y2);
  While not keypressed do
  begin
    x1a:=x1;y1a:=y1;x2a:=x2;y2a:=y2;
    UpDateRaehmchen(x1,y1,x2,y2);
    if Leftmousebutton or rightmousebutton then
    begin
      raehmchen(x1,y1,x2,y2);
      setcolor(malfarbe);
      settextjustify(centertext,centertext);
      if Richtung=HorizDir
      Then outtextxy((x1+x2)div 2,(y1+y2)div 2-Unterlaenge,Zeile)
      ELSE outtextxy((x1+x2)div 2-Unterlaenge,(y1+y2)div 2,Zeile);
      settextjustify(lefttext,toptext);
      raehmchen(x1,y1,x2,y2);
    end
  end;
  raehmchen(x1,y1,x2,y2);
  end;
END; {TextWindow}



Procedure Faerben(var x1,y1,x2,y2,von,bis,neu:Integer);
var
    x,y,f,diff:integer;
    zeile:array[-4..1023] of Byte;
BEGIN
  diff:=neu-von; {Die auszufhrende Farbverschiebung}
  raehmchen(x1,y1,x2,y2);

  While not keypressed do
  begin
    UpDateRaehmchen(x1,y1,x2,y2);

    if LeftMouseButton then
    begin
      x:=x1+random(x2-x1+1);
      y:=y1+random(y2-y1+1);
      f:=getpixel(x,y);
      if (f>=von) and (f<=bis) then putpixel(x,y,f+diff);
    end
    else
    if RightMouseButton then
    begin
      for y:=y1 to y2 do
      if not keypressed then
      if getmaxcolor=255 then
      begin
	getimage(x1,y,x2,y,Zeile);
	for x:=0 to x2-x1 do
	  if (Zeile[x]>=von) and (Zeile[x]<=bis) then inc(Zeile[x],diff);
	putimage(x1,y,zeile,normalput);
      end
      else
      for x:=x1 to x2 do
      begin
	f:=getpixel(x,y);
	if (f>=von) and (f<=bis) then putpixel(x,y,f+diff);
      end;
    end
  end; {While not Keypressed}
  raehmchen(x1,y1,x2,y2);
END; {Frben}


Procedure Stempel(var x1,y1,x2,y2:Integer);
Type SprayFeldTyp=array[0..65534] of Byte;
var
    STPuffer:Pointer;
    STPufferUsed,
    KannSprayen:Boolean;
    IMGSize:Longint;
    spraypuffer:^Sprayfeldtyp;
    x,y,breite:Integer;

BEGIN
  if getmaxcolor=255 then
    IMGSize:=(longint(1)+y2-y1)*(longint(7)+x2-x1)+6
    {Liefert manchmal sogar richtige Werte. Manchmal wre es
     richtig, wenn die magische Sieben durch eine Zwei ersetzt
     wrde...}
  else
  if getmaxcolor=15 then
    IMGSize:=(longint(1)+y2-y1)*(longint(7)+x2-x1)div 2+6
    {Manchmal stimmt's und sonst ist's auf der sicheren Seite.}
  else {Weil ich keinen Monochrommodus mit mehr als 64 Kbyte kenne}
    IMGSize:=imagesize(x1,y1,x2,y2);
  If ImgSize>65536 then
     writesl('Warnung: gewhlter Bereich grer als 64 KByte!',true);
  if (maxavail>=imgsize) then
  begin
    getmem(STPuffer,imgsize);
    graphresult; 	{Durch Dummy-Abfrage auf null setzen!}
    GetImage(x1,y1,x2,y2,STpuffer^);
    STPufferUsed:=(GraphResult=0);
    If Not STPufferUsed Then FREEMEM(STPuffer,IMGSIZE);
  end else STPufferUsed:=FALSE;

  If Not STPufferUsed then
  begin
    writesl('Zuwenig Speicher fr Ausschnitt verfgbar!',true);
    Repeat until Keypressed;
    exit;
  end;

  raehmchen(x1,y1,x2,y2);

  KannSprayen:=(IMGSize<65536) and (GetmaxColor=255);
  SprayPuffer:=STPuffer;
  Breite:=x2-x1+1;

  While not keypressed do
  begin

    UpDateRaehmchen(x1,y1,x2,y2);

    if KannSprayen and Leftmousebutton then
    begin
      x:=random(x2-x1+1);
      y:=random(y2-y1+1);
      putpixel(x+x1,y+y1,spraypuffer^[y*breite+x+4]);
    end
    else
    if (LeftMouseButton and not kannsprayen) or Rightmousebutton
    then PutImage(x1,y1,STpuffer^,copyput);

  end; {While not Keypressed}
  FREEMEM(STPuffer,IMGSIZE);
  raehmchen(x1,y1,x2,y2);
END; {Stempel}

Procedure QWGEinfuegen(qwgname:pathstr;
		       var x1,y1,x2,y2:Integer);
var
    x,y:Integer;
    qwg:file;
    header:qwgheadertyp;
var istwpg,
    einsbak,
    bmzoombak,
    dummy:Boolean;
var x1l,y1l,x2l,y2l:longint;

BEGIN
  if istwpgdatei(qwgname) then
    istwpg:=true
  else
  begin
  istwpg:=false;
  assign(qwg,qwgname);
  reset(qwg,1);
  if ioresult<>0 then
  begin
    writesl('Finde '+fexpand(qwgname)+' nicht!',true);
    exit;
  end;
  blockread(qwg,header,16);
  if (ioresult<>0)
  or (header.MaxColor<>GetMaxColor) then
  begin
    writesl('QWG-Datei ungltig!',true);
    exit;
  end;

  x2:=x1+header.dx;
  y2:=y1+header.dy;
  end;{test auf QWG-Datei}
  raehmchen(x1,y1,x2,y2);

  While not keypressed do
  begin
    UpDateRaehmchen(x1,y1,x2,y2);

    If LeftMouseButton or Rightmousebutton
    then
    if istwpg then
    begin
      x1l:=x1;
      y1l:=y1;
      x2l:=x2;
      y2l:=y2;
      bmzoombak:=zoombitmap;
      einsbak:=einszueins;
      zoombitmap:=TRUE;
      einszueins:=false;
      zeigwpg(qwgname,x1l,y1l,x2l,y2l,dummy);
      zoombitmap:=bmzoombak;
      einszueins:=einsbak;
      {Font-Einstellungen verndert. Deshalb hier das Zurcksetzen.}
      IF fontnr=0 THEN
	SetTextstyle(0,0,Charsize div 8)
      ELSE
      BEGIN
	SetTextStyle(Fontnr,0,4);
	IF graphresult<>0 THEN     {Fehler -11: Unbekannter Fehler}
	  SetTextStyle(Fontnr,0,4); {Jetzt klappt's meist...}
	SetUserCharSize(Charsize,TextHeight('A'),Charsize,TextHeight('A'));
      END;
    end
    else LiesQWG(qwgname,x1,y1,False,FALSE);

  end; {While not Keypressed}
  raehmchen(x1,y1,x2,y2);
END; {QWG_Einfuegen}

Procedure Rahmenangleichen(VAR x1,y1,x2,y2:Integer);
{Pat den Ausschnittrahmen an das in ihm befindliche Objekt an.
 Ein zu kleiner Rahmen wird vergrert, ein zu groer Rahmen wird
 so verkleinert, da an keiner Seite ausschlielich Hintergrundpixel
 vorkommen.}
var
    i:Integer;
    otest,utest,ltest,rtest:boolean;
    Gleich,
    Fertig:Boolean;

BEGIN
  {Zuerst ggf. vergrern:}
  Repeat
    Fertig:=True;
    Gleich:=true;
    i:=x1;
    while gleich and (i<=x2) do
    begin
      gleich:=gleich and (getpixel(i,y1)=hgfarbe);
      inc(i);
    end;
    if not Gleich and (y1>0) then begin dec(y1);fertig:=false end;

    Gleich:=true;
    i:=x1;
    while gleich and (i<=x2) do
    begin
      gleich:=gleich and (getpixel(i,y2)=hgfarbe);
      inc(i);
    end;
    if not Gleich and (y2<maxy) then begin inc(y2);fertig:=false end;

    Gleich:=true;
    i:=y1;
    while gleich and (i<=y2) do
    begin
      gleich:=gleich and (getpixel(x1,i)=hgfarbe);
      inc(i);
    end;
    if not Gleich and (x1>0) then begin dec(x1);fertig:=false end;

    Gleich:=true;
    i:=y1;
    while gleich and (i<=y2) do
    begin
      gleich:=gleich and (getpixel(x2,i)=hgfarbe);
      inc(i);
    end;
    if not Gleich and (x2<maxx) then begin inc(x2);fertig:=false end;
  Until Fertig;

  {Falls zu gro, auf Gre des Objektes zusammenziehen:}
  otest:=true;
  utest:=true;
  ltest:=true;
  rtest:=true; {Wenn eine Kante "Kontakt" hat,
		braucht sie nicht mehr getestet zu werden.}
  Repeat
    Fertig:=True;
    if utest then begin
      Gleich:=true;
      for i:=x1 to x2 do gleich:=gleich and (getpixel(i,y1)=hgfarbe);
      if Gleich and (y1<y2) then begin inc(y1);fertig:=false end
      else utest:=false;
    end;
    if otest then begin
      Gleich:=true;
      for i:=x1 to x2 do gleich:=gleich and (getpixel(i,y2)=hgfarbe);
      if Gleich and (y2>y1) then begin dec(y2);fertig:=false end
      else otest:=false;
    end;
    if ltest then begin
      Gleich:=true;
      for i:=y1 to y2 do gleich:=gleich and (getpixel(x1,i)=hgfarbe);
      if Gleich and (x1<x2) then begin inc(x1);fertig:=false end
      else ltest:=false;
    end;
    if rtest then begin
      Gleich:=true;
      for i:=y1 to y2 do gleich:=gleich and (getpixel(x2,i)=hgfarbe);
      if Gleich and (x2>x1) then begin dec(x2);fertig:=false end
      else rtest:=false;
    end;
  Until Fertig;
END; {Rahmenangleichen}

Procedure Rahmenangleichen2(VAR x1,y1,x2,y2:Integer);
{Pat den Ausschnittrahmen an das in ihm befindliche Objekt an.
 Ein zu kleiner Rahmen wird vergrert,
 bis jede Seite nur Pixel einer Farbe hat.}
var
    i,Vergleichsfarbe:Integer;
    Gleich,
    gleichx1,gleichx2,gleichy1,gleichy2,
    Fertig:Boolean;

BEGIN
  {Nur vergrern:}
  Repeat
    Fertig:=True;
    Gleich:=true;

    i:=x1+2;
    Vergleichsfarbe:=getpixel(x1+1,y1);
    while gleich and (i<x2) do
    begin
      gleich:=gleich and (getpixel(i,y1)=Vergleichsfarbe);
      inc(i);
    end;
    if not Gleich and (y1>0)
    then begin dec(y1);fertig:=false end;
    gleichy1:=gleich;

    Gleich:=True;
    i:=x1+2;
    Vergleichsfarbe:=getpixel(x1+1,y2);
    while gleich and (i<x2) do
    begin
      gleich:=gleich and (getpixel(i,y2)=Vergleichsfarbe);
      inc(i);
    end;
    if not Gleich and (y2<maxy)
    then begin inc(y2);fertig:=false end;
    gleichy2:=gleich;

    Gleich:=true;
    i:=y1+2;
    Vergleichsfarbe:=getpixel(x1,y1+1);
    while gleich and (i<y2) do
    begin
      gleich:=gleich and (getpixel(x1,i)=Vergleichsfarbe);
      inc(i);
    end;
    if not Gleich and (x1>0)
    then begin dec(x1);fertig:=false end;
    gleichx1:=gleich;

    Gleich:=true;
    i:=y1+2;
    Vergleichsfarbe:=getpixel(x2,y1+1);
    while gleich and (i<y2) do
    begin
      gleich:=gleich and (getpixel(x2,i)=Vergleichsfarbe);
      inc(i);
    end;
    if not Gleich and (x2<maxx)
    then begin inc(x2);fertig:=false end;
    gleichx2:=gleich;

  Until Fertig;
  if gleichx1 then inc(x1);
  if gleichx2 then dec(x2);
  if gleichy1 then inc(y1);
  if gleichy2 then dec(y2);
END; {Rahmenangleichen2}

procedure farbleiste(maxfarbe:integer;
		     var breite,offset:integer;
		     var farbleisteneu:Boolean);
var n:byte;
begin
  offset:=textwidth(' GLOBAL ');
  breite:=(getmaxx-offset) div (maxfarbe+1);
  line(0,getmaxy,0,getmaxy);
  {Das ist mal wieder so eine magische Zeile...
   Im SVGA-Treiber von Hargrave ist ein Bug, der
   fr Muster bei BAR sorgt, wenn von XORPUT auf NORMALPUT
   gewechselt wurde. Aber nicht, wenn vorher
   eine Linie gezeichnet wurde...}
  writesl('',true); {Zeile lschen}
  for n:=0 to maxfarbe do
  begin
    if MonoChrom OR ZuVieleFarben then
    begin
      setfillpattern(monopattern[grauwert(n)div 4],getmaxcolor);
      setfillstyle(userfill,getmaxcolor);
    end
    else
      setfillstyle(solidfill,n);
    setcolor(getmaxcolor);
    bar(offset+n*breite,maxy+3,offset+(n+1)*breite,getmaxy-1);
  end;
  farbleisteneu:=TRUE;
end;

Procedure Fadenkreuz(x,y:word);
BEGIN
 setcolor(getmaxcolor);
 setwritemode(xorput);
 line(x,y-4,x,y+4);
 line(x-4,y,x+4,y);
 setwritemode(CopyPut);line(0,maxy+1,0,maxy+1); {HARGRAVE!}
END;


PROCEDURE MausFadenKreuz(var x,y,n:integer);
var mausbewegt:Boolean;
var dx,dy:integer;
begin
  Mouse_Motion(dx,dy);
  mausbewegt:=(dx<>0) or (dy<>0);
  if Mausbewegt then
  begin
    fadenkreuz(x,y);
    x:=min(lmax(0,x+dx),getmaxx);
    y:=min(lmax(0,y+dy),getmaxy);
    fadenkreuz(x,y);
    n:=getpixel(x,y);
    delay(50);
  end;
end;

function Hole_Raehmchen(var x1,y1,x2,y2:integer;modus:integer):Boolean;
var
    dx,dy,
    x1a,y1a,
    x2a,y2a:Integer;
    zeichen,
    zeichen2:char;
    Fertig:boolean;
    muster,farbe:word;
    breite,offset:integer;
const step:integer=1;
const bewegen:Boolean=TRUE;

begin
  AusschnittSL(bewegen,step,modus);
  Fertig:=False;
  zeichen:=#0;
  muster:=$f0f0;
  farbe:=getmaxcolor;
  setwritemode(xorput);
  setcolor(farbe);
  setlinestyle(userbitln,muster,normwidth);
  x1a:=x1;
  x2a:=x2;
  y1a:=y1;
  y2a:=y2;
  rectangle(x1a,y1a,x2a,y2a);

REPEAT
  setwritemode(xorput);
  setlinestyle(userbitln,muster,normwidth);
  setcolor(farbe);
  IF VGAKARTE THEN WAIT_VRETRACE ELSE DELAY(20);
  rectangle(x1a,y1a,x2a,y2a);
  x1a:=x1;
  y1a:=y1;
  x2a:=x2;
  y2a:=y2;
  if muster=$FFFF then
  begin
    muster:=$f0f0;
    farbe:=getmaxcolor;
  end
  else
  begin
    muster:=$FFFF;
    farbe:=random(getmaxcolor);
  end;
  setlinestyle(userbitln,muster,normwidth);
  setcolor(farbe);
  IF VGAKARTE THEN WAIT_VRETRACE ELSE DELAY(20);
  rectangle(x1,y1,x2,y2);

  if mausda then
  begin
    nosound;
    mouse_motion(dx,dy);
    if bewegen then
    begin
      if not leftmousebutton then begin inc(x1,dx); inc(y1,dy); end;
      inc(x2,dx); inc(y2,dy);
{$IFDEF Vollbildexport}
      if x2>getmaxx then x1:=getmaxx-x2+x1;
      if y2>getmaxy then y1:=getmaxy-y2+y1;
{$ELSE}
      if x2>maxx then x1:=maxx-x2+x1;
      if y2>maxy then y1:=maxy-y2+y1;
{$ENDIF}
      if x1<0 then x2:=x2-x1;
      if y1<0 then y2:=y2-y1;
    end else
    begin
      inc(x2,dx); inc(y2,dy);
    end;
  end;


  if keypressed or (mausda and Rightmousebutton) then
  begin
    if Rightmousebutton then zeichen:=#13 else
    zeichen:=upcase(readkey);
    rectangle(x1a,y1a,x2a,y2a);
    case zeichen of
    ' ': begin
	 step:=8 div step; {Schalter 8 <-> 1}
	 AusschnittSL(Bewegen,step,modus);
	 end;
    '+': begin
	   if x1>=step then dec(x1,step);
	   if y1>=step then dec(y1,step);
	   if x2<=maxx-step then inc(x2,step);
	   if y2<=maxy-step then inc(y2,step);
	 end;
    '-': begin
	   if x2>=x1+step then dec(x2,step);
	   if y2>=y1+step then dec(y2,step);
	   if x1<=x2-step then inc(x1,step);
	   if y1<=y2-step then inc(y1,step);
	 end;
    '@','V':
	 begin
	 Bewegen:=TRUE;
	 WriteSL('Ausschnittbreite: ',true);
	 szeile:=ls(x2-x1+1);
	 If Inputsl(szeile,5) then x2:=x1+sl(szeile)-1;
	 WriteSL('Ausschnitthhe: ',true);
	 szeile:=ls(y2-y1+1);
	 If Inputsl(szeile,5) then y2:=y1+sl(szeile)-1;
	 AusschnittSL(bewegen,step,Modus);
	 end;
    'A': begin
	 bewegen:=true;
	 WriteSL('Anpassung der Ausschnittgrenzen, bitte warten...',true);
	 Rahmenangleichen(x1,y1,x2,y2);
	 AusschnittSL(bewegen,step,Modus);
	 end;
    'G': begin
	 bewegen:=true;
	 WriteSL('Suche Objektgrenzen, bitte warten...',true);
	 Rahmenangleichen2(x1,y1,x2,y2);
	 AusschnittSL(bewegen,step,Modus);
	 end;
    #9: begin
	  Bewegen:=NOT Bewegen;
	  sound(10000);delay(5);
	  nosound;
	  delay(50);
	  AusschnittSL(bewegen,step,Modus);
	end;
    #0: begin zeichen2:=readkey;
	case zeichen2 of
{<-}	#75: if bewegen then
		begin
		  dec(x1,step); dec(x1,x1 mod step);
		  dec(x2,step); dec(x2,x2 mod step);
		end else
		begin
		  dec(x2,step); dec(x2,x2 mod step);
		end;
{->}	#77: if bewegen then
		begin
		  inc(x1,step); dec(x1,(x1+1) mod step);
		  inc(x2,step); dec(x2,(x2+1) mod step);
		end else
		begin
		  inc(x2,step); dec(x2,(x2+1) mod step);
		end;
{ab}	#80: if bewegen then
		begin
		  inc(y2,step);
		  inc(y1,step);
		end else
		begin
		  inc(x2,step);
		  {y ist dann abhngig von x}
		end;
{auf}	#72: if bewegen then
		begin
		  dec(y1,step);
		  dec(y2,step);
		end else
		begin
		  dec(x2,step);
		  {y ist dann abhngig von x}
		end;
{F1}	#59: Case Modus of
             rmZoomen: ZoomHilfe;
             rmDrucken: Druckhilfe;
             rmSchreiben: Ausschnitthilfe(TRUE);
                          {TRUE eigentlich "AusHauptMenue"}
             end;
	ELSE Fertig:=TRUE;
	end; {case}
	end; {sonderzeichen}
    ELSE fertig:=TRUE;
    while keypressed do readkey;
    end; {case readkey}
    setwritemode(xorput);
    setlinestyle(userbitln,muster,normwidth);
    setcolor(farbe);
    if not Fertig then rectangle(x1a,y1a,x2a,y2a);
  end; {keypressed}
{$IFDEF Vollbildexport}
  x1:=min(getmaxx-1,lmax(0,x1));
  x2:=min(getmaxx,lmax(x2,x1+1));
  y1:=min(getmaxy-1,lmax(0,y1));
  y2:=min(getmaxy,lmax(y2,y1+1));
{$ELSE}
  if modus=rmZoomen then y2:=y1+round((1.0*x2-x1)*maxy/maxx);
  x1:=min(maxx-1,lmax(0,x1));
  x2:=min(maxx,lmax(x2,x1+1));
  y1:=min(maxy-1,lmax(0,y1));
  y2:=min(maxy,lmax(y2,y1+1));
{$ENDIF}
Until Fertig;
setwritemode(copyput);
if zeichen=#27
then
begin
  x1:=0;
  x2:=maxx;
  y1:=0;
  y2:=maxy;
end;
hole_Raehmchen:=Zeichen<>#27;
end;

Function DeviceName(name:Pathstr):Boolean;
Begin
  if name[length(name)]=':' then dec(name[0]);
  name:=upstr(name);
  Devicename:=
    (name='CON')
  or(name='LPT1')
  or(name='LPT2')
  or(name='LPT3')
  or(name='LPT4')
  or(name='AUX')
  or(name='PRN')
  or(name='NUL')
  or(name='COM1')
  or(name='COM2')
  or(name='COM3')
  or(name='COM4');
END;

PROCEDURE TextMalen(VAR x1,y1,x2,y2,MalStil,Textrichtung:Integer);
VAR T:Text;
VAR MaxZeilenBreite:Integer;
VAR Zeile,BreiteZeile:String;
VAR NrBreiteZeile:Integer;
VAR i,Zeilen:Integer;
VAR ya,yb:Integer;
VAR dy:real;
const maltext:string='';
BEGIN
  Writesl('Text: ',TRUE);
  repeat until not (leftmousebutton or rightmousebutton);
  if inputsl(Maltext,16) then
  BEGIN
  repeat until not (rightmousebutton or leftmousebutton);
  if fileexist(Maltext) and not DeviceName(Maltext)
  then
  begin
    assign(t,maltext);
    reset(t);
    MaxZeilenbreite:=0;
    BreiteZeile:='';
    NrBreiteZeile:=0;
    Zeilen:=0;
    while not eof(t) do
    begin
      readln(t,zeile);
      inc(Zeilen);
      if textwidth(zeile)>MaxZeilenbreite
      then
	begin
	  BreiteZeile:=Zeile;
	  MaxZeilenBreite:=TextWidth(Zeile);
	  NrBreiteZeile:=Zeilen;
	end;
    end;
    close(t);
    if zeilen>0 then
    begin
    reset(t);
    dy:=y2-y1; {Real-Zahl, um Integer-berlufe bei Zwischenergebnissen
                zu vermeiden}
    ya:=round(y1+dy*(NrBreiteZeile-1.0)/Zeilen);
    yb:=round(y1+dy*(NrBreiteZeile-0.1)/Zeilen);
    {Farbe -1: Kein Text ausgeben, nur Textgre berechnen}
    Wintext(x1,ya,x2,yb,
	    -1,MalStil,Textrichtung,BreiteZeile);
    i:=0;
    setcolor(malfarbe);
    while not eof(t) and not (keypressed and (ReadKey=#27)) do
    begin
      readln(t,zeile);
      inc(i);
      outtextxy(x1,round(y1+dy*(i-1.0)/Zeilen),Zeile);
    end;
    close(t);
    end; {Text war nicht leer}
  end {Text war Dateiname}
  else
  BEGIN {Normale Textzeile}
    WriteSL('Maustaste: Text einfgen.',true);
    Wintext(x1,y1,x2,y2,malfarbe,MalStil,Textrichtung,maltext);
  END;
  END;

  {Font-Einstellungen verndert. Deshalb hier das Zurcksetzen.}
  IF fontnr=0 THEN
    SetTextstyle(0,0,Charsize div 8)
  ELSE
  BEGIN
    SetTextStyle(Fontnr,0,4);
    IF graphresult<>0 THEN     {Fehler -11: Unbekannter Fehler}
      SetTextStyle(Fontnr,0,4); {Jetzt klappt's meist...}
    SetUserCharSize(Charsize,TextHeight('A'),Charsize,TextHeight('A'));
  END;
END; {TextMalen}

procedure ausschnitt_schreiben(maxfarbe,Breitenfaktor:word;
			       name:string;
			       insclipboard,
			       AusHauptMenue:Boolean);
var xa,ya:word;
    fv,fb,fn,
    dx,dy,
    x,y,
    x1,y1,
    x2,y2,
    x1a,y1a,
    x2a,y2a:Integer;
    zeichen,
    zeichen2:char;
    bewegen:boolean;
    muster,farbe:word;
    s:string;
    dir:dirstr;
    fname:namestr;
    qwgext,
    ext:extstr;
    icon,
    transparent,
    ok:Boolean;
    breite,offset:integer;
    bdummy:boolean;
    linx0,liny0,
    n,
    randfarbe:integer;
    Geschrieben:Boolean;

const step:integer=1;
const qwgname:pathstr='';
const malstil:Integer=1;
const Textrichtung:Integer=Horizdir;

Procedure Speichern(Zeichen:Char);
BEGIN
Geschrieben:=TRUE;
if not Lizenziert then
 BEGIN
 setwritemode(copyput);
 setcolor(getmaxcolor
	  xor getpixel(x1+random(x2-x1),y1+random(y2-y1)));
 outtextxy(x1+1,y1+1,Programmname+' SHAREWAREVERSION');
 END;
 if (ext='.ICN') and (zeichen=#13) then
 begin
   writesl('Icon-Hintergrund transparent',true);
   transparent:=janeinsl;
 end;
 writesl('Schreibe '+fexpand(name),true);
 Case Zeichen of
 ^D: writesl(' um 90 gedreht',false);
 ^G: if maxfarbe=255
     then writesl(' mit 64 Graustufen',false)
     else writesl(' mit 16 Graustufen',false);
 ^S: writesl(' mit sortierter Palette',false);
 ^V: writesl(' auf 50% verkleinert',false);
 ^Z: writesl(' auf 200% gezoomt',false);
 Else if ext='.ICN'
      then
	writesl(' (Windows-Icon)',false)
      else
	if ext='.DXF'
	then
	  if MonoChrom
	  then writesl(' (2D-Linien)',false)
	  else writesl(' (3D-Masche in '+ls(maxfarbe+1)+' Stufen)'
		       ,false)
	ELSE
	if (ext='.HPG') or (ext='.PLT')
	then
	  writesl(' (Plotdatei)',false)
	else
	  if MonoChrom
	  then writesl(' (monochrom)',false)
	  else writesl(' ('+ls(maxfarbe+1)+' Farben)',false);
 end;
 if insclipboard then writesl('Schreibe Ausschnitt ins Clipboard',true);
 writesl(', bitte warten.',false);

 if ((ext='.PCX')
  or (ext='.HPG')
  or (ext='.PLT')
  or (ext='.QWF')
  or (ext='.DXF')
  or (ext='.ICN'))
 and (Zeichen<>#13) then
 begin
   Writesl('Nur fr WPG-Export erlaubt!',true);
   repeat until keypressed;
   ok:=True;
 end
 else
 Case Zeichen of
   #13: if ext='.DXF' then
	  schreibe_DXF(x1,x2,y1,y2,name,monochrom,ok)
	else
	if ext='.PCX' then
	  schreibe_PCX(x1,x2,y1,y2,name,monochrom,ok)
	else
	if (ext='.PLT') or (ext='.HPG') then
	  schreibe_HPGL(x1,x2,y1,y2,name,ok)
	else
	if ext='.QWG' then
	  schreibe_QWG(x1,x2,y1,y2,name,ok)
	else
	if ext='.ICN' then
	  schreibe_icon(x1,y1,name,transparent,ok)
	else
	  schreibe_fenster(WPG_Normal,maxfarbe,x1,x2,y1,y2,
			   breitenfaktor,name,
			   monochrom,ok);
   ^G:  If Monochrom Then
	Begin
	  Writesl('Im Monochrommodus nicht mglich!',true);
	  Repeat until Keypressed;
	  ok:=True;
	end
	ELSE
	schreibe_fenster(WPG_Grau,maxfarbe,x1,x2,y1,y2,
			 breitenfaktor,name,
			 monochrom,ok);
   ^S:  If Monochrom Then
	Begin
	  Writesl('Im Monochrommodus nicht mglich!',true);
	  Repeat until Keypressed;
	  ok:=True;
	end
	ELSE
	schreibe_fenster(WPG_Sortiert,maxfarbe,x1,x2,y1,y2,
			 breitenfaktor,name,
			 monochrom,ok);
   ^D:  schreibe_fenster(WPG_Gedreht,maxfarbe,x1,x2,y1,y2,
			 breitenfaktor,name,
			 monochrom,ok);
   ^V:  schreibe_ViertelFenster(maxfarbe,x1,x2,y1,y2,
			 breitenfaktor,name,ok);
   ^Z:  schreibe_zoomfenster(maxfarbe,x1,x2,y1,y2,
			 breitenfaktor,name,ok);
 END; {Case}
 If Not ok then WriteSL('Fehler beim Schreiben der Datei!',TRUE);
 AusSchnt_x1:=x1;
 AusSchnt_y1:=y1;
 AusSchnt_x2:=x2;
 AusSchnt_y2:=y2;
END; {Speichern}

begin
  Geschrieben:=False;
  fv:=0;
  fb:=maxfarbe;
  fn:=0;
  fsplit(upstr(name),dir,fname,ext);
  Icon:=ext='.ICN';
  bewegen:=TRUE;
  AusschnittSL(bewegen,step,rmSchreiben);
  getaspectratio(xa,ya);
  xa:=round(10000.0*xa/Breitenfaktor);
  x1:=AusSchnt_x1; {Die Fenstergrenzen merkt er sich global}
  x1a:=x1;
  y1:=AusSchnt_y1;
  y1a:=y1;
  if icon then x2:=x1+31 else
  x2:=AusSchnt_x2;
  x2a:=x2;
  if icon then y2:=y1+31 else
  y2:=AusSchnt_y2;
  y2a:=y2;
  zeichen:=#0;
  muster:=$f0f0;
  farbe:=getmaxcolor;
  setwritemode(xorput);
  setcolor(farbe);
  setlinestyle(userbitln,muster,normwidth);
  rectangle(x1a,y1a,x2a,y2a);

REPEAT
  setwritemode(xorput);
  setlinestyle(userbitln,muster,normwidth);
  setcolor(farbe);
  IF VGAKARTE THEN WAIT_VRETRACE ELSE DELAY(20);;
  rectangle(x1a,y1a,x2a,y2a);
  x1a:=x1;
  y1a:=y1;
  x2a:=x2;
  y2a:=y2;
  if muster=$FFFF then
  begin
    muster:=$f0f0;
    farbe:=getmaxcolor;
  end
  else
  begin
    muster:=$FFFF;
    farbe:=random(getmaxcolor);
  end;
  setlinestyle(userbitln,muster,normwidth);
  setcolor(farbe);
  IF VGAKARTE THEN WAIT_VRETRACE ELSE DELAY(20);
  rectangle(x1,y1,x2,y2);

  if mausda then
  begin
    nosound;
    mouse_motion(dx,dy);
    if bewegen then
    begin
      if not leftmousebutton then begin inc(x1,dx); inc(y1,dy); end;
      inc(x2,dx); inc(y2,dy);
{$IFDEF Vollbildexport}
      if x2>getmaxx then x1:=getmaxx-x2+x1;
      if y2>getmaxy then y1:=getmaxy-y2+y1;
{$ELSE}
      if x2>maxx then x1:=maxx-x2+x1;
      if y2>maxy then y1:=maxy-y2+y1;
{$ENDIF}
      if x1<0 then x2:=x2-x1;
      if y1<0 then y2:=y2-y1;
    end else
    begin
      inc(x2,dx); inc(y2,dy);
    end;
  end;


  if keypressed or (mausda and Rightmousebutton) then
  begin
    if Rightmousebutton then zeichen:=#9 else
    zeichen:=upchar(readkey); {UPCASE kann keine Umlaute}
    rectangle(x1a,y1a,x2a,y2a);
    case zeichen of
    ^D,^G,^S,^V,^Z:
	 Speichern(Zeichen);
    ^P:	IF AusHauptMenue
	THEN
	  BEGIN
	    Palette_aendern('',0,0,MaxFarbe+1);
	    AusschnittSL(bewegen,step,rmSchreiben);
	  END
	ELSE Zeichen:=#27;
    #9: if not icon then begin
	  Bewegen:=NOT Bewegen;
	  sound(10000);delay(5);
	  nosound;
	  delay(50);
	  AusschnittSL(bewegen,step,rmSchreiben);
	end;
    {Die STRG-Sequenzen sind nur zur Vermeidung von Tippfehlern.
     Tatschlich sollten die Funktionen damit nicht aufgerufen werden.}
    ^F,
    'F': If Mausda Then
	 BEGIN
	 farbleiste(maxfarbe,breite,offset,bdummy);
	 setfillstyle(solidfill,getmaxcolor);
	 bar(0,maxy+2,offset-2,getmaxy);
	 setcolor(0);
	 outtextxy(0,maxy+3,'Farbe:');
	 setcolor(getmaxcolor);
	 x:=(x1+x2) div 2;
	 y:=(y1+y2) div 2;
	 fadenkreuz(x,y);
	 repeat mausfadenkreuz(x,y,malfarbe)
	 until keypressed or leftmousebutton or rightmousebutton;
	 fadenkreuz(x,y);
	 AusschnittSL(bewegen,step,rmSchreiben);
	 END;
    ^W,
    'W': if mausda then
	 BEGIN
	   farbleiste(maxfarbe,breite,offset,bdummy);
	   setfillstyle(solidfill,getmaxcolor);
	   bar(0,maxy+2,offset-2,getmaxy);
	   setcolor(0);
	   outtextxy(0,maxy+3,'Von');
	   setcolor(getmaxcolor);
	   fadenkreuz(x,y); {Zeichnen}
	   repeat mausfadenkreuz(x,y,n)
	   until keypressed or leftmousebutton or rightmousebutton;
	   fv:=n;
	   bar(0,maxy+2,offset-2,getmaxy);
	   setcolor(0);
	   outtextxy(0,maxy+3,'Bis');
	   setcolor(getmaxcolor);
	   repeat until not (RightMouseButton or LeftMouseButton);
	   repeat mausfadenkreuz(x,y,n)
	   until keypressed or leftmousebutton or rightmousebutton;
	   fb:=n;
	   fadenkreuz(x,y); {Lschen}
	   WriteSL('Weichzeichner: links sprayen, rechts ganzes Fenster.',true);
	   Weichzeichner(x1,y1,x2,y2,fv,fb);
	   AusschnittSL(bewegen,step,rmSchreiben);
	 END;
    ^L,
    'L': if mausda then
	 BEGIN {Lineal}
	   Linealbenutzen:=FALSE;
	   Writesl('Ersten Punkt anklicken oder Lineal mit Leertaste lschen',true);
	   setfillstyle(solidfill,getmaxcolor);
	   x:=linx1;
	   y:=liny1;
	   fadenkreuz(x,y); {Zeichnen}
	   setwritemode (xorput);
	   line(x,y,x+linx2-linx1,y+liny2-liny1);
	   repeat
	     IF VGAKARTE THEN WAIT_VRETRACE ELSE DELAY(20);;
	     line(x,y,x+linx2-linx1,y+liny2-liny1);
	     mausfadenkreuz(x,y,n);
	     setwritemode (xorput);
	     line(x,y,x+linx2-linx1,y+liny2-liny1);
	   until keypressed or leftmousebutton or rightmousebutton;
	   line(x,y,x+linx2-linx1,y+liny2-liny1);
	   setwritemode(normalput);line(0,getmaxy,0,getmaxy); {HARGRAVE}
	   linx0:=x;liny0:=y;
	   if not keypressed then
	   begin
	     Linealbenutzen:=TRUE;
	     Writesl('Zweiten Punkt anklicken oder Lineal mit Leertaste umsetzen',true);
	     repeat until not (RightMouseButton or LeftMouseButton);
	     setwritemode (xorput); line(linx0,liny0,x,y);
	     repeat
	       IF VGAKARTE THEN WAIT_VRETRACE ELSE DELAY(20);;
	       line(linx0,liny0,x,y);
	       mausfadenkreuz(x,y,n);
	       setwritemode (xorput); line(linx0,liny0,x,y);
	     until keypressed or leftmousebutton or rightmousebutton;
	     line(linx0,liny0,x,y);
	     setwritemode(normalput);line(0,getmaxy,0,getmaxy); {HARGRAVE}
	     if keypressed and (readkey=' ') then
	     begin
	       dx:=linx0-linx1;
	       dy:=liny0-liny1;
	       linx1:=x;
	       liny1:=y;
	       inc(linx2,dx);
	       inc(liny2,dy);
	     end
	     else
	     begin
	       linx1:=linx0;
	       liny1:=liny0;
	       linx2:=x;
	       liny2:=y;
	     end;
	     while keypressed do readkey; {#0...}
	   end; {not keypressed}
	   fadenkreuz(x,y); {Lschen}
	   AusschnittSL(bewegen,step,rmSchreiben);
	   repeat until not (RightMouseButton or LeftMouseButton);
	 END;
    ^D,
    'D': if MausDa then
	 BEGIN
	 WriteSL('Dunkler: links sprayen, rechts ganzes Fenster.',true);
	 Dunkler(x1,y1,x2,y2,maxfarbe);
	 AusschnittSL(bewegen,step,rmSchreiben);
	 END;
    ^U,
    'U': if MausDa Then
	 BEGIN
	   farbleiste(maxfarbe,breite,offset,bdummy);
	   setfillstyle(solidfill,getmaxcolor);
	   bar(0,maxy+2,offset-2,getmaxy);
	   setcolor(0);
	   outtextxy(0,maxy+3,'Von');
	   setcolor(getmaxcolor);
	   fadenkreuz(x,y); {Zeichnen}
	   repeat mausfadenkreuz(x,y,n)
	   until keypressed or leftmousebutton or rightmousebutton;
	   fv:=n;
	   bar(0,maxy+2,offset-2,getmaxy);
	   setcolor(0);
	   outtextxy(0,maxy+3,'Bis');
	   setcolor(getmaxcolor);
	   repeat until not (RightMouseButton or LeftMouseButton);
	   repeat mausfadenkreuz(x,y,n)
	   until keypressed or leftmousebutton or rightmousebutton;
	   fb:=n;
	   bar(0,maxy+2,offset-2,getmaxy);
	   setcolor(0);
	   outtextxy(0,maxy+3,'Nach');
	   setcolor(getmaxcolor);
	   repeat until not (RightMouseButton or LeftMouseButton);
	   repeat mausfadenkreuz(x,y,n)
	   until keypressed or leftmousebutton or rightmousebutton;
	   fn:=n;
	   fadenkreuz(x,y); {Lschen}
	   WriteSL('Umfrben: links sprayen, rechts ganzes Fenster.',true);
	   repeat until not (RightMouseButton or LeftMouseButton);
	   Faerben(x1,y1,x2,y2,fv,fb,fn);
	   AusschnittSL(bewegen,step,rmSchreiben);
	 END;
    '': if MausDa then begin {Fluten}
	   farbleiste(maxfarbe,breite,offset,bdummy);
	   setfillstyle(solidfill,getmaxcolor);
	   bar(0,maxy+2,offset-2,getmaxy);
	   setcolor(0);
	   outtextxy(0,maxy+3,'Fll-F.');
	   setcolor(getmaxcolor);
	   fadenkreuz(x,y); {Zeichnen}
	   repeat mausfadenkreuz(x,y,n)
	   until keypressed or leftmousebutton or rightmousebutton;
	   malfarbe:=n;
	   bar(0,maxy+2,offset-2,getmaxy);
	   setcolor(0);
	   outtextxy(0,maxy+3,'Rand-F.');
	   setcolor(getmaxcolor);
	   repeat until not (RightMouseButton or LeftMouseButton);
	   repeat mausfadenkreuz(x,y,n)
	   until keypressed or leftmousebutton or rightmousebutton;
	   Randfarbe:=n;
	   Writesl('Zu fllende Bereiche whlen, Ende mit Leertaste',true);
	   fadenkreuz(x,y); {Lschen}
	   WHILE Not KeyPressed do
	   BEGIN
	   fadenkreuz(x,y); {Zeichnen}
	   repeat until not (RightMouseButton or LeftMouseButton);
	   repeat mausfadenkreuz(x,y,n)
	   until keypressed or leftmousebutton or rightmousebutton;
	   fadenkreuz(x,y); {Lschen}
	   setfillstyle(solidfill,malfarbe);
	   if not keypressed then
	   begin
	     setviewport(0,0,maxx,maxy,TRUE);
	     floodfill(x,y,randfarbe);
	     setviewport(0,0,getmaxx,getmaxy,FALSE);
	   end;
	   setcolor(getmaxcolor);
	   END; {While not KeyPressed};
	   setfillstyle(solidfill,getmaxcolor);
	   ausschnittsl(bewegen,step,rmSchreiben);
	 end;
    ^H,
    'H': If MausDa then
	 BEGIN
	 WriteSL('Heller: links sprayen, rechts ganzes Fenster.',true);
	 Heller(x1,y1,x2,y2,maxfarbe);
	 AusschnittSL(bewegen,step,rmSchreiben);
	 END;
    ^S,
    'S': if Mausda then BEGIN
	 If GetMaxColor=255 Then
	 WriteSL('Stempel: links sprayen, rechts ganzes Fenster.',true)
	 ELSE
	 WriteSL('Stempeln mit linkem oder rechtem Mausknopf.',true);
	 Stempel(x1,y1,x2,y2);
	 AusschnittSL(bewegen,step,rmSchreiben);
	 END;
    ^Q,
    'Q': if Mausda then BEGIN
	 WriteSL('Name der QWG-Datei: ',true);
	 if qwgname='' then qwgname:=dir+fname+'.QWG';
	 InputSL(qwgname,8);
	 if pos('.',qwgname)=0 then qwgname:=qwgname+'.QWG';
	 if not fileexist(qwgname) then
	 if fileexist(qwgpfad+qwgname) then qwgname:=qwgpfad+qwgname else
	 if fileexist(dir+qwgname) then qwgname:=dir+qwgname else
	 begin
	   Writesl('* Nicht gefunden *',true);
	   delay(1000);
	   while keypressed do readkey;
	 end;
	 fsplit(fexpand(qwgname),qwgpfad,qwgname,qwgext);
	 qwgname:=qwgpfad+qwgname+qwgext;
	 WriteSL('Einfgen mit linkem oder rechtem Mausknopf.',true);
	 QWGEinfuegen(qwgname,x1,y1,x2,y2);
	 AusschnittSL(bewegen,step,rmSchreiben);
	 END;
    'M': If MausDa then
	 BEGIN
	 WriteSL('Malen: links sprayen, rechts massiv.',true);
	 repeat until not (rightmousebutton or leftmousebutton);
	 Malen(x1,y1,x2,y2,malfarbe);
	 AusschnittSL(bewegen,step,rmSchreiben);
	 END;
    ^C,
    'C': If MausDa then
	 BEGIN

	 Writesl('Stil (1..10): '+ls(malstil),TRUE);
	 FONT_HILFE(WarteFlag);
	 if not(LeftMouseButton or RightMouseButton) THEN
	 Hole_FontNr(MalStil);
	 Writesl('Text horizontal',TRUE);
	 if janeinsl then Textrichtung:=0 else Textrichtung:=1;
	 AusschnittSL(bewegen,step,rmSchreiben);

	 END;
    ^T,
    'T': If MausDa then
	 BEGIN
	   Textmalen(x1,y1,x2,y2,MalStil,Textrichtung);
	   AusschnittSL(bewegen,step,rmSchreiben);
	 END;
    ' ': begin
	 step:=8 div step; {Schalter 8 <-> 1}
	 AusschnittSL(bewegen,step,rmSchreiben);
	 end;
    '+': begin
	   if x1>=step then dec(x1,step);
	   if y1>=step then dec(y1,step);
	   if x2<=maxx-step then inc(x2,step);
	   if y2<=maxy-step then inc(y2,step);
	 end;
    '-': begin
	   if x2>=x1+step then dec(x2,step);
	   if y2>=y1+step then dec(y2,step);
	   if x1<=x2-step then inc(x1,step);
	   if y1<=y2-step then inc(y1,step);
	 end;
    '@','V',^V:
	 begin
	 Bewegen:=TRUE;
	 WriteSL('Ausschnittbreite: ',true);
	 szeile:=ls(x2-x1+1);
	 If Inputsl(szeile,5) then x2:=x1+sl(szeile)-1;
	 WriteSL('Ausschnitthhe: ',true);
	 szeile:=ls(y2-y1+1);
	 If Inputsl(szeile,5) then y2:=y1+sl(szeile)-1;
	 AusschnittSL(bewegen,step,rmSchreiben);
	 end;
    ^A,
    'A': begin
	 bewegen:=true;
	 WriteSL('Anpassung der Ausschnittgrenzen, bitte warten...',true);
	 Rahmenangleichen(x1,y1,x2,y2);
	 AusschnittSL(bewegen,step,rmSchreiben);
	 end;
    ^G,
    'G': begin
	 bewegen:=true;
	 WriteSL('Suche Objektgrenzen, bitte warten...',true);
	 Rahmenangleichen2(x1,y1,x2,y2);
	 AusschnittSL(bewegen,step,rmSchreiben);
	 end;
    #0: begin zeichen2:=readkey;
	case zeichen2 of
{<-}	#75: if bewegen then
		begin
		  dec(x1,step); dec(x1,x1 mod step);
		  dec(x2,step); dec(x2,x2 mod step);
		end else
		begin
		  dec(x2,step); dec(x2,x2 mod step);
		end;
{->}	#77: if bewegen then
		begin
		  inc(x1,step); dec(x1,(x1+1) mod step);
		  inc(x2,step); dec(x2,(x2+1) mod step);
		end else
		begin
		  inc(x2,step); dec(x2,(x2+1) mod step);
		end;
{ab}	#80: if bewegen then
		begin
		  inc(y2,step);
		  inc(y1,step);
		end else
		begin
		  inc(y2,step);
		end;
{auf}	#72: if bewegen then
		begin
		  dec(y1,step);
		  dec(y2,step);
		end else
		begin
		  dec(y2,step);
		end;
{F1,F3}	#59,#61: BEGIN
		   SetWriteMode(NormalPut);
		   line(0,getmaxy,0,getmaxy); {HARGRAVE}
		   Ausschnitthilfe(AusHauptMenue);
		 END;
{F7}    #65: Speichern(#13);
{Strg-F8}
	#101:
	  If MausDa then
	  BEGIN
	    Writesl('Stil (1..10): '+ls(malstil),TRUE);
	    FONT_HILFE(WarteFlag);
	    if not(LeftMouseButton or RightMouseButton) THEN
	    Hole_FontNr(MalStil);
	    Writesl('Text horizontal',TRUE);
	    if janeinsl then Textrichtung:=0 else Textrichtung:=1;
	    AusschnittSL(bewegen,step,rmSchreiben);
	  END;
	end; {case}
	end; {sonderzeichen}
    end; {case readkey}
    setwritemode(xorput);
    setlinestyle(userbitln,muster,normwidth);
    setcolor(farbe);
    if not (Geschrieben or (Zeichen=#27))
       then rectangle(x1a,y1a,x2a,y2a);
  end; {keypressed}
{$IFDEF Vollbildexport}
  x1:=min(getmaxx-1,lmax(0,x1));
  x2:=min(getmaxx,lmax(x2,x1+1));
  y1:=min(getmaxy-1,lmax(0,y1));
  y2:=min(getmaxy,lmax(y2,y1+1));
{$ELSE}
  x1:=min(maxx-1,lmax(0,x1));
  x2:=min(maxx,lmax(x2,x1+1));
  y1:=min(maxy-1,lmax(0,y1));
  y2:=min(maxy,lmax(y2,y1+1));
{$ENDIF}

Until Geschrieben or (Zeichen=#27);
setwritemode(copyput);
end;

VAR RPalette:Array[0..255,1..3]of Real;
CONST Farbaddition:Boolean=TRUE;
CONST FAZ:ARRAY[Boolean]of Char=('*','+');

Procedure SetRGBBit(MaxFarbe,Bit:Byte);
{Maskiert die Farbtiefe}
VAR n,m,j,a:byte;
BEGIN
m:=$FF00 shr Bit; {Maske der relevanten Bits}
a:=$7F shr Bit;   {Wird zum Runden aufaddiert}
for n:=0 to Maxfarbe do
  BEGIN
    for j:=1 to 3 do
      RGBPalette[n,j]:=(round(rlim(0,RPalette[n,j]+a,255)))and m;
    SetRGBPalette(n,rgbpalette[n,1],rgbpalette[n,2],rgbpalette[n,3]);
  END;
END;

Procedure Changergb(von,bis:integer;s:string);
var i,j,n:byte;
begin
for n:=von to bis do
for i:=1 to length(s) do
begin
if Farbaddition then
case char(s[i]) of
    'r': rpalette[n,1]:=rlim(0,rpalette[n,1]-4,255);
    'R': rpalette[n,1]:=rlim(0,rpalette[n,1]+4,255);
    'g': rpalette[n,2]:=rlim(0,rpalette[n,2]-4,255);
    'G': rpalette[n,2]:=rlim(0,rpalette[n,2]+4,255);
    'b': rpalette[n,3]:=rlim(0,rpalette[n,3]-4,255);
    'B': rpalette[n,3]:=rlim(0,rpalette[n,3]+4,255);
end {case}
else
case char(s[i]) of
    'r': rpalette[n,1]:=rpalette[n,1]*15/16;
    'R': rpalette[n,1]:=rpalette[n,1]*16/15;
    'g': rpalette[n,2]:=rpalette[n,2]*15/16;
    'G': rpalette[n,2]:=rpalette[n,2]*16/15;
    'b': rpalette[n,3]:=rpalette[n,3]*15/16;
    'B': rpalette[n,3]:=rpalette[n,3]*16/15;
end; {case}
for j:=1 to 3 do
  rgbpalette[n,j]:=round(rlim(0,rpalette[n,j],255));
setrgbpalette(n,rgbpalette[n,1],rgbpalette[n,2],rgbpalette[n,3]);
end;
end;

Procedure Kontrast(von,bis:Byte;s:char);
var n,i,j:byte;
begin
for n:=von to bis do
begin
case s of
    'k':for j:=1 to 3 do
	  rpalette[n,j]:=128+(rpalette[n,j]-128)*15/16;
    'K':for j:=1 to 3 do
	  rpalette[n,j]:=128+(rpalette[n,j]-128)*16/15;
end; {case}
for j:=1 to 3 do
  rgbpalette[n,j]:=round(rlim(0,rpalette[n,j],255));
SetRGBPalette(n,rgbpalette[n,1],rgbpalette[n,2],rgbpalette[n,3]);
end;
end;


Procedure Farbintensitaet(von,bis:Byte;s:char);
var n,i,j,grau:byte;
begin
for n:=von to bis do
begin
grau:=grauwert(n);
case s of
    'f':for j:=1 to 3 do
	  rpalette[n,j]:=Grau+(rpalette[n,j]-Grau)*15/16;
    'F':for j:=1 to 3 do
	  rpalette[n,j]:=Grau+(rpalette[n,j]-Grau)*16/15;
end; {case}
for j:=1 to 3 do
  rgbpalette[n,j]:=round(rlim(0,rpalette[n,j],255));
SetRGBPalette(n,rgbpalette[n,1],rgbpalette[n,2],rgbpalette[n,3]);
end;
end;


Procedure Negativ(maxfarbe:Byte);
var n,i:byte;
    r:rgbpaltype absolute rgbpalette; {Tippfaulheit}
begin
for n:=0 to maxfarbe do
  begin
    r[n,1]:=255-r[n,1];
    r[n,2]:=255-r[n,2];
    r[n,3]:=255-r[n,3];
    SetRGBPalette(n,r[n,1],r[n,2],r[n,3]);
    for i:=1 to 3 do rpalette[n,i]:=r[n,i];
  end;
  if getmaxcolor>maxfarbe then
  {Hintergrund von Farbe null unterscheidbar machen:}
  begin
    n:=getmaxcolor;
    for i:=1 to 3 do
      if r[0,i]<128 then r[n,i]:=255 else r[n,i]:=0;
    SetRGBPalette(n,r[n,1],r[n,2],r[n,3]);
    for i:=1 to 3 do rpalette[n,i]:=r[n,i];
  end;
end;

Procedure Bildausschnitt(maxfarbe:integer;
			 clipboardzwang,AusHauptMenue:boolean;
			 dir:dirstr;originalname:namestr);
{Aus HauptMenue oder aus dem Paletteneditor aufrufbar}
VAR RGBSave16:ARRAY[1..3*16] of Byte;
  {Speichert die Originalpalette bei geditherten Bildern zwischen}
VAR InsClipBoard:Boolean;
VAR f:File;
VAR BYtesGelesen:Word;
VAR DIRBAK:DIRstr;
VAr Name:NameStr;
VAR EXT: EXTStr;
VAR i:Integer;
VAR Puffer:^Puffertyp;
VAR MaxPuffer:Word;
begin
  InsClipBoard:=FALSE;
  if AusschnittZiel='' Then Ausschnittziel:=dir;
  WriteSL('Dateiname des Ausschnitts: ',true);
  fsplit(fexpand(Ausschnittziel+originalname),szeile,name,ext);
  ext:=Ausschnittext;
  while fileexist(szeile+name+ext) do incname(name);
  szeile:=szeile+name+ext;
  if clipboardzwang then szeile:='';
  if clipboardzwang or inputsl(szeile,9) then
  begin
    if shellresident and (szeile='')
    then
    begin
      szeile:=Programmpfad+'MV}MV{CL.WPG';
      InsClipBoard:=TRUE;
    end;

    if not insclipboard then
    begin
    Getdir(0,dirbak);
    CHDIR(CHdirformat(Ausschnittziel));if ioresult<>0 then;
    szeile:=upstr(fexpand(szeile));
    chdir(dirbak);
    WildCardExpand(Szeile,Originalname);
    fsplit(szeile,AusschnittZiel,name,Ausschnittext);
    if fileexist(szeile) then
    begin
      writesl(szeile+' existiert. berschreiben ',true);
      if not janeinsl then exit;
    end;
    end;

    if zuvielefarben then
    {Dann stehen nicht die RGB-Werte der Bildschirmanzeige, sondern
     die aus der Datei in RGBPalette}
    begin
      move(RGBPalette,RGBSave16,3*16);
      For i:=0 to 7 do
      begin
       SETRGBpalette(i,
		    (i and 4)shr 2*170, {Rot}
		    (i and 2)shr 1*170, {Grn}
		    (i and 1)*170);     {Blau}
       SETRGBpalette(8+i,
		    (i and 4)shr 2*170+85, {Rot}
		    (i and 2)shr 1*170+85, {Grn}
		    (i and 1)*170+85);     {Blau}
      end;
      SETRGBPalette(6,170,85,0); {Braun}
    END;
    Ausschnitt_schreiben(maxfarbe,Breitenfaktor,szeile,
			 InsClipBoard,AusHauptMenue);
    If InsClipBoard Then
    BEGIN
      assign(f,ProgrammPfad+'MV}MV{CL.WPG');
      reset(f,1); If ioresult=0 then
      begin
	maxpuffer:=lmin(maxavail,sizeof(puffertyp));
	getmem(puffer,maxpuffer);
	blockread(f,puffer^,maxpuffer,bytesgelesen);
	WPShell_Write(6,Puffer^[17],Bytesgelesen-16);
	while bytesgelesen=maxpuffer do
	begin
	  blockread(f,puffer^,maxpuffer,bytesgelesen);
	  WPShell_Append(6,Puffer^[1],Bytesgelesen);
	end;
	close(f);
	erase(f);
	FREEMEM(puffer,MAXPUFFER);
      end;
    END;
    If ZuVieleFarben Then Move(RGBSave16,RGBPalette,3*16);
  end;
end;

Procedure Palette_aendern(Dateiname:PathStr;PalPos:LongInt;
			  PalFirst, PalFarben:Integer);
var
    psave:rgbpaltype;
    rgbsave16:array[1..3*16] of Byte;
      {Enthlt whrend des Schreibens eines geditherten Bildes
       die OriginalPalette}
    maxfarbe,
    x,y,
    r,g,b,n,i,j,von,bis,
    offset,
    breite:integer;
    z,z2:char;
    mausbewegt,
    mausgedrueckt,
    farbleisteneu:boolean;
    ByteFile:File; {Zum Paletteneintragen}
    ior:WORD; {Merkt sich IOResult}
    RelevBits:Byte; {Anzahl relevanter Bits}
    pfad:pathstr;
    name:namestr;
    ext:extstr;
    valcode:Integer;
const pal16header:array[1..6]of Byte=(14,52,0,0,16,0);
      endwpg:array[1..2]of Byte=(16,0);



    Procedure UpDateFadenKreuz;
    BEGIN
    if Mausbewegt then
    begin
      fadenkreuz(x,y);
      x:=min(lmax(0,x+dx),getmaxx);
      y:=min(lmax(0,y+dy),getmaxy);
      fadenkreuz(x,y);
      n:=getpixel(x,y);
      z:=#255;
      delay(50);
    end;
    END;

begin
  If (Dateiname<>'')
  AND not IstWPGDatei(Dateiname) then
  begin
    WriteSL('Palettennderung hier nicht erlaubt!',true);
    sound(50);delay(200);nosound;
    NoPalHilfe;
    exit;
  end;
  fsplit(Dateiname,pfad,name,ext);
  setviewport(0,0,getmaxx,getmaxy,false);
  psave:=rgbpalette;
  RelevBits:=6; {Grenze der Sichtbarkeit}
  for n:=0 to 255 do
  begin
    for i:=1 to 3 do
      rpalette[n,i]:=rgbpalette[n,i];
  end;
  If PalFirst+Palfarben=256
  Then MaxFarbe:=255
  else maxfarbe:=15; {Umschaltbar 15 <-> 255}
  n:=0;
  von:=1;
  bis:=0;
  farbleiste(maxfarbe,breite,offset,farbleisteneu);
  x:=getmaxx+16;
  y:=getmaxy+16;
  fadenkreuz(x,y);

  set_mouse_x_range(0,getmaxx);
  set_mouse_y_range(0,getmaxy);
  Set_Graphics_icon(0,0,0);
  repeat
    if MonoChrom OR ZuVieleFarben then
    BEGIN
    Setwritemode(NormalPut);line(0,getmaxy,0,getmaxy);{HARGRAVE}
    for i:=von to bis do
    begin
      setfillpattern(monopattern[grauwert(i)div 4],getmaxcolor);
      bar(offset+1+i*breite,maxy+3,offset-1+(i+1)*breite,getmaxy-1);
    end;
    END;
    setcolor(getmaxcolor);
    setwritemode(xorput);
    rectangle(offset+n*breite,maxy+2,offset+(n+1)*breite,getmaxy);
    setwritemode(NormalPut);line(0,getmaxy,0,getmaxy);
    {Das ist mal wieder so eine magische Zeile...
     Im SVGA-Treiber von Hargrave ist ein Bug, der
     fr Muster bei BAR sorgt, wenn von XORPUT auf NORMALPUT
     gewechselt wurde. Aber nicht, wenn vorher
     eine Linie gezeichnet wurde...}

    repeat
      if ((mem[$40:$17]and 16) = 16) then {Scroll-Lock}
      begin
	if (von<>0) or (bis<>maxfarbe) or (farbleisteneu) then
	begin
	  von:=0; bis:=maxfarbe;
	  setfillstyle(solidfill,getmaxcolor);
	  bar(0,maxy+2,offset-2,getmaxy);
	  setcolor(0);
	  outtextxy(0,maxy+3,FAZ[Farbaddition]+'GLOBAL');
	  setcolor(getmaxcolor);
	end
      end
      else
      if (von<>n) or (bis<>n) or (farbleisteneu) then
      begin
	von:=n; bis:=n;
	setfillstyle(solidfill,n);
	bar(0,maxy+2,offset-2,getmaxy);
	if Grauwert(n)>128 then setcolor(0);
	outtextxy(0,maxy+3,FAZ[Farbaddition]+ls(n));
	setcolor(getmaxcolor);
      end;
    farbleisteneu:=FALSE;

    Mausgedrueckt:=FALSE;
    Mausbewegt:=FALSE;
    If Mausda then
    begin
      Mouse_Motion(dx,dy);
      mausbewegt:=(dx<>0) or (dy<>0);
      If RightMouseButton then
      begin
	 changergb(von,bis,'RGB');
	 delay(50);
	 Mausgedrueckt:=True;
      end;
      If LeftMouseButton then
      begin
	 changergb(von,bis,'rgb');
	 delay(50);
	 Mausgedrueckt:=True;
      end;
    end; {If MausDa}

    until keypressed or mausbewegt or mausgedrueckt;

    setwritemode(xorput);
    rectangle(offset+n*breite,maxy+2,offset+(n+1)*breite,getmaxy);
    setwritemode(NormalPut);

    updatefadenkreuz;

    If Keypressed Then begin

    z:=readkey;
    case z of
    '+','-':
	begin
	  Farbaddition:=TRUE;
	  Farbleiste(maxfarbe,breite,offset,farbleisteneu);
	end;
    '*','/':
	begin
	  Farbaddition:=FALSE;
	  Farbleiste(maxfarbe,breite,Offset,FarbLeisteNeu);
	end;

    ^A: If Dateiname<>'' THEN
	{Sonst wurde der Paletteneditor schon aus der
	 Ausschnittfunktion aufgerufen}
	begin
	  fadenkreuz(x,y);
	  PalIgnore:=TRUE;
	  {sonst werden 0 und GetmaxColor auf schwarz und wei gesetzt}
	  Bildausschnitt(maxfarbe,FALSE,FALSE,pfad,name+ext);
	  {nicht ins Clipboard und nicht wieder den Paletteneditor aufrufen}
	  PalIgnore:=FALSE;
	  farbleiste(maxfarbe,breite,Offset,FarbLeisteNeu);
	  fadenkreuz(x,y);
	end
	ELSE Z:=#13;
    ^E: begin
	  SetEGARGB;
	  for i:=0 to 15 do
	  for j:=1 to 3 do
	    rpalette[i,j]:=rgbpalette[i,j];
	  farbleiste(maxfarbe,breite,Offset,FarbLeisteNeu);
	end;
    ^N: begin
	  Negativ(maxfarbe);
	  if MonoChrom OR ZuVieleFarben then farbleiste(maxfarbe,breite,Offset,FarbLeisteNeu);
	end;
    ^G: begin
	  if maxfarbe=255 then
	  for i:=0 to 255 do SetRGBPalette(i,i,i,i)
	  else
	  for i:=0 to 15 do SetRGBPalette(i,17*i,17*i,17*i);
	  for i:=0 to 255 do
	    for j:=1 to 3 do
	      rpalette[i,j]:=rgbpalette[i,j];
	  if MonoChrom OR ZuVieleFarben then farbleiste(maxfarbe,breite,Offset,FarbLeisteNeu);
	end;
    ^Z: begin {Zwischentne interpolieren}
	 Writesl('Erste Farbnummer: ',true);
	 szeile:=ls(0);
	 if inputsl(szeile,10) then begin
	 val(szeile,i,valcode);
	 if valcode=0 then begin
	 Writesl('Zweite Farbnummer: ',true);
	 szeile:=ls(maxfarbe);
	 if inputsl(szeile,10) then begin
	 val(szeile,j,valcode);
	 if valcode=0 then
	 begin
	 Writesl('Interpoliere Zwischentne, bitte warten...',true);
	 if j<i then
	 begin
	   n:=j;
	   j:=i;
	   i:=n;
	 end;
	 if i<0 then i:=0;
	 if j>maxfarbe then j:=maxfarbe;
	 if i<>j then
	   for n:=i to j do
	   begin
	     r:=round(rpalette[i,1]
		      +(rpalette[j,1]-rpalette[i,1])*(n-i)/(j-i));
	     g:=round(rpalette[i,2]
		      +(rpalette[j,2]-rpalette[i,2])*(n-i)/(j-i));
	     b:=round(rpalette[i,3]
		      +(rpalette[j,3]-rpalette[i,3])*(n-i)/(j-i));
	     if r<0 then r:=0;
	     if r>255 then r:=255;
	     if g<0 then g:=0;
	     if g>255 then g:=255;
	     if b<0 then b:=0;
	     if b>255 then b:=255;
	     SetRGBPalette(n,r,g,b)
	   end;
	  for r:=i to j do
	    for g:=1 to 3 do
	      rpalette[r,g]:=rgbpalette[r,g];
	 end; {2. Zahl korrekt eingegeben}
	 end; {2. Zahl eingegeben}
	 end; {1. Zahl korrekt eingegeben}
	 end; {1. Zahl eingegeben}
	 farbleiste(maxfarbe,breite,Offset,FarbLeisteNeu);
	end;

    #9: begin
	  maxfarbe:=maxfarbe xor $f0; { 255 <-> 15}
	  farbleiste(maxfarbe,breite,Offset,FarbLeisteNeu);
	  n:=min(n,maxfarbe);
	end;

    '1'..'8': BEGIN
		RelevBits:=ord(z)-48;
		SetRGBBit(MaxFarbe,RelevBits);
	      END;
    'r','R',
    'g','G',
    'b','B': ChangeRGB(von,bis,z);
    'y': ChangeRGB(von,bis,'rg'); {Gelb}
    'Y': ChangeRGB(von,bis,'RG');
    'c': ChangeRGB(von,bis,'gb'); {Cyan}
    'C': ChangeRGB(von,bis,'GB');
    'm': ChangeRGB(von,bis,'rb'); {Magenta}
    'M': ChangeRGB(von,bis,'RB');
    'w': ChangeRGB(von,bis,'rgr'); {Braun (broWn)}
    'W': ChangeRGB(von,bis,'RGR');
    'k','K': begin Kontrast(von,bis,z);
	     if MonoChrom OR ZuVieleFarben then farbleiste(maxfarbe,breite,Offset,FarbLeisteNeu);
	     end;
    'f','F': Farbintensitaet(von,bis,z);
    #0:
      begin
	z2:=readkey;
	case z2 of
{F1}	  #59: Palettenhilfe(Dateiname<>'');
{<-}	  #75: if n>maxfarbe then n:=maxfarbe else if n>0 then dec(n);
{->}	  #77: if n<maxfarbe then inc(n) else n:=maxfarbe;
{auf}	  #72: changergb(von,bis,'RGB');
{ab}	  #80: changergb(von,bis,'rgb');
{C-Pos1} #119: GraphDefaults;
{Pos1}	  #71: begin
	       for i:=PalFirst to PalFirst+PalFarben-1 do
	       begin
		 SetRGBPalette(i,psave[i,1],psave[i,2],psave[i,3]);
		 for j:=1 to 3 do rpalette[i,j]:=psave[i,j];
	       end;
	       if MonoChrom OR ZuVieleFarben then farbleiste(maxfarbe,breite,Offset,FarbLeisteNeu);
	       end;
	end {case z2}
      end {#0}
    end; {case z}
    while keypressed do readkey;
  End; {Keypressed}
  until z in [#27,#13,' '];
  fadenkreuz(x,y); {lschen}

  Case z of
  ' ': PalIgnore:=TRUE;  {Beim Leerzeichen wird die Palette
			  zum Bildaufbau benutzt}
  #13:
  If Dateiname<>'' {Aus HauptMenue} THEN
  begin
    if PalPos=0 Then
    begin
      PalFarben:=16;
      PalFirst:=0;
      WriteSL('Neue Palette an '+Dateiname+' anhngen',true);
    end
    else
      WriteSL('Neue Palette in '+Dateiname+' eintragen',true);
    if janeinsl then
    begin
      if PalPos=0 then
      WriteSL('Hnge neue Palette mit 16 Farben an, bitte warten.',true)
      else
      WriteSL('Trage Palette mit '+ls(PalFarben)+' Farben ein, bitte warten.',true);
      assign(ByteFile,Pfad+'TEST_IOR.$$$');
      Rewrite(ByteFile); ior:=ioresult;
      IF ior=0 then
      begin
	Close(ByteFile);
	Erase(ByteFile);
	Assign(ByteFile,Dateiname);
	reset(bytefile,1);
	ior:=ioresult;
	if ior=0 then
	BEGIN
	  if palpos=0 then
	  begin
	    seek(ByteFile,Filesize(Bytefile)-2);
	    blockwrite(ByteFile,Pal16Header,6);
	  end
	  else seek(ByteFile,PalPos);
	  BlockWrite(ByteFile,RGBPalette[Palfirst],3*PalFarben);
	  if palpos=0 then BlockWrite(ByteFile,EndWpg,2);
	  close(ByteFile);
	  ior:=ioresult;
	END;
      END;
      DosErrSL(ior);
      if ior<>0 then
      begin
	sound(20);
	delay(200);
	nosound;
	delay(800);
	while keypressed do readkey;
      end;
    end; {Diskette beschreibbar}
  end; {#13}
  end {case z beim Ausgang}
end;



begin end.

