{$A+,B-,D+,E+,F+,I-,L+,N+,O+,R-,V-,X+}
{ $DEFINE SEWVIEW}
unit DXFview;
{Darstellung von DXF-Dateien in ZEIGWPG

 15.11.92}

interface uses crt,graph,viewsl,viewprim,drehfont;

procedure ZEIGDXF(dir,name:string;x1,y1,x2,y2:Longint);

implementation

{$IFopt N+}
TYPE Real=Double;
{$ENDIF}
VAR DXF:Text;
    puffer:^Puffertyp;
    Maxpuffer:word;


PROCEDURE ZEIGDXF(dir,name:string;x1,y1,x2,y2:Longint);
var
  xvaria,yvaria,
  breite,hoehe,
  min_x,min_y,
  max_x,max_y:Real;
  r,
  v1,v2,varia:Real;
  textFlags,
  PolyFlags,
  xas,yas,
  x0,y0:Word;
  x,y,
  xa,ya,
  x_1,y_1,
  wi,wi_1,witemp,
  radius,
  hzx,hzy,hzz:integer;
  fertig:Boolean;
  code:Integer;
  textZeile,
  Zeile:String;
  Letzterbefehl:String;
  Stiftoben,extvorh:Boolean;
  valcode:integer;
  test_a,test_b:integer;
  xr,x_1r:real;
  plspiegeln:Boolean;

  function lrstrip(s:string):string;
  begin
  while s[length(s)]=' ' do dec(s[0]);
  while (s[1]=' ') and (length(s)>0) do delete(s,1,1);
  lrstrip:=s;
  end;

BEGIN
  ASSIGN(DXF,dir+Name);
  maxpuffer:=lmin(maxavail,sizeof(Puffertyp));
  if maxpuffer>128 then
  begin
  getmem(puffer,maxpuffer);
  settextbuf(DXF,puffer^,maxpuffer);
  end;
  RESET(DXF); if ioresult=0 then
BEGIN

  Fertig:=KeyPressed;
  min_x:=0;
  max_x:=1000;
  min_y:=0;
  max_y:=1000;
  extvorh:=false; {Sind die wirklichen Zeichnungsgrenzen im Header vermerkt?}

  REPEAT
    Readln(DXF,Code);  If IORESULT<>0 Then Fertig:=TRUE;
    Readln(DXF,Zeile); If IORESULT<>0 Then Fertig:=TRUE;
    If Code=9 then
    BEGIN
    If not extvorh then
    if Zeile='$LIMMIN' then
      begin
	readln(dxf,code);readln(dxf,min_x); If IORESULT<>0 Then Fertig:=TRUE;
	readln(dxf,code);readln(dxf,min_y); If IORESULT<>0 Then Fertig:=TRUE;
      end
    ELSE
    if Zeile='$LIMMAX' then
      begin
	readln(dxf,code);readln(dxf,max_x); If IORESULT<>0 Then Fertig:=TRUE;
	readln(dxf,code);readln(dxf,max_y); If IORESULT<>0 Then Fertig:=TRUE;
      end;
    if Zeile='$EXTMIN' then
      begin
	readln(dxf,code);readln(dxf,min_x); If IORESULT<>0 Then Fertig:=TRUE;
	readln(dxf,code);readln(dxf,min_y); If IORESULT<>0 Then Fertig:=TRUE;
	extvorh:=TRUE;
      end
    ELSE
    if Zeile='$EXTMAX' then
      begin
	readln(dxf,code);readln(dxf,max_x); If IORESULT<>0 Then Fertig:=TRUE;
	readln(dxf,code);readln(dxf,max_y); If IORESULT<>0 Then Fertig:=TRUE;
	EXTVORH:=TRUE;
      end
    end;
    If Keypressed then fertig:=True;
  UNTIL (Zeile='ENTITIES') or FERTIG or EOF(DXF);

  IF EinsZuEins
    THEN BEGIN Xas:=1; Yas:=1 END
  ELSE
    BEGIN
      GetAspectRatio(Xas,Yas);
      Xas:=round(Xas*10000.0/Breitenfaktor);
    END;
  if max_x=min_x then breite:=1 else breite:=max_x-min_x+1;
  if max_y=min_y then hoehe:=1 else hoehe:=max_y-min_y+1;
  v1:=1.0*(x2-x1+1)/breite;
  v2:=1.0*(y2-y1+1)/hoehe*Yas/Xas;

  {Je nachdem, ob das Bild zu hoch oder zu breit ist, wird
   v1 oder v2 genommen:}
  IF v1>v2 THEN
  BEGIN
    xvaria:=v2*0.95;
    yvaria:=v2*Xas/Yas*0.95;
  END
  ELSE
  BEGIN
    xvaria:=v1*0.95;
    yvaria:=v1*Xas/Yas*0.95;
  END;

  x0:=x1+((x2-x1)-round(xvaria*(max_x-min_x))) div 2; {links}

  y0:=y2-((y2-y1)-round(yvaria*(max_y-min_y)))div 2; {unten}

  IF infdatvorh
  THEN zeiginfozeile(name);
{$IFNDEF SEWVIEW}
  IF NOT infogefunden THEN
  Writesl(name+', Originalgre: '+
	  ls(round((max_x-min_x)))+' x '+
	  ls(round((max_y-min_y))),true);
{$ENDIF}

  LetzterBefehl:='';
  settextstyle(2,0,4);
  plspiegeln:=FALSE;
  xr:=0;
  x_1r:=0;

  REPEAT
    Readln(DXF,Code);  If IORESULT<>0 Then Fertig:=TRUE;
    Readln(DXF,Zeile); If IORESULT<>0 Then Fertig:=TRUE;
    Zeile:=lrstrip(Zeile);
    val(zeile,r,valcode);

    Case Code of
    0:
    BEGIN
    if LetzterBefehl='VERTEX' then
      BEGIN
	If stiftoben then
	begin
	xa:=x;
	ya:=y;
	moveto(x,y)
	end
	else lineto(x,y);
	Stiftoben:=False;
      END {Vertex}
    ELSE
    if LetzterBefehl='LINE' then
      begin
	line(x,y,x_1,y_1);
      end
    ELSE
    if LetzterBefehl='ARC' then
      begin
	arc(x,y,wi,wi_1,radius);
      end
    ELSE
    if LetzterBefehl='CIRCLE' then
      begin
	CIRCLE(x,y,radius);
      end
    ELSE
    if LetzterBefehl='SEQEND' then
      begin
	if (polyflags and 1)=1 then lineto(xa,ya);
        plspiegeln:=false;
      end
    ELSE
    if LetzterBefehl='TEXT' then
      begin
        settextstyle(2,wi,4);
	{Jetzt folgt eine programmiertechnische Kapriole:
	 Die iterative Textgrenermittlung, weil die Skalierung
	 bei Turbo Pascal manchmal derben Mist produziert.}
	test_a:=1;
	test_b:=1;
	repeat
	  setusercharsize(test_a,test_b,test_a,test_b);
	  if textheight('A')<RADIUS then inc(test_a) else inc(test_b);
	until (textheight('A')=RADIUS)
	  or (test_a=255)
	  or (test_b=255);

        {Steuercodes fr Unterstreichen u.. entfernen}
	while pos('%%',textzeile)<>0
	do delete(textzeile,pos('%%',textzeile),3);

	  case textflags of
	  1:begin
	      settextjustify(centertext,bottomtext);
	      Outtextxy(x_1,y_1,textzeile);
	    end;
	  2:begin
	      settextjustify(righttext,bottomtext);
	      Outtextxy(x_1,y_1,textzeile);
	    end;
	  4:begin
	      settextjustify(centertext,centertext);
	      Outtextxy(x_1,y_1,textzeile);
	    end;
	  else begin
	      settextjustify(lefttext,bottomtext);
	      Outtextxy(x,y,textzeile);
	    end;
	  end;
      end; {text}
    LetzterBefehl:=ZEILE;
    if valcode<>0 then
	if zeile='TEXT' then
	begin
	  wi:=0;
	  textflags:=0;
	end
	else
	if zeile='POLYLINE' then
	begin
	  PolyFlags:=0;
	  Stiftoben:=TRUE;
          plspiegeln:=false;
	end
    END; {0}
    10:begin
         if plspiegeln then xr:=-r else xr:=r;
         x:=x0+round(xvaria*(xr-min_x));
       end;
    11:begin
         if plspiegeln then x_1r:=-r else x_1r:=r;
         x_1:=x0+round(xvaria*(x_1r-min_x));
       end;
    20:y:=y0-round(yvaria*(r-min_y));
    21:y_1:=y0-round(yvaria*(r-min_y));
    40:Radius:=round(xvaria*r);
    50:wi:=round(r);
    51:wi_1:=round(r);
    70:polyflags:=round(r);
    72:textflags:=round(r);
    {Die folgenden Gruppen bestimmen die "Hochzugsrichtung".
     Keine Ahnung, was das ist, doch unter bestimmten
     Umstnden (s.u.) sind die X-Koordinaten gespiegelt...
     Trat bei einigen DXF-Dateien von SEW auf.}
    210:hzx:=round(r);
    220:hzy:=round(r);
    230:begin
          hzz:=round(r);
          if (hzx=0)
          and(hzy=0)
          and(hzz=-1)
          then
          begin
            if LetzterBefehl='POLYLINE' then plspiegeln:=true;
            x   :=x0+round(xvaria*(-xr-min_x));
            x_1 :=x0+round(xvaria*(-x_1r-min_x));
            witemp:=wi;
            wi  :=180-wi_1;   if wi<0 then wi:=wi+360;
            wi_1:=180-witemp; if wi_1<0 then wi_1:=wi_1+360;
          end;
        end;
    1:TextZeile:=ZEILE;
    end; {case}
    If Keypressed then Fertig:=True;
  UNTIL FERTIG or EOF(DXF);
END; {Kein Fehler beim ffnen der Datei}
  if maxpuffer>128 then FREEMEM(puffer,MAXPUFFER);

  CLOSE(DXF);if ioresult<>0 then;

  {Font-Einstellungen verndert. Deshalb hier das Zurcksetzen.}
  IF fontnr=0 THEN
    SetTextstyle(0,0,Charsize div 8)
  ELSE
  BEGIN
    SetTextStyle(Fontnr,0,4);
    IF graphresult<>0 THEN     {Fehler -11: Unbekannter Fehler}
      SetTextStyle(Fontnr,0,4); {Jetzt klappt's meist...}
    SetUserCharSize(Charsize,TextHeight('A'),Charsize,TextHeight('A'));
  END;
  if graphresult<>0 then;
  Settextjustify(Lefttext,TopText);
END;

BEGIN END.

