{$A+,B-,D+,E-,F+,G-,I-,L+,N-,O+,R-,S-,V-,X+}
UNIT General;

{Eine wirre Sammlung von Assembler-Allerlei. Ein Hoch auf den eingebauten
 Linker von Turbo-Pascal, der den unbenutzen Code rausschmeit. Wer
 Kleinweichs Quiek-Pascal benutzt, darf von Hand sieben...}

{$L FillWord}
{$L BINSTR}
{$L Hexstr}
{$L Pruefe}
{$L InvHerc}
{$L Scrollup}
{$L BitSum}
{$L LBitSum}
{$L RBitSum}
{$L HiWord}

INTERFACE
TYPE BINSTRTYP=STRING[16];
     Hexstrtyp=string[4];


PROCEDURE FillWord(Var x; Count,What:Word);
FUNCTION BINSTR(What:Word):Binstrtyp;
FUNCTION HEXSTR(What:Word):hexstrtyp;
FUNCTION BITSUM(What:WORD):Byte;
FUNCTION LBITSUM(B1,B2,B3,B4:WORD):Byte;
FUNCTION RBITSUM(B1,B2,B3,B4:WORD):Byte;
FUNCTION LRBITSUM(a,b,c,d:WORD):Word;
FUNCTION HIWORD(L:Longint):WORD;
PROCEDURE Pruefe(VAR Buffer;VAR Vorher:Longint;Zaehler:Word);
PROCEDURE InvHerc;
PROCEDURE Scrollup;
PROCEDURE ColdBoot;

IMPLEMENTATION

PROCEDURE FillWord(Var x; Count,What:Word);External;
{  Fllt einen Speicherbereich X von COUNT 2-Byte-Worten
   mit dem Wert WHAT.
}

FUNCTION BINSTR(What:Word):Binstrtyp;External;
{  Umwandlung eines WORD-Wertes in eine 16stellige Binrzahl
}

FUNCTION HEXSTR(What:Word):hexstrtyp;External;
{  Umwandlung eines WORD-Wertes in eine 4stellige Hexzahl
}

FUNCTION BITSUM(What:WORD):Byte;External;
{  Bildet die Summe der Bits eines WORD-Wertes.
   (Brauche ich fr mein LiesGEM-Programm)
}

FUNCTION LBITSUM(B1,B2,B3,B4:WORD):Byte;External;
{  Bildet die Summe der Bits der linken Nibble der unteren Bytes der vier
   WORD-Werte.
   (Brauche ich fr mein LiesGEM-Programm)
}

FUNCTION RBITSUM(B1,B2,B3,B4:WORD):Byte;External;
{  Bildet die Summe der Bits der rechten Nibble der unteren Bytes der vier
   WORD-Werte.
   (Brauche ich fr mein LiesGEM-Programm)
}

FUNCTION HIWORD(L:LONGINT):WORD;External;
{  Liefert das hherwertige WORD eines LONGINT-Wertes zurck. Brauche
   ich, um in ZEIGWPG V1.0 die Division durch 65536 zu ersetzen.
   HIWORD liefert einen GERUNDETEN Wert zurck, es schneidet nicht
   nur die unteren 16 Bit ab!}

PROCEDURE Pruefe(VAR Buffer;VAR Vorher:Longint;Zaehler:Word);External;
{  Bildet eine Prfsumme ber ZAEHLER Word-Werte in BUFFER.
   Das obere Wort von VORHER enthlt die Summe der Buffer-
   Elemente, das untere Wort wird ber XOR gebildet. Der
   Wert, den VORHER beim Aufruf hat, wird bercksichtigt
   (daher der Name)
}

PROCEDURE InvHerc; External;
{  Invertiert den Speicherbereich von $B000:0000 bis $B000:$7FFF
   (Hercules-Grafikseite 0)
}

PROCEDURE Scrollup; External;
{  Pixelweises Scrollen der Hercules-Grafikseite 0
}

PROCEDURE ColdBoot;
{  Kaltstart mit RAM-Test und so.}
BEGIN
inline($B8/$40/$00/           { MOV AX,40 }
       $8E/$D8/               { MOV DS,AX }
       $B8/$7f/$7f/           { MOV AX,7F7F }
       $A3/$72/$00/           { MOV [72],AX }
       $EA/$00/$00/$FF/$FF);  { JMP FFFF:0000 }
END;

FUNCTION LRBitsum(a,b,c,d:Word):WORD;assembler;
{Zhlt die Bits in den oberen und unteren Halbbytes von jeweils 4 Byte.
 Summe ist im oberen und unteren Byte des Ergebnisses.
 Die oberen Bytes von A..D werden vernachlssigt.
 A: 0010 0100
 B: 0011 1100
 C: 1101 0011
 D: 0101 0000
 ------------
 :    8    5 -> $0805 als Rckgabewert

 Summe wird jedoch um eins herabgesetzt: 16->15, 1->0, 0->0
}
asm
  XOR BX,BX
  MOV AX,a

  SHR AL,1
  ADC BL,0
  SHR AL,1
  ADC BL,0
  SHR AL,1
  ADC BL,0
  SHR AL,1
  ADC BL,0

  SHR AL,1
  ADC BH,0
  SHR AL,1
  ADC BH,0
  SHR AL,1
  ADC BH,0
  SHR AL,1
  ADC BH,0

  MOV AX,b

  SHR AL,1
  ADC BL,0
  SHR AL,1
  ADC BL,0
  SHR AL,1
  ADC BL,0
  SHR AL,1
  ADC BL,0

  SHR AL,1
  ADC BH,0
  SHR AL,1
  ADC BH,0
  SHR AL,1
  ADC BH,0
  SHR AL,1
  ADC BH,0

  MOV AX,c

  SHR AL,1
  ADC BL,0
  SHR AL,1
  ADC BL,0
  SHR AL,1
  ADC BL,0
  SHR AL,1
  ADC BL,0

  SHR AL,1
  ADC BH,0
  SHR AL,1
  ADC BH,0
  SHR AL,1
  ADC BH,0
  SHR AL,1
  ADC BH,0

  MOV AX,d

  SHR AL,1
  ADC BL,0
  SHR AL,1
  ADC BL,0
  SHR AL,1
  ADC BL,0
  SHR AL,1
  ADC BL,0

  SHR AL,1
  ADC BH,0
  SHR AL,1
  ADC BH,0
  SHR AL,1
  ADC BH,0
  SHR AL,1
  ADC BH,0

  OR BH,BH
  JZ @1
  DEC BH
@1:
  OR BL,BL
  JZ @2
  DEC BL
@2:
  MOV AX,BX
end;


BEGIN END.
