{$A+,B-,D+,E+,F+,I-,L+,N+,O+,R-,V-,X+}
unit IMGVIEW;

interface

procedure liesgemimg;

implementation
uses
graph,
viewprim,
general,
crt,
viewsl
;
(*---------------------------------------------------------------------
	  4 Monochrome Zeilen nach 16 Graustufen
---------------------------------------------------------------------*)

Procedure Monomachgrau(y:Integer;Zeile:Bytefeldtyp;Laenge:Integer);
VAR M,Y4:Integer;
    C:Byte;
    W:Word;
    m2gzeile    :ARRAY[0..3] of BytefeldTyp;
		 {Fr Mononachgrau}
BEGIN
  move(zeile[0],m2gzeile[y mod 4][0],Laenge);
  if y mod 4 = 3 then
  BEGIN
    Y4:=Y DIV 4;
    for m:=0 to laenge-1 do
    begin
      W:=LRBitSum(M2GZeile[0,m],M2GZeile[1,m],M2GZeile[2,m],M2GZeile[3,m]);
      putpixel(M*2,y4,hi(W));
      putpixel(M*2+1,y4,lo(W));
    end;
  END;
END;

procedure liesgemimg;
Label Fehler;
VAR
    blockzahl,gelesen:word;
    imgheader:array[1..16] of Byte;
    zeilenkopf:array[1..2] of Byte;
    zeile:Bytefeldtyp;
    wzeile:Array[0..1024] of Word Absolute Zeile;
    laenge,
    n,m,m8,i:word;
    b,c:word;

begin
  if ioresult<>0 then; {Wo kommt das her?!!!}
  blockread(wpg,imgheader,16,gelesen);
    if ioresult<>0 then goto fehler;
  blockzahl:=imgheader[15]*256+imgheader[16];
  if blockzahl=0 then goto fehler;
  Falschertyp:=FALSE;

  If Zeichnungbegonnen and not keypressed then
  begin
    {Zeichenflche lschen}
    setfillstyle(userfill,HGFarbe);
    setfillPattern(HGMuster,HGfarbe);
    bar(0,0,maxx,maxy);
    Zeichnungbegonnen:=FALSE;
  END;

IF Monochrom or not graustufen then
  begin
  Setrgbpalette(0,0,0,0);
  SetRGBPalette(1,255,255,255);
  WriteSL('Erwarte monochrome GEM-Datei mit '+ls(blockzahl)+' Zeilen.',true);
  if blockzahl>maxy then
    begin
      blockzahl:=maxy+1;
      WriteSL(' Stelle '+ls(blockzahl)+' Zeilen dar.',false);
    end;
  end
Else {16 Farben}
  Begin
  For i:=0 to 15 do SetRGBPalette(i,17*i,17*i,17*i);
  WriteSL('Erwarte 16-farbige GEM-Datei mit '+ls(blockzahl div 4)+' Zeilen.',true);
  if blockzahl>4*maxy then
    begin
      blockzahl:=4*maxy;
      WriteSL(' Stelle '+ls(maxy)+' Zeilen dar.',false);
    end;
  END;


  for n:=0 to blockzahl-1 do
  if not (keypressed or (ioresult<>0)) then
  begin
    blockread(wpg,zeilenkopf,2); if ioresult<>0 then goto fehler;
    if zeilenkopf[1]=0 then
    begin
      writesl('Kann keine gepackten IMG-Dateien darstellen.',true);
      exit;
    end;
    blockread(wpg,zeile,zeilenkopf[2]); if ioresult<>0 then goto fehler;

    If Monochrom or not Graustufen then
    BEGIN
    laenge:=min(zeilenkopf[2],(maxx+1)div 8);;
    for m:=0 to laenge div 2 do wzeile[m]:=not wzeile[m];
    If Hercules then Move(zeile,mem[$B000:hgaddress[n]],laenge)
    else if EGAVGA16 then move(Zeile,mem[$a000:n*EGAVGABreite],laenge)
    ELSE
      for m:=0 to laenge-1 do
      begin
	c:=not zeile[m];
	m8:=m*8;
	putpixel(m8,n,byte((c and 128)=0));
	putpixel(m8+1,n,byte((c and 64)=0));
	putpixel(m8+2,n,byte((c and 32)=0));
	putpixel(m8+3,n,byte((c and 16)=0));
	putpixel(m8+4,n,byte((c and 8)=0));
	putpixel(m8+5,n,byte((c and 4)=0));
	putpixel(m8+6,n,byte((c and 2)=0));
	putpixel(m8+7,n,byte((c and 1)=0));
      end;
    END
    ELSE
    BEGIN
      laenge:=min(2*maxx,zeilenkopf[2]);
      for m:=0 to laenge div 2 do wzeile[m]:=not wzeile[m];
      monomachgrau(n,zeile,laenge);
    END;
  END;
  writesl('Darstellung abgeschlossen',true);
  ZeichnungBegonnen:=Not Ineinanderzeichnen;
Exit;
Fehler:
  writesl('Ist keine darstellbare GEM-Datei,',true);
  Falschertyp:=True;
end;

begin end.

