{$A+,B-,D+,E+,F+,G+,I-,L+,N+,O+,P-,Q-,R-,S-,T-,V-,X+,Y+}
UNIT VEXMAIN;

INTERFACE
  PROCEDURE MAIN;
IMPLEMENTATION
USES
     Overlay,
     OEINIT,
   {$IFOpt G+}
     Test286,             {Damit ZEIGWPG auf XTs nicht abstrzt}
   {$EndIF}
     CRT,                 {Tastatur, Delay}
     DOS,                 {Interrupts, Dateifunktionen}
     GRAPH,               {...}
     Disk,                {Erweiterte Dateifunktionen}
{$IFDEF BGIEinbinden}
     BGIDriv,             {EGAVGA- und HERC-Treiber}
     BGIFont,		  {Simplex-Font}
{$ENDIF}
     VGABios,           {Bios-Calls und Hardwarezugriffe}
     VideoTst,		{Test auf APAMode}
     General,           {Assemblerroutinen, z.B. Prfsummenberechnung}
     Maus,              {Nur Microsoft-kompatible}
     DXFVIEW,		{Anzeige von DXF-Dateien}
     WPGVIEW,           {Anzeige von WPG-Dateien}
{$IFNDEF SEWVIEW}
     HPGLVIEW,		{Anzeige von PlotDateien}
     PCXVIEW,           {Anzeige von PCX-Dateien}
     IMGVIEW,           {Anzeige von IMG-Dateien}
     ICNVIEW,           {Anzeige von Windows-Icons}
     QWGVIEW,           {Anzeige von QWG-Dateien}
     TXTVIEW,           {Anzeige von ASCII-Dateien (PC-8)}
     BMPVIEW,           {Anzeige von Windows-Bitmaps}
{$ENDIF}
     VIEWprim,          {Die paar Funktionen ohne Seiteneffekte}
     VIEWsl,            {Alles, was Text in der Statuszeile ausgibt}
     VIEWSLIN,          {Texteingaben in der Statuszeile}
     VIEWhelp,          {Ein paar Speicherfresser}
     WPGPaint,		{Malfunktionen}
{$IFNDEF SEWVIEW}
     WPShell,		{Yeah!}
     VIEWLOCK,		{Kennwortverschlsselung}
{$ENDIF}
     POPWIN,		{POP-UP-Fenster}
     QWGIO,		{QWG-Verwaltung}
{$IFNDEF SEWVIEW}
     GREXPORT,		{Bildschirmausschnitte schreiben}
     VIEWFILES,		{Dateien kopieren, usw.}
     HARDCOPY,          {Ausschnitte drucken}
{$ENDIF}
     VIEWDALI,  	{Die Dateileiste}
     VIEWCFG,		{Konfiguration schreiben/lesen}
     DREHFONT,          {Vektorfonts in beliebigem Winkel}
     SCRIPT;            {Bildabhngige Tastenfunktionen}
CONST
      Version='6.31';
      VersDat='3.1.95';

{$IFOPT N+}
TYPE real=double;         {Das Programm hat keine nennenswerten
			   Fliekommaberechnungen, einzig die Grauwert-
			   berechnung kommt nicht ohne SQRT aus,
			   auerdem gibt es ein bichen SIN und COS beim
			   Zeichnen sehr dicker Linien und bei Ellipsen.}
{$ENDIF}


(*---------------------------------------------------------------------
			GLOBALE VARIABLEN
---------------------------------------------------------------------*)
VAR
    WarteZeit	:Integer;      	{Fr DiaShow}
    grdriver	:integer; 	{Fr BGI}
    grmode	:integer;
    zoom_x1,
    zoom_x2,
    zoom_y1,
    zoom_y2	:Integer;	{Koordinaten des Zoom-Fensters}
    Zeichen,
    Zeichen2	:Char;        	{Fr ReadKey und sowas alles}
    virt_x1,
    virt_x2,
    virt_y1,
    virt_y2	:Longint;	{"Bildschirm"-Koordinaten der gezoomten
				 Grafik}
    L		:LONGINT;       {Fr temporre Zwecke}
    w		:word;
    i		:integer;
    DarfZoomen	:Boolean;	{Nur bei DXF- HPGL- und WPG-Dateien}
    header	:WPCHeadertyp; 	{16 Byte Dateiheader}
    Tastendruck	:Boolean;       {Bildaufbau jederzeit abbrechbar}
    dx,dy	:integer;	{Maus}
    m2,m3	:integer;	{Maus}
    StatusZeileGeloescht
		:Boolean;       {Bei Mausbewegungen}
    SZeile	:String;
    Warnen	:Boolean;	{Wenn's Grund fr ein Hinweisfenster gibt}
    Zoomfaktor	:Real;
    name  	:dateinamentyp; {Name mit oder ohne ext}
    ext		:extstr;        {Meist '.WPG'}
    Neuaufbau   :Boolean;	{Wenn Bild nach Tastendruck neu geladen werden mu}
    LastDir     :PathStr;       {Verzeichnis, aus dem gewechselt wurde}

(*---------------------------------------------------------------------
		 INITIALISIERUNG FR GESAMTES PROGRAMM
		 PRFSUMMENTEST
		 AUSWERTUNG DER KOMMANDOZEILE
---------------------------------------------------------------------*)

PROCEDURE Parameterauswertung(Parameter:String; VAR Unbekanntes:Boolean);
VAR Janein:Boolean;
VAR VALCODE:Integer;
VAR I:Integer;
VAR EXT:EXTStr;
BEGIN
  IF parameter[1]=';' then exit;
  parameter:=UpStr(parameter);
  IF parameter[1]='/'
  THEN
  BEGIN
    IF Parameter[2]='-' THEN
    BEGIN
      delete(parameter,2,1);
      Janein:=FALSE;
    END
    else
      Janein:=TRUE;

    CASE CHAR(Parameter[2]) of
{$IFDEF SEWVIEW}
    '?': SEWHILFE(version,versdat,programmname,exename);
{$ELSE}
    '?': HILFE(version,versdat,programmname,exename);
    'A': IF janein THEN
            si2(copy(Parameter,3,255),
                HardCopyPrinterID,
                HardCopyPrinterRes);
{$ENDIF}
    '0',
    'O': BEGIN
	   Nullbreite:=Janein;
	 END;
    '1': BEGIN
	   EinsZuEins:=Janein;
	 END;
    'B': BEGIN
	   BreitZwang:=Janein;
	 END;
    'C': IF janein THEN
            si2(copy(Parameter,3,255),
                FontNr,
                CharSize);
    'D': IF Janein THEN
         IF Parameter[3]='S' THEN
         BEGIN {Script}
           Openscript(copy(parameter,4,255));
           maxy:=Statusline_off;
         END
         ELSE
	 BEGIN
	   DiaShow:=True;
	   IF parameter[3]='R' THEN
	   BEGIN
	     Randomshow:=TRUE;
	     delete(parameter,3,1);
	     Randomize;
	   END;
	   VAL(copy(parameter,3,5),WarteZeit,valcode);
	   IF valcode>0 THEN Wartezeit:=3;
	   IF Wartezeit<0 THEN
	   BEGIN
	     wartezeit:=-wartezeit;
	     ausblenden:=TRUE;
	   END;
	   IF Wartezeit>1000 THEN Wartezeit:=Wartezeit div 1000;
	   IF Wartezeit>60 THEN Wartezeit:=60;
	 END;
    'E': BEGIN
	   EGAZwang:=Janein;
	   IF Janein THEN
	   BEGIN
	     Hercules:=FALSE;
	     VGAZwang:=FALSE;
	     XternDriver:=FALSE;
	   END
           else EMSerlaubt:=FALSE;
	 END;
    'F': BEGIN
	   IF Janein
	   THEN
	     VAL(copy(parameter,3,6),Breitenfaktor,valcode)
	   else
	     Breitenfaktor:=10000;
	   IF valcode<>0 THEN Breitenfaktor:=10000;
	   Breitenfaktor:=lmin(lmax(breitenfaktor,1000),100000);
	 END;
    'G': BEGIN
	   Graustufen:=Janein;
	 END;
    'H': BEGIN
	   Hercules:=Janein;
	   IF Janein THEN
	   BEGIN
	     VGAZwang:=FALSE;
	     EGAZwang:=FALSE;
	     XternDriver:=FALSE;
	   END;
	 END;
    'I': BEGIN
	   Ineinanderzeichnen:=Janein;
	   IF parameter[3]='' THEN ausblenden:=true;
	 END;
    'M': BEGIN
	   MonochromZwang:=Janein;
	 END;
    'P': BEGIN
	    IF Janein THEN
	      BGIPfad:=Copy(Parameter,3,255)
	    else
	      BGIPfad:='';
	 END;
    'R': BEGIN
	   HGreduziert:=Janein;
	 END;
    'S': SaveConfig:=JaNein;
    'V': BEGIN
	   VGAZwang:=Janein;
	   IF Janein THEN
	   BEGIN
	     Hercules:=FALSE;
	     EGAZwang:=FALSE;
	     XternDriver:=FALSE;
	   END;
	 END;
    'W': IF janein THEN
	   DiMat:=@WPDiMat
	 ELSE
	   DiMat:=@MVDiMat;
    'X': IF Janein THEN
	 BEGIN
	   VGAZwang:=FALSE;
	   EGAZwang:=FALSE;
	   Hercules:=FALSE;
	   XDriverName:=Copy(Parameter,3,255);
	   i:=pos(',',XDrivername);
	   {DOS ist ja so blde!
	    Durch Komma, Semikolon oder Gleichheitszeichen separierte
            Parameter, die an eine Batch-Datei gegeben werden, werden dem
            Programm getrennt bergeben. Habe ich eine Batchdatei Z.BAT,
	    in der ein ZEIGWPG-Aufruf "ZEIGWPG %1 %2 %3" drin steht,
	    und rufe ich die Batch-Datei mit "Z *.WPG /XSVGA,3" auf,
	    so kommt beim Programm an: "ZEIGWPG *.WPG /XSVGA 3".
	    Deshalb ist ab sofort gestattet, den Modus mit einem
	    Schrgstrich zu trennen.}
	   IF i=0 THEN i:=pos('/',XDrivername);
	   IF i>0 THEN
	   BEGIN
	     {maximaler Modus sei 999}
	     VAL(copy(XDrivername,i+1,3),XdriverMode,valcode);
	     XDriverName:=Copy(XdriverName,1,i-1);
	   END
	   else XDriverMode:=0;

	   fsplit(XDriverName,AKT_Dir,XDrivername,ext);
	   IF AKT_DIR<>'' THEN BGIPfad:=AKT_DIR;
	   XternDriver:=TRUE;
	   IF XDriverName='CGA' THEN GRDRIVER:=1
	   {Aus irgendeinem Grund nimmt Turbo sonst
	    Treiber Nummer 10, IBM3270... !?!}
	   ELSE IF (XDriverName>'') THEN
		GRDRIVER:=installuserdriver(XDriverName,nil)
	   ELSE GRDRIVER:=DETECT;
	 END;
    'Y': BEGIN
	   NimmFloyd:=Janein;
	 END;
    'Z': BEGIN
	   ZoomBitMap:=Janein;
	 END;
    Else
      BEGIN
	WriteLN('??? ',parameter);
	unbekanntes:=True;
      END;
    END {CASE}
  END
  ELSE
  BEGIN
    SuchMaske:=Parameter;
    if ist_verzeichnis(Suchmaske) then suchmaske:=suchmaske+'\*.*';
  END;
END; {Parameterauswertung}


PROCEDURE ProgramInit;
VAR n:Byte;
    dn:word;
    s:string;
    cfg:text;
    name:namestr;
    ext:extstr;
    zeichen:char;

BEGIN
  While Keypressed do if readkey=#0 then readkey;
  CheckBreak:=FALSE;
  if apamode then DirectVideo:=FALSE;
  NormVideo;
  ClrScr;
  s:=Programmname+' '+version;
  gotoxy(40-length(s)div 2,9);Write(s);
  gotoxy(40-12,11);write('(C) Copyright 1990, 1997');
  gotoxy(40-11,12);write('Alle Rechte vorbehalten');
  gotoxy(40-14,13);write('Computersoftware Martin Vogel');
  gotoxy(40-7,14);write('D-58452 Witten');
  gotoxy(2,20);write('* Bitte warten *');
  gotoxy(1,22);


{$IFDEF Pruefsummentest}
  Pruefsummentest;
{$ENDIF}

  SuchMaske:='*.*';
  UnBekanntes:=False;

  assign(cfg,ProgrammPfad+exename+'.CFG');
  reset(cfg);
  while (ioresult=0) and NOT eof(cfg) do
    BEGIN
      readln(cfg,S);
      IF S>'' THEN Parameterauswertung(S,unbekanntes);
    END;
  close(cfg); IF ioresult<>0 THEN;

  for n:=1 to paramcount do
  BEGIN
    Parameterauswertung(paramstr(n),unbekanntes);
  END;

  Fsplit(fexpand(SuchMaske),AKT_dir,name,ext);
  ChDir(chdirformat(Akt_dir));
  IF name='' THEN name:='*';
  IF ext='' THEN ext:='.*';
  Suchmaske:=AKT_dir+name+ext;

  Suchmaske_Eindeutig:=(pos('?',Suchmaske)=0) and (pos('*',Suchmaske)=0);

  IF Unbekanntes THEN WriteLN;

  GetLastDrive;
  Hole_Dateien(Suchmaske,Dnamenfeld,Dateienzahl);
  Qsort_DateiNamen(1,Dateienzahl);
  IF ScriptAktiv
  THEN SucheDatei(GetFirstScriptPicture)
  ELSE SucheErsteDatei;
  Liste_bis:=0;

  IF Unbekanntes THEN
  BEGIN
    WriteLN('Achtung: Verstehe nicht alle Parameter.');
    WriteLN('Mit ',exename,' /? erhalten Sie einen Hilfstext.');
    WriteLN;
    WriteLN('Wenn Sie abbrechen wollen, drcken Sie bitte [Esc].');
    Repeat Zeichen:=Readkey until NOT Keypressed;
    IF Zeichen=#27 THEN FehlerAbbruch(Benutzerabbruch);
    WriteLN;
  END;

  IF Dateienzahl=0 THEN
  BEGIN
    WriteLN(#13'FEHLER: Finde keine Dateien mit "',Suchmaske,'"!');
    Halt(1);
  END;

{$IFDEF SEWVIEW}
Lizenziert:=TRUE;
{$ELSE}
  if diashow
  then lizenziert:=false
  else repeat pruefelizenz until lizenziert or not lizenzieren(Programmname);
{$ENDIF}

  IF RandomShow
  THEN Dateinummer:=Zufall(Dateienzahl)
  else Dateinummer:=1;
  IF ScriptAktiv
  THEN SucheDatei(GetFirstScriptPicture)
  ELSE SucheErsteDatei;
  If Scriptaktiv or NurEineDateiAnzuzeigen
  THEN BreitDarstellung:=TRUE;

{$IFOPT O+}
  if emserlaubt then Overinitems;
{$ENDIF}
  @SCRIPT.SCRIPTERROR:=@POPWIN.SCRIPTERROR;
END; {ProgramInit}


(*---------------------------------------------------------------------
		 INITIALISIERUNG DER GRAFIK
---------------------------------------------------------------------*)

PROCEDURE GrafikInit;
VAR GrafikFehler:Integer;
VAR N:INteger;
BEGIN
  IF NOT (Hercules or EGAgefunden) THEN BorderSave:=getBorder;

{$IFDEF BGIEinbinden}
  { "Registrierung" der Grafik-Treiber (aus BGIDRIV.TPU) }
  if not xterndriver then
  begin
  RegisterBGIdriver(@EGAVGADriverProc);
{  RegisterBGIdriver(@HercDriverProc);}
  end;

  RegisterBGIFont(@SimplexFontProc);
{  RegisterBGIFont(@TriplexFontProc);}
  RegisterBGIFont(@SmallFontProc);
{$ENDIF}

  {Wenn nicht erzwungen, dann nachsehen:}
  IF NOT (Hercules or VGAzwang or EGAzwang)
  THEN Hercules:=(MEM[$40:$49]=7);

	IF hercules THEN grdriver:=HercMono
  else  IF VGAzwang THEN grdriver:=VGA
  else  IF EGAZwang THEN grdriver:=EGA
  else  IF NOT xterndriver THEN detectgraph(grdriver,grmode);

  EGAgefunden:=grdriver=EGA;

  IF xterndriver
  THEN grmode:=Xdrivermode
  else getmoderange(grdriver,n,grmode);

  {Der BGI-Pfad kann als Parameter gesetzt worden sein
   "/P" oder "/X", oder die Environment-Variable ist gesetzt.
   Sonst werden die treiber im Programmverzeichnis gesucht.}
  IF bgipfad='' THEN BGIPfad:=Getenv('BGI');
  IF bgipfad='' THEN BGIPfad:=ProgrammPfad;

  SetGraphBufSize(lmin(MaxAvail div 4,$FFF0));

  clrscr;
  WriteLN('Wenn dieser Text lesbar bleibt, ist der gewhlte Grafikmodus ungltig.');
  WriteLN('Bitte drcken Sie [Esc] [Enter], um das Programm abzubrechen!');
  WriteLN;

  initgraph(grdriver,grmode,BGIPfad);

  GrafikFehler:=GraphResult;

  IF Grafikfehler <> grOk THEN             { Fehler? }
  BEGIN
    ClrScr;
    WriteLN('Grafik-Initialisierungsfehler: "', GraphErrorMsg(GrafikFehler),'"');
    Halt(255);
  END;
			  {Nur da, wo VGA draufsteht, ist auch VGA drin}
  vgakarte:=Get_VGA_Installed
            and(  (pos('VGA',GetModeName(GRMODE))<>0)
                or(pos('VESA',GetModeName(GRMODE))<>0));
  {Wichtig fr direktes Port I/O}

  EGAVGA16:=(getmaxcolor=15)
	    and (egagefunden or vgakarte)
	    and (longint(getmaxx+1)*(getmaxy+1) div 8 < $10000);
  {Dann knnen monochrome BitMaps direkt in den Speicher geschrieben
   werden. Bei Modi mit mehr 64 KByte pro Plane geht das wieder nicht}

  EGAVGABreite:=(getmaxx+1)div 8;

  Ausblenden:=Ausblenden and VGAKArte; {ebenso}

  IF Charsize=0 THEN {Standardgre holen}
  BEGIN
    SetTextstyle(fontnr,0,1+3*ord(fontnr>0));
    IF graphresult<>0 THEN            {Fehler -11: Unbekannter Fehler}
      SetTextStyle(Fontnr,0,1+3*ord(fontnr>0)); {Jetzt klappt's meist...}
    SetUserCharSize(1,1,1,1);
    Charsize:=Textheight('A');
  END;

  IF fontnr=0 THEN
    SetTextstyle(fontnr,0,Charsize div 8)
  ELSE
  BEGIN
    SetTextStyle(Fontnr,0,4);
    IF graphresult<>0 THEN     {Fehler -11: Unbekannter Fehler}
      SetTextStyle(Fontnr,0,4); {Jetzt klappt's meist...}
    SetUserCharSize(Charsize,TextHeight('A'),Charsize,TextHeight('A'));
  END;

  SetTextJustify(lefttext,toptext);
  TH:=textheight('A');

  ErrechneMaxx;

  If Scriptaktiv
  then maxy:=statusline_off
  else maxy:=statusline_on;

  MonoChrom:=(GetMaxColor=1) or MonoChromZwang;

  IF GetMaxColor=1
  THEN HGfarbe:=1
  Else HGfarbe:=GetMaxcolor;

  for n:=0 to 15 do Graupalette[n]:=n*17;
    {Bis ein Palettenrecord das wieder ndert}
  Graupalette[16]:=0;

{$IFNDEF SEWVIEW}
  Ausschnt_x1:=maxx div 4;
  Ausschnt_y1:=maxy div 4;
  Ausschnt_x2:=3*Ausschnt_x1;
  Ausschnt_y2:=3*Ausschnt_y1;
{$ENDIF}
  Zoom_x1:=maxx div 4;
  Zoom_y1:=maxy div 4;
  Zoom_x2:=3*Zoom_x1;
  Zoom_y2:=3*Zoom_y1;

  MausDa:=MsMouse;

  InitMonoPattern;

  SETEGARGB;
  setrgbpalette(getmaxcolor,255,255,255);

  InitDrehen; {Font in beliebigem Winkel}

END; {GrafikInit}


(*---------------------------------------------------------------------
			  HARDCOPY
---------------------------------------------------------------------*)
{$IFNDEF SEWVIEW}
Procedure Drucken;
var x1,y1,x2,y2:Integer;
var s:string;
begin
Writesl('Drucker, Auflsung? (Hilfe mit [F1]): ',true);
s:=ls(HardCopyPrinterID)+','+ls(HardCopyPrinterRes);
if inputsl(s,17)
then
begin
si2(s,HardCopyPrinterID,HardCopyPrinterRes);
x1:=Ausschnt_x1;
x2:=Ausschnt_x2;
y1:=Ausschnt_y1;
y2:=Ausschnt_y2;
if Hole_Raehmchen(x1,y1,x2,y2,rmDrucken)
then
begin
  writesl('Druckausgabe auf '+gethardcopyprintername+' luft. Abbruch mit [Esc]',true);
  if not printwindow(x1,y1,x2,y2)
  then
  begin
    writesl('Druck abgebrochen!',TRUE);
    sound(960);
    delay(500);
    nosound;
  end;
  Ausschnt_x1:=x1;
  Ausschnt_x2:=x2;
  Ausschnt_y1:=y1;
  Ausschnt_y2:=y2;
end;
end;
end;
{$ENDIF}

(*---------------------------------------------------------------------
***********************************************************************

			      ZEIGWPG

***********************************************************************
---------------------------------------------------------------------*)
PROCEDURE MAIN;
BEGIN {Hauptprogramm}
  PROGRAMINIT;
{$IFNDEF SEWVIEW}
  If ShellResident
  and WPShell_ThisProgramToBeInstalledResident
  then WPShell_Goto;
{$ENDIF}
  GRAFIKINIT;
{$IFDEF SEWVIEW}
if not nureinedateianzuzeigen then
begin
    virt_x1:=0;
    virt_y1:=0;
    virt_x2:=getmaxx;
    virt_y2:=getmaxy;
if fileexist(Programmpfad+'VIEWME.WPG') then
begin
ZEIGWPG(Programmpfad+'VIEWME.WPG',
	virt_x1,virt_y1,virt_x2,virt_y2,
	Darfzoomen);
i:=0;
repeat
  delay(1);
  inc(i);
until keypressed or (i=5000);
end;
While Keypressed do if readkey=#0 then readkey;
end;
{$ELSE}
If NOT NurEineDateiAnzuzeigen
Then Introfenster(Version,Lizenznehmer);
{$ENDIF}
REPEAT {Bis Erlaubnis der Shell zum Beenden erteilt}
REPEAT {Bis Abgebrochen oder normal Beendet}
IF NOT Abgebrochen THEN
BEGIN
  {In der Dateiliste das Rhmchen neu zeichnen:}
  ZeigDateiliste(Liste_von,Liste_bis,Dateinummer,UpDateCursor);
  {Auf einem 40-MHz-486er ist hier manchmal Mll im Tastaturpuffer}
  while keypressed do if readkey=#0 then readkey;
  {Damit der Cursor nicht so springt, sondern gleichmig bers Bild luft:}
  Delay(50);
  {Damit nicht in irgendwelche EXE-Dateien Paletten eingetragen werden:}
  PalPos:=0;

  {Wenn jetzt Taste gedrckt, gar nicht erst mit dem Bildaufbau beginnen:}
IF NOT KEYPRESSED THEN
IF Dnamenfeld[Dateinummer]^.F=Laufwerk
THEN
BEGIN
{$IFDEF SEWVIEW}
  WriteSL('ENTER changes to drive '
	 +Dnamenfeld[Dateinummer]^.N[3]+':',true);
{$ELSE}
  WriteSL('Mit ENTER wechseln Sie auf Laufwerk '
	 +Dnamenfeld[Dateinummer]^.N[3]+':',true);
  File_Info(AKT_dir,Dnamenfeld[Dateinummer]^,DateiAttr,0,0);
{$ENDIF}
END
ELSE
BEGIN
  If Zeichen<>^Z Then
  begin
    virt_x1:=0;
    virt_y1:=0;
    virt_x2:=maxx;
    virt_y2:=maxy;
  end;
  wpgbreite:=0;
  wpghoehe:=0;
  XVARIA:=0;
  YVARIA:=0;
  Unbekanntes:=FALSE;     {Keine WPG-Datei}
  ZuVieleFarben:=False;
  IF MonoChrom THEN
    SetzMonoPalette
  else
  IF NOT palignore THEN
  BEGIN
    {Fr schwarzen Text auf wei:}
    SetRGBPalette(0,0,0,0);
    SetRGBPalette(getmaxcolor,255,255,255);
  END;
  REPEAT
  Assign(wpg,AKT_dir+Dnamenfeld[Dateinummer]^.N);
  GetFattr(wpg,dateiattr);
  ior:=ioresult; {Dummy (verdummy nochmal!)}
  Filemode:=0;  {Damit auch schreibgeschtzte Dateien gelesen werden knnen}
  if Dnamenfeld[Dateinummer]^.F=Datei then reset(wpg,1);
  FileMode:=2;
  ior:=ioresult;
  if ior<>0 then
  BEGIN
    DOSERRSL(ior);  {Diskette entnommen oder sowas hnliches}
    LoescheAlleDateinamen(Dnamenfeld,Dateienzahl);
    Hole_Dateien(Suchmaske,Dnamenfeld,Dateienzahl);
    if ioresult=0 then;
    IF Dateienzahl=0
    THEN
      BEGIN
       HoleSuchMaske;
	IF Dateinummer=0 THEN
	  BEGIN
	    Writesl('Programm beenden',true);
	    IF JaneinSL THEN fehlerabbruch(Benutzerabbruch);
	  END;
      END
    else
    BEGIN
      QSort_Dateinamen(1,Dateienzahl);
      Dateinummer:=1;
      setfillpattern(HGmuster,HGfarbe);
      Bar(maxx,0,getmaxx,maxy);
      ErrechneMaxx;
      ZeigDateiliste(liste_von,liste_bis,Dateinummer,UpDateAll);
    END;
    if ioresult=0 then;
  END
  UNTIL IOR=0;
  ;{ELSE}
  BEGIN
  GetFTime(wpg,l);
  UnPackTime(l,Dateizeit);

  IF NOT (Hercules or Egagefunden) THEN SetBorder(getmaxcolor);

  SetzeHintergrund;

  IF infdatvorh
  THEN zeiginfozeile(Dnamenfeld[Dateinummer]^.N);
  IF NOT infogefunden THEN
    WriteSL(Dnamenfeld[Dateinummer]^.N,TRUE);

  {Am rechten unteren Bildschirmrand werden die Optionen, die nicht
   sofort aus der Abbildung ersichtlich sind, angezeigt}

  OptionS:='';
  IF Nullbreite THEN OptionS:=Options+'0';
  IF EinsZuEins THEN OptionS:=Options+'1';
  IF BreitZwang THEN OptionS:=Options+'B';
  IF HGReduziert THEN OptionS:=Options+'R';
  IF DiMat=@WPDiMat THEN OptionS:=OptionS+'W';
  IF Graustufen THEN OptionS:=Options+'G';
  IF Ineinanderzeichnen THEN OptionS:=Options+'I';
  IF Monochromzwang THEN OptionS:=Options+'M';
  IF ZoomBitMap THEN OptionS:=Options+'Z';
  If (virt_x1<>0) or (virt_y1<>0) or
     (virt_x2<>maxx) or (virt_y2<>maxy)
     THEN Options:=Options+':'+LS(100*(virt_x2-virt_x1) div maxx)+'%';
  IF NimmFloyd THEN OptionS:=OptionS+'Y';
  IF OptionS<>'' THEN OptionS:='/'+OptionS;
  moveto(getmaxx-1-TextWidth(options),maxy+3);
  IF NOT infogefunden THEN
    outtext(OptionS);

Falschertyp:=TRUE;
DarfZoomen:=FALSE;
{$IFDEF IMGSupport}
if not keypressed then
IF (Pos('.IMG',DNamenfeld[Dateinummer]^.N)>0)
THEN
  BEGIN
    LiesGemImg; {Falschertyp wird bei Erfolg auf FALSE gesetzt}
    IF falschertyp THEN
    BEGIN
      close(wpg); IF ioresult=0 THEN;
      reset(wpg,1); IF ioresult=0 THEN;
    END;
  END;
{$ENDIF}

{$IFNDEF SEWVIEW}
if not keypressed then
IF (Pos('.PCX',DNamenfeld[Dateinummer]^.N)>0)
OR (Pos('.SCR',DNamenfeld[Dateinummer]^.N)>0) {Microsoft Word!}
THEN
  BEGIN
    LiesPCX; {Falschertyp wird bei Erfolg auf FALSE gesetzt}
    IF falschertyp THEN PCXInfo(DNamenfeld[dateinummer]^,DateiZeit);
  END;

if not keypressed then
IF (Pos('.BMP',DNamenfeld[Dateinummer]^.N)>0)
OR (Pos('.RLE',DNamenfeld[Dateinummer]^.N)>0)
THEN
  BEGIN
    LiesBMP; {Falschertyp wird bei Erfolg auf FALSE gesetzt}
    IF falschertyp THEN BMPInfo(DNamenfeld[dateinummer]^,DateiZeit);
  END;

if not keypressed then
IF (Pos('.QWG',DNamenfeld[Dateinummer]^.N)>0)
THEN
  BEGIN
    If Zeichnungbegonnen and not keypressed and not ineinanderzeichnen then
    begin
      {Zeichenflche lschen}
      setfillstyle(userfill,HGFarbe);
      setfillPattern(HGMuster,HGfarbe);
      bar(0,0,maxx,maxy);
      Zeichnungbegonnen:=FALSE;
    END;
    LiesQWG(AKT_dir+DNamenfeld[Dateinummer]^.N,0,0,TRUE,FALSE);
    {Falschertyp wird bei Erfolg auf FALSE gesetzt}
    IF falschertyp THEN QWGInfo;
  END;

if not keypressed then
IF (Pos('.PLT',DNamenfeld[Dateinummer]^.N)>0)
OR (Pos('.HPG',DNamenfeld[Dateinummer]^.N)>0)
THEN
  BEGIN
    WriteSL('Bestimme Grenzen der '+ls(filesize(wpg))+' Byte groen Plotdatei '+
	    DNamenfeld[Dateinummer]^.N+', bitte warten...',TRUE);
    Falschertyp:=FALSE; {Eine Plotdatei hat keine eindeutige Kennung}
    close(wpg); IF ioresult=0 THEN;
    IF         Zeichnungbegonnen
       and NOT keypressed
       and not Ineinanderzeichnen
    THEN
    BEGIN
      setfillstyle(userfill,HGFarbe);
      setfillPattern(HGMuster,HGfarbe);
      bar(0,0,maxx,maxy);
    END;
    ZEIGPLT(AKT_dir,DNamenfeld[Dateinummer]^.N,virt_x1,virt_y1,virt_x2,virt_y2);
    DarfZoomen:=True;
    Zeichnungbegonnen:=true;
  END;
{$ENDIF} {SEWVIEW}

if not keypressed then
IF (Pos('.DXF',DNamenfeld[Dateinummer]^.N)>0)
THEN
  BEGIN
{$IFNDEF SEWVIEW}
    WriteSL('Bestimme Grenzen der '+ls(filesize(wpg))+' Byte groen DXF-Datei '+
	    DNamenfeld[Dateinummer]^.N+', bitte warten...',TRUE);
{$ELSE}
    WriteSL(DNamenfeld[Dateinummer]^.N+' ...',TRUE);
{$ENDIF}
    Falschertyp:=FALSE; {Bei Mierfolg nochmal als WPG lesen}
    close(wpg); IF ioresult=0 THEN;
    IF         Zeichnungbegonnen
       and NOT keypressed
       and not Ineinanderzeichnen
    THEN
    BEGIN
      setfillstyle(userfill,HGFarbe);
      setfillPattern(HGMuster,HGfarbe);
      bar(0,0,maxx,maxy);
    END;
    setviewport(0,0,maxx,maxy,true);
    ZEIGDXF(AKT_dir,DNamenfeld[Dateinummer]^.N,virt_x1,virt_y1,virt_x2,virt_y2);
    setviewport(0,0,getmaxx,getmaxy,false);
    Zeichnungbegonnen:=true;
    DarfZoomen:=TRUE;
  END;


{$IFNDEF SEWVIEW}
if not keypressed then
IF (Pos('.IC',DNamenfeld[Dateinummer]^.N)<>0)
and (filesize(wpg)=766)
THEN
  BEGIN
    ZeigWindowsIcon;
    IF falschertyp THEN
    BEGIN
      close(wpg); IF ioresult=0 THEN;
      reset(wpg,1); IF ioresult=0 THEN;
    END;
  END;
{$ENDIF}

{$IFNDEF SEWVIEW}
if not keypressed then
if falschertyp then
if DNamenfeld[Dateinummer]^.F=Datei then
IF (Pos('.TXT',DNamenfeld[Dateinummer]^.N)<>0)
OR (Pos('.BAT',DNamenfeld[Dateinummer]^.N)<>0)
OR (Pos('.DOC',DNamenfeld[Dateinummer]^.N)<>0)
OR (Pos('.ASC',DNamenfeld[Dateinummer]^.N)<>0)
OR isascii(Akt_Dir+DNamenfeld[Dateinummer]^.N)
THEN
BEGIN
  ZeigTXT(Akt_Dir+DNamenfeld[Dateinummer]^.N);
  FALSCHERTYP:=FALSE;
END;
{$ENDIF}

  {Nochmal ausgeben:}
  moveto(getmaxx-1-TextWidth(options),maxy+3);
  IF NOT infogefunden THEN
    outtext(OptionS);

if not keypressed then
IF Falschertyp THEN
 BEGIN

  IF ioresult=0 THEN;
  Seek(WPG,0);
  BlockRead(WPG,header,sizeof(header),i);

  {Damit nicht Dateien der Lnge null als WP-Dateien interpretiert werden:}
  if i<sizeof(header)
  then
    fillchar(header,sizeof(header),#0);

  IF not IstWPGDatei(AKT_dir+Dnamenfeld[Dateinummer]^.N) THEN
  BEGIN
    IF NOT infogefunden THEN
    IF Dnamenfeld[Dateinummer]^.F=Verzeichnis
{$IFNDEF SEWVIEW}
    THEN WriteSL('Mit ENTER wechseln Sie in das Verzeichnis '
		 +fexpand(AKT_dir+Dnamenfeld[Dateinummer]^.N),true)
    ELSE WriteSL(' ist keine darstellbare Grafikdatei.',false);
    File_Info(AKT_dir,Dnamenfeld[Dateinummer]^,DateiAttr,0,0);
{$ELSE}
    THEN WriteSL('ENTER changes to directory '
		 +fexpand(AKT_dir+Dnamenfeld[Dateinummer]^.N),true)
    ELSE WriteSL(' is no valid graphics file.',false);
{$ENDIF}
  END ELSE Falschertyp:=FALSE;

  PalGesetzt:=FALSE;
  Ende:=FALSE;

  IF         Zeichnungbegonnen
     and IstWPGDatei(AKT_dir+Dnamenfeld[Dateinummer]^.N)
     and NOT keypressed
     and not Ineinanderzeichnen
  THEN
  BEGIN
    setfillstyle(userfill,HGFarbe);
    setfillPattern(HGMuster,HGfarbe);
    bar(0,0,maxx,maxy);
    Zeichnungbegonnen:=FALSE;
  END;

  IF IstWPGDatei(AKT_dir+Dnamenfeld[Dateinummer]^.N) THEN
  BEGIN
    setviewport(0,0,maxx,maxy,true);
    DarfZoomen:=TRUE;
    ZEIGWPG(AKT_dir+DNamenfeld[Dateinummer]^.N,
	    virt_x1,virt_y1,virt_x2,virt_y2,
	    DarfZoomen);
    setviewport(0,0,getmaxx,getmaxy,false);
  END;

  {Falls Text in der Grafik war, wurden die Font-Einstellungen
   verndert. Deshalb hier das Zurcksetzen.}
  IF fontnr=0 THEN
    SetTextstyle(0,0,Charsize div 8)
  ELSE
  BEGIN
    SetTextStyle(Fontnr,0,4);
    IF graphresult<>0 THEN     {Fehler -11: Unbekannter Fehler}
      SetTextStyle(Fontnr,0,4); {Jetzt klappt's meist...}
    SetUserCharSize(Charsize,TextHeight('A'),Charsize,TextHeight('A'));
  END;

{$IFNDEF SEWVIEW}
  IF NOT palgesetzt and ausblenden THEN fade_in(RGBPalette,0,getmaxcolor);

  IF Unbekanntes and NOT abgebrochen and not DiaShow and NOT infogefunden
  THEN WriteSL(' (Enthlt nicht dargestellte Objekte)',false);
{$ENDIF}
  END;{Wenn eine irgendwie auswertbare Datei}

  close(wpg); if ioresult=0 then;

  END; {IORESULT=0}
END; {IF NOT Keypressed THEN...}

  Tastendruck:=FALSE;
  IF Diashow and NOT keypressed THEN
  BEGIN
    IF randomshow
    THEN Dateinummer:=Zufall(Dateienzahl)
    else inc(DateiNummer)
  END
  ELSE
  BEGIN
    REPEAT
    {So lange Tastendrcke holen, bis das Bild neu aufgebaut werden mu:}
    Tastendruck:=TRUE;
    EscapeGedrueckt:=False;

    m1:=0;
    Mouse_Motion(dx,dy); {Rcksetzen}
    StatusZeileGeloescht:=FALSE;

    while NOT keypressed and MausDa and (m1=0) do
    BEGIN
      Mouse_Motion(dx,dy);

	   if dy<0 then dy:=-sqr((dy-7) div 8)
      ELSE if dy>0 then dy:=sqr((dy+7) div 8);
      dateinummer:=min(Dateienzahl,lmax(1,Dateinummer+dy));
      IF dy<>0 THEN
	BEGIN
	  If not StatusZeilegeloescht Then
{$IFDEF SEWVIEW}
	  writesl('Please press left mousebutton or ENTER to view file.',true);
{$ELSE}
	  writesl('Linke Maustaste: Anzeige oder Verzeichniswechsel',TRUE);
{$ENDIF}
	  StatusZeileGeloescht:=TRUE;
	  zeigdateiliste(liste_von,liste_bis,dateinummer,UpDateCursor);
	  if abs(dy)=1 then delay(50); {feine Bewegungen bremsen}
	  mouse_motion(dx,dy);
	END;
      get_mouse_status(m1,m2,m3);
    END;

    CASE m1 of
    0: Zeichen:=UpCase(ReadKey);
    1: Zeichen:=#13;
    2: Zeichen:=#32;
    END;

    If Zeichen=#0 Then Zeichen2:=ReadKey;

    While Keypressed do if ReadKey=#0 then ReadKey;

    If ScriptAktiv then
      SucheDatei(GetNextScriptPicture(KeyName(Zeichen,Zeichen2)))
    ELSE
    Case Zeichen of
{$IFNDEF SEWVIEW}
      ^A:  BEGIN
	   Bildausschnitt(getmaxcolor,FALSE,TRUE,
			  AKT_dir,dnamenfeld[Dateinummer]^.N);
	   {KEIN Clipboardzwang, Aufruf des Paletteneditors mglich}
	   if AusschnittZiel=AKT_dir then
	   begin
	     LoescheAlleDateinamen(Dnamenfeld,Dateienzahl);
	     Hole_Dateien(Suchmaske,DNamenfeld,Dateienzahl);
	     QSort_Dateinamen(1,Dateienzahl);
	     ZeigDateiListe(Liste_von,Liste_bis,Dateinummer,UpDateAll);
	   END;
	   END;
      ^B:  Hole_Linienbreite;
      ^C:  BEGIN
	   WriteSL('Neuer Font (0..10) '+ls(fontnr),true);
	   FONT_HILFE(KeepFlag);
	   Hole_Font(FontNR,CharSize);
	   Setze_Font(FontNR,Charsize);
	   ZeigDateiListe(Liste_Von,Liste_Bis,DateiNummer,UpDateAll);
	   END;
      ^D:  ASCIIDUMP(Akt_Dir+DNamenFeld[Dateinummer]^.N);
      ^F:  Hole_Breitenfaktor;
      ^L:  HM_Loesche_Datei;
      ^U:  Umbenenne_Datei;
      ^K:  If DNamenFeld[Dateinummer]^.Markiert
	   and (Markiertedateien>1)
	   then
	   BEGIN
	     if kopierziel='' then kopierziel:=AKT_dir;
	     szeile:=kopierziel;
	     Gruppen_Info(MarkierteDateien,MarkierteKByte);
	     Writesl('Zielverzeichnis: ',true);
	     If Inputsl(szeile,14)
	     then
	     if ist_verzeichnis(szeile) then
	     begin
	       szeile:=szeile+'\';
	       kopierziel:=upstr(fexpand(szeile));
	       for w:=1 to Dateienzahl do
	       if DNamenFeld[w]^.Markiert and not Escapegedrueckt
	       then
	       begin
		 Kopiere_Datei(w,FALSE); {Ohne Rckfragen}
	       end;
	       if Escapegedrueckt THEN
	       begin
		 writesl('* Abgebrochen *',TRUE);
		 ZeigDateiliste(Liste_von,Liste_bis,DateiNummer,UpDateAll);
		 While Keypressed do if readkey=#0 then readkey;
                 repeat until keypressed;
	       end;
	     end
	     else
	     begin
	       sound(50);
	       writesl(szeile+' ist kein gltiges Verzeichnis!',TRUE);
	       delay(200);
	       nosound;
	       repeat until keypressed;
	     end;
	   END
	   ELSE
	     Kopiere_Datei(Dateinummer,TRUE);
      ^T:  ZeigTxt(Akt_Dir+DNamenFeld[Dateinummer]^.N);
      ^V:  If DNamenFeld[Dateinummer]^.Markiert
	   and (Markiertedateien>1)
	   then
	   BEGIN
	     if verschiebungsziel='' then verschiebungsziel:=AKT_DIR;
	     szeile:=VerschiebungsZiel;
	     Gruppen_Info(MarkierteDateien,MarkierteKByte);
	     Writesl('Zielverzeichnis: ',true);
	     If Inputsl(szeile,15)
	     then
	     if ist_verzeichnis(szeile) then
	     begin
	       szeile:=szeile+'\';
	       verschiebungsziel:=upstr(fexpand(szeile));
	       for w:=Dateienzahl downto 1 do
	       if DNamenFeld[w]^.Markiert and not EscapeGedrueckt
	       then
	       begin
		 Verschiebe_Datei(w,FALSE); {Ohne Rckfragen}
		 if w<=dateinummer then dec(dateinummer);
	       end;
	       if Escapegedrueckt THEN
	       begin
		 writesl('* Abgebrochen *',TRUE);
		 ZeigDateiliste(Liste_von,Liste_bis,DateiNummer,UpDateAll);
		 While Keypressed do if readkey=#0 then readkey;
                 repeat until keypressed;
	       end;
	     end
	     else
	     begin
	       sound(50);
	       writesl(szeile+' ist kein gltiges Verzeichnis!',TRUE);
	       delay(200);
	       nosound;
	       repeat until keypressed;
	     end;
	   END
	   ELSE
	     Verschiebe_Datei(Dateinummer,TRUE);
      ^P:  Palette_aendern(AKT_Dir+Dnamenfeld[Dateinummer]^.N,
			   PalPos,PalFirst,Palfarben);
      ^S:   BEGIN
	      WriteSL('Sortiere Dateiliste mit '+ls(Dateienzahl)
		      +' Eintrgen, bitte warten.',TRUE);
	      QSort_Dateinamen(1,Dateienzahl);
	      ZeigDateiListe(Liste_von,Liste_bis,Dateinummer,UpDateAll);
	    END;
      '+': BEGIN
	     Markierung(Dateinummer,Setzen,Anzeigen);
	     IF Dateinummer<Dateienzahl THEN inc(Dateinummer);
	   END;
      '-': BEGIN
	     Markierung(Dateinummer,Loeschen,Anzeigen);
	     IF Dateinummer<Dateienzahl THEN inc(Dateinummer);
	   END;
      '*': BEGIN
	     Markierung(Dateinummer,Not DNamenFeld[Dateinummer]^.Markiert,
			Anzeigen);
	     IF Dateinummer<Dateienzahl THEN inc(Dateinummer);
	   END;
      ^I:  Inputinfo(Dnamenfeld[Dateinummer]^.N,infdatvorh);
{$ENDIF} {SEWVIEW}
      ^Z:  If DarfZoomen Then
	   BEGIN
	     Hole_Raehmchen(zoom_x1,zoom_y1,zoom_x2,zoom_y2,rmZoomen);
	     Warnen:=False;
	     Repeat
	       if zoom_x1=zoom_x2 then Zoomfaktor:=1E20
	       else
	       Zoomfaktor:=maxx/(zoom_x2-zoom_x1);
	       If Zoomfaktor*(virt_x2-virt_x1)>={32000}64000
	       then
		 begin
		 sound(50);
		 dec(zoom_x1);
		 dec(zoom_y1);
		 inc(zoom_x2);
		 warnen:=true;
		 end;
	     until Zoomfaktor*(virt_x2-virt_x1)<{32000}64000;
	     if   (zoom_x1<=0)
	      and (zoom_x2>=maxx)
	      and (zoom_y1<=0)
	      and (zoom_y2>=maxy)
	     then zeichen:=#255; {Kein Neuaufbau}
	     nosound;
	     l:=round(zoomfaktor*(virt_x1-zoom_x1));
	     virt_x2:=l+round(zoomfaktor*(virt_x2-virt_x1));
	     virt_x1:=l;
	     l:=round(zoomfaktor*(virt_y1-zoom_y1));
	     virt_y2:=l+round(zoomfaktor*(virt_y2-virt_y1));
	     virt_y1:=l;
	     If warnen then
	     begin
{$IFDEF SEWVIEW}
	       writesl('Maximum zooming factor ('
		      +ls(round(100*(virt_x2-virt_x1)/maxx))
		      +'%) is active.',true);
{$ELSE}
	       writesl('Maximaler Zoomfaktor ('
		      +ls(round(100*(virt_x2-virt_x1)/maxx))
		      +'%) erreicht!',true);
{$ENDIF}
	       delay(2000);
	       While Keypressed do if readkey=#0 then readkey;
	     end;
{$IFNDEF SEWVIEW}
	   END
	   ELSE
	   BEGIN
	     Writesl('Zoomen bei dieser Grafik nicht erlaubt.',true);
	     Sound(50);
	     delay(200);
	     nosound;
	     NoZoomHilfe;
	     Zeichen:=#255; {Verhinderung von Neuaufbau}
{$ENDIF}
	   END;
{$IFNDEF SEWVIEW}
      #32: BEGIN
	     close(wpg);if ioresult<>0 then;
	     assign(wpg,AKT_dir+Dnamenfeld[Dateinummer]^.N);
	     reset(wpg,1);
	     getftime(wpg,l);
	     UnPackTime(l,Dateizeit);
	     Falschertyp:=true;
	     If (pos('.PCX',Dnamenfeld[Dateinummer]^.N)>0)
	     or (pos('.SCR',Dnamenfeld[Dateinummer]^.N)>0)
	     then pcxinfo(Dnamenfeld[Dateinummer]^,DateiZeit);
	     If (pos('.BMP',Dnamenfeld[Dateinummer]^.N)>0)
	     or (pos('.RLE',Dnamenfeld[Dateinummer]^.N)>0)
	     then BMPinfo(Dnamenfeld[Dateinummer]^,DateiZeit);
	     If FalscherTyp Then File_Info(AKT_dir,Dnamenfeld[Dateinummer]^,DateiAttr,PalPos,PalFarben);
	     close(wpg);if ioresult<>0 then;
	     repeat until keypressed;
	     {Sonst versucht das Programm sofort wieder, die Datei
	      als Grafik darzustellen.}
	   END;
{$ENDIF}
      #27: BEGIN
{$IFDEF SEWVIEW}
	     Abgebrochen:=TRUE;
{$ELSE}
	     WriteSL(Programmname+' beenden',true);
	     Abgebrochen:=JaNeinSL;
{$ENDIF}
	   END;
      #13: BEGIN
	     IF Dnamenfeld[Dateinummer]^.F<>Datei
	     THEN
	     BEGIN {Verzeichnis- oder Laufwerkswechsel}
               LastDir:=akt_dir;
	       Writesl('* Wechsele Verzeichnis *',TRUE);
	       fsplit(Suchmaske,Szeile,name,ext);
	       If Dnamenfeld[Dateinummer]^.F=Laufwerk
	       THEN
	       SuchMaske:=Dnamenfeld[Dateinummer]^.N[3]+':\'+name+ext
	       ELSE
	       SuchMaske:=SingleBackSlashFormat(fexpand(AKT_dir+Dnamenfeld[Dateinummer]^.N)+'\'+name+ext);
	       LoescheAlleDateinamen(Dnamenfeld,Dateienzahl);
	       Hole_Dateien(Suchmaske,Dnamenfeld,Dateienzahl);
	       Fsplit(SuchMaske,AKT_dir,name,ext);
	       chdir(akt_dir);
	       IF Dateienzahl=0
	       THEN HoleSuchMaske
	       else
	       BEGIN
		 QSort_Dateinamen(1,Dateienzahl);
                 If Dnamenfeld[Dateinummer]^.F=Laufwerk
                 then SucheErstedatei
                 else SucheVerzeichnis(LastDir);
		 setfillpattern(HGmuster,HGfarbe);
		 Bar(maxx,0,getmaxx,maxy);
		 ErrechneMaxx;
		 ZeigDateiliste(liste_von,liste_bis,Dateinummer,UpDateAll);
	       END;
	     END
	     {else {normale Datei nur neu anzeigen}
	   END;
      #33..#255: {Dateiname}
	     SucheDatei(zeichen);
      #0:
      CASE Zeichen2 of
{$IFNDEF SEWVIEW}
	#17: {alt-W}
	     BEGIN
	     IF DiMat=@MVDiMat
	     THEN DiMat:=@WPDiMat
	     ELSE DiMat:=@MVDiMat;
	     InitMonoPattern;
	     END;
	#19: {alt-R}
	     HGreduziert:=NOT HGreduziert;
	#21: {alt-Y}
	     NimmFloyd:=NOT NimmFloyd;
	#23: {alt-i}
	     IneinanderZeichnen:=NOT IneinanderZeichnen;
	#34: {alt-G}
	     Graustufen:=NOT Graustufen;
	#44: {alt-Z}
	     ZoomBitMap:=NOT ZoomBitMap;
	#48: {alt-B}
	     BEGIN
	       BreitZwang:=NOT BreitDarstellung;
	       BreitDarstellung:=BreitZwang;
	       ErrechneMaxx;
	       zeigdateiliste(liste_von,liste_bis,dateinummer,UpDateAll);
	     END;
	#50: {alt-M}
	     BEGIN
	       MonochromZwang:=NOT Monochromzwang;
	       MonoChrom:=(GetMaxColor=1) or MonoChromZwang;
	     END;
	#59: {F1}
             BEGIN
             Writesl('[Enter] nchste Hilfeseite, [Esc] Ende.',TRUE);
	     HelpWindow;
             Writesl('Tastenbelegung ausdrucken',true);
             If JaNeinSL then
             if not DruckeHilfstext then AbbruchHinweis;
             END;
	#60: {F2}
	     Disk_Info(AKT_DIR,Markiertedateien,markierteKbyte);
	#61: {F3}
	     Programm_Info(Version,GRMode);
	#68: {F10}
	     TestBild;
	#75: {left}
	     Markierung(Dateinummer,Loeschen,Anzeigen);
	#77: {right}
	     Markierung(Dateinummer,Setzen,Anzeigen);
        #82: {Einfg}
             Mach_Verzeichnis;
        #83: {Entf}
             HM_Loesche_Datei;
	#94: {Strg-F1}
	     If ShellResident then
	     begin
	       writesl('1: Zu Shell',true);
	       if Shellversion>='2' then
	       writesl('  2: Ausschnitt ins Clipboard ',FALSE);
	       zeichen2:=readkey;
	       while keypressed do begin zeichen2:='0';readkey; end;
	       case zeichen2 of
	       '1':
	       begin
                 closegraph;
		 swapvectors;
		 if WPShell_goto>1 then halt(0);
		 swapvectors;
		 initgraph(grdriver,grmode,bgipfad);
		 setfillstyle(userfill,HGFarbe);
		 setfillPattern(HGMuster,HGfarbe);
		 bar(0,0,maxx,maxy);
		 Zeichnungbegonnen:=FALSE;
		 LoescheAlleDateinamen(Dnamenfeld,Dateienzahl);
		 Hole_Dateien(Suchmaske,DNamenfeld,Dateienzahl);
		 QSort_Dateinamen(1,Dateienzahl);
		 ZeigDateiListe(Liste_von,Liste_bis,Dateinummer,UpDateAll);
	       end;
	       '2':
		 if Shellversion>='2' then
		 BildAusschnitt(getmaxcolor,TRUE,FALSE,
				AKT_dir,'');
	       end;
	     end;
	 #98:{Strg-F5}
	     If IstWPCDatei(AKT_dir+dnamenfeld[Dateinummer]^.N)
	     THEN
	     BEGIN
	     if header.enkey=0
	     then
	       writesl('Kennwort vergeben',true)
	     else
	       writesl('Kennwort lschen',true);
	     if janeinsl then
	       WPLOCK(AKT_dir+dnamenfeld[Dateinummer]^.N);
	     Zeichen:=#13;
	     END;
	#101:{Strg-F8}
	     BEGIN
	     WriteSL('Neuer Font (0..10) '+ls(fontnr),true);
	     FONT_HILFE(KeepFlag);
	     Hole_Font(FontNR,CharSize);
	     Setze_Font(FontNR,Charsize);
	     ZeigDateiListe(Liste_Von,Liste_Bis,DateiNummer,UpDateAll);
	     END;
	#104:{alt-F1}
	     BEGIN
	     IntroFenster(Version,LizenzNehmer);
	     ZeigDateiListe(Liste_von,Liste_bis,Dateinummer,UpDateAll);
	     END;
	#120:{alt-1}
	     EinsZuEins:=NOT EinsZuEins;
	#129,{alt-0}
	#24: {alt-O}
	     Nullbreite:=NOT Nullbreite;
        #107:{alt-F4}
             BEGIN
	       Abgebrochen:=TRUE;
	       WriteSL(Programmname+' schlieen',true);
	       Abgebrochen:=JaNeinSL;
	     END;
	#108:{Alt-F5}
	     BEGIN
	     If Markiertedateien>0 then
	     BEGIN {Alle Markierungen lschen}
	       For w:=1 to Dateienzahl-1 do
	       Markierung(w,Loeschen,Not Anzeigen);
	       Markierung(Dateienzahl,Loeschen,Anzeigen);
	     END
	     ELSE
	     BEGIN {Alle Markierungen setzen}
	       For w:=1 to Dateienzahl-1 do
	       Markierung(w,Setzen,Not Anzeigen);
	       Markierung(Dateienzahl,Setzen,Anzeigen);
	     END;
	     ZeigDateiliste(Liste_von,Liste_bis,Dateinummer,UpdateAll);
	     END;
	#150:{Strg-Gr-'*'}
	     BEGIN
	       For w:=1 to Dateienzahl-1 do
	       Markierung(w,Not DNamenFeld[w]^.Markiert,
			  NOT Anzeigen);
	       Markierung(Dateienzahl,Not DNamenFeld[Dateienzahl]^.Markiert,
			  Anzeigen);
	       ZeigDateiliste(Liste_von,Liste_bis,Dateinummer,UpdateAll);
	     END;
	#90: {Shift-F7}
	     Drucken;
{$ENDIF} {nicht SEWVIEW}
	#63: {F5}
	     HoleSuchmaske;
	#65, #45: {F7 oder Alt-X}
	     BEGIN
{$IFNDEF SEWVIEW}
	       WriteSL(Programmname+' verlassen',true);
	       Abgebrochen:=JaNeinSL;
{$ELSE}
	       Abgebrochen:=TRUE;
{$ENDIF}
	     END;
	#71: {home}
	     Dateinummer:=Liste_von;
	#72: {up}
	     IF Dateinummer>1 THEN dec(Dateinummer);
	#73: {pgup}
	     Dateinummer:=LMax(1,longint(Dateinummer)-Liste_bis+Liste_von);
	#79: {END}
	     Dateinummer:=Liste_bis;
	#80: {down}
	     IF Dateinummer<Dateienzahl THEN inc(Dateinummer);
	#81: {pgdown}
	     Dateinummer:=LMin(Dateienzahl,Dateinummer+Liste_bis-Liste_von);
	#117,{Strg-END}
	#118:{Strg-pgdown}
	     Dateinummer:=Dateienzahl;
	#119,{Strg-home}
	#132:{Strg-pgup}
	     Dateinummer:=1;
        #141:{Strg-up}
             if dateinummer>1 then
             repeat
               dec(dateinummer)
             until (dateinummer=1)
                or DNamenFeld[Dateinummer]^.Markiert
                or (DNamenFeld[Dateinummer-1]^.F<>Datei);
        #145:{Strg-down}
             if dateinummer<dateienzahl then
             repeat
               inc(dateinummer)
             until (dateinummer=dateienzahl)
                or DNamenFeld[Dateinummer]^.Markiert;
{$IFNDEF SEWVIEW}
	ELSE HelpWindow;
{$ENDIF}
      END; {Case Zeichen2}
    END{Case Zeichen};
  NeuAufbau:=   Scriptaktiv OR
                Not ((Zeichen in [^A,^I,^N,^K,^S,'+','-','*',#255])
	          or ((Zeichen=#0)
		      and (zeichen2 in
                           [#59,#60,#61,#68,#75,#77,
                            #90,#142,#144,#150])));
{$IFNDEF SEWVIEW}
  If Not Neuaufbau and not Keypressed
  then
  BEGIN
    {Die Markierungstasten setzen den Cursor weiter; das Bild soll jedoch
     nicht neu aufgebaut werden, damit das Statusfenster erhalten bleibt}
    ZeigDateiliste(Liste_Von,Liste_Bis,Dateinummer,UpDateCursor);
    Writesl(dnamenfeld[Dateinummer]^.N+': Neuanzeige mit [Enter]',TRUE);
  END;
{$ENDIF}
  {Tastendrcke holen und auswerten, bis Bild neu aufgebaut werden mu.
   Aufbau immer, auer wenn:}
  UNTIL NeuAufbau;
  END;

  IF Diashow and (Dateinummer>Dateienzahl)
  THEN Programmende:=TRUE; {Normal beendet}

  IF NOT (abgebrochen or tastendruck)
  THEN
    IF DiaShow and not Falschertyp
    THEN
      BEGIN
	i:=WarteZeit*1000;
	While i>0 do
	  IF Keypressed THEN
	  BEGIN
	    dec(dateinummer); {Womit dieselbe Nummer wie oben wieder da wre}
	    i:=0;
	  END
	  ELSE
	    BEGIN
	      DELAY(1);
	      DEC(i);
	    END;
      END; {Warten bei Diashow}
END; {IF NOT Abgebrochen THEN ...}
until Programmende or abgebrochen;

{$IFDEF SEWVIEW}
UNTIL TRUE;
{$ELSE}
UNTIL WPShell_RequestExitPermission<>0;
{$ENDIF}

CloseGraph;
NormVideo;
Hide_Mouse;
IF ioresult<>0 THEN; {Wo kommt das denn manchmal her ???}

clrscr;
{SCHLUSSBILDSCHIRM}
{$IFDEF SEWVIEW}
Writeln('DXF Graphics File Viewer');
Writeln('Copyright (c) 1997 by Dipl.-Ing. Martin Vogel, Witten, Germany.');
Writeln('Unauthorised copying and hiring of this software prohibited.');
Writeln('All rights reserved.');
{$ELSE}
Write(Programmname,' Version ',version);
{$IfOpt G+}
WriteLN(' fr IBM AT.');
{$ELSE}
WriteLN;
{$Endif}
WriteLN;
if not diashow and not lizenziert then
begin
  Registrierformular(version,programmname);
  clrscr;
end;
If Lizenziert then
begin
WriteLN('Uneingeschrnkte Vollversion.');
WriteLN('Lizenznehmer: ',lizenznehmer);
WriteLN('Jede Weitergabe der Datei ',exename,'.LIZ ist untersagt!');
WriteLN;
end;
{$IFDEF Testlauf}
TextColor(Lightred);
WriteLN('NUR FR TESTZWECKE !!!   KEINE FREIGABE !!!');
NormVideo;
{$ELSE}
WriteLN('Hilfe zu den Startoptionen erhalten Sie mit "',exename,' /?"');
WriteLN;
Writeln('Copyright (c) 1990-1997 by Dipl.-Ing. Martin Vogel.');
WriteLN('Alle Rechte vorbehalten.');
WriteLN;
{$ENDIF}
If SaveConfig Then
Schreibkonfiguration
	  (Nullbreite,
	   EinsZuEins,
	   Breitzwang,
	   EGAZwang,
	   VGAZwang,
	   Hercules,
	   XTernDriver,
	   MonoChromZwang,
	   GrauStufen,
	   HGReduziert,
	   Ineinanderzeichnen,
	   Ausblenden,
	   NimmFloyd,
	   ZoomBitMap,
	   DiMat=@WPDimat,
           EMSerlaubt,          {:Boolean;}
	   XDriverMode,
	   FontNr,
	   Charsize,
           HardCopyPrinterID,
           HardCopyPrinterRes,  {:Integer;}
	   Breitenfaktor,	{:LongInt;}
	   Programmname,
	   SuchMaske,
	   Programmpfad,
	   XDriverName,
	   BGIPfad,		{:PathStr;}
	   EXEName		{:ExtStr});
{$ENDIF} {Nicht SEWView}
IF NOT (Hercules or egagefunden) THEN Setborder(Bordersave);
Chdir(StartPfad);
While Keypressed do if readkey=#0 then readkey;
END;

BEGIn END.
