{$A+,B-,D+,E+,F+,I-,L+,N+,O+,R-,V-,X+}
unit viewfiles;
{Dateioperationen}

interface uses dos;
VAR KOPIERESULT:INTEGER;
CONST 	KopierZiel	:PathStr='';
	VerschiebungsZiel	:PathStr='';
PROCEDURE Kopiere(von,nach:pathstr;VAR kopieresult:Integer);
PROCEDURE Loesche_Datei(VAR DN:word;Rueckfragen:Boolean);
PROCEDURE HM_Loesche_Datei;
PROCEDURE Umbenenne_Datei;
PROCEDURE Verschiebe_Datei(dn:word;Fragen:boolean);
PROCEDURE Kopiere_Datei(DN:Word;ZielErfragen:Boolean);
PROCEDURE Mach_Verzeichnis;

implementation
uses
	crt,
	graph,
	disk,
	popwin,
	viewsl,
	viewslin,
	viewprim,
	viewdali,
	wpgview {palettenposition};
(*---------------------------------------------------------------------
		 STATUSANZEIGE BEIM KOPIEREN
		INITIALISIEREN ODER ENTFERNEN
---------------------------------------------------------------------*)

Procedure Zeichneprozentuhr(x,y:integer;oeffnen:boolean);
const bp:Pointer=nil;
BEGIN
  IF oeffnen THEN
  BEGIN
  IF imagesize(x,y-50,x+50,y)>Maxavail THEN
  BEGIN
    BP:=NIL;
    EXIT;
  END;
  getmem(bp,imagesize(x,y-50,x+50,y));
  getimage(x,y-50,x+50,y,bp^);
  setfillstyle(solidfill,0);
  bar(x+5,y-45,x+50,y);
  setfillstyle(solidfill,getmaxcolor);
  bar(x,y-50,x+45,y-5);
  setcolor(0);
  setlinestyle(solidln,0,3);
  rectangle(x+3,y-47,x+42,y-8);
  setlinestyle(solidln,0,1);
  circle(x+23,y-28,15);
  END
  ELSE
  If BP<>NIL THEN
  BEGIN
    putimage(x,y-50,bp^,normalput);
    freemem(bp,imagesize(x,y-50,x+50,y));
  END;
END;

(*---------------------------------------------------------------------
		 STATUSANZEIGE BEIM KOPIEREN
			 NACHFHREN
---------------------------------------------------------------------*)

Procedure Prozentuhr(x,y:integer;a,b:longint;smile:Boolean);
BEGIN
  setfillstyle(solidfill,0);
  setcolor(0);
  if b=0 then exit;{Dateilnge null Byte, Frechheit!}

  PieSlice(x+23,y-28,0,round(360.0*a/b),15);
  IF a=b THEN
  if smile then
  BEGIN
    setcolor(getmaxcolor);
    circle(x+18,y-31,2);
    circle(x+28,y-31,2);
    arc(x+23,y-35,230,310,15);
  END
  else
  BEGIN
    setcolor(getmaxcolor);
    circle(x+18,y-31,2);
    circle(x+28,y-31,2);
    arc(x+23,y-5,60,120,18);
  END;
END;


(*--------------------------------------------------------------------
		 KOPIEREN EINER BELIEBIGEN DATEI
---------------------------------------------------------------------*)

PROCEDURE Kopiere(von,nach:pathstr;VAR kopieresult:Integer);
VAR ein,aus		:file;
    bytesgelesen	:word;
    geschrieben,
    zuschreiben,
    time		:longint;
    uhrbegonnen         :boolean;
VAR Puffer:^Puffertyp;
VAR MaxPuffer:Word;

BEGIN
  kopieresult:=0;

  {Auf sich selbst kopiert? Bitteschn, schon fertig...}
  IF fexpand(von)=fexpand(nach) THEN exit;

  IF fileexist(fexpand(nach)) THEN
  BEGIN
    double_file_info(von,nach);
    writesl('Datei existiert. berschreiben',true);
    IF NOT janeinsl THEN
    BEGIN
      If EscapeGedrueckt Then Kopieresult:=-1; {Storno}
      exit;
    END;
  END;

  assign(ein,von);
  filemode:=0;
  reset(ein,1);		IF InOutRes<>0 THEN kopieresult:=IOResult;
  zuschreiben:=filesize(ein);
  geschrieben:=0;
  assign(aus,nach);
  filemode:=2;
  rewrite(aus,1);
  IF InOutRes<>0 THEN
  begin
    kopieresult:=IOResult;
    uhrbegonnen:=false;
  end
  ELSE
  BEGIN
    zeichneprozentuhr(20,maxy-20,true);
    uhrbegonnen:=true;
    MaxPuffer:=LMIN(MaxAvail,Sizeof(Puffertyp));
    Getmem(Puffer,MaxPuffer);
    repeat
      blockread(ein,puffer^,maxpuffer,bytesgelesen);
	IF InOutRes<>0 THEN kopieresult:=IOResult;
      blockwrite(aus,puffer^,bytesgelesen);
	IF InOutRes<>0 THEN kopieresult:=IOResult;
      inc(geschrieben,bytesgelesen);
      prozentuhr(20,maxy-20,geschrieben,zuschreiben,true);
      if keypressed and (readkey=#27) then
      begin
	 kopieresult:=-1;
	 escapegedrueckt:=TRUE;
      end;
    until (bytesgelesen<maxpuffer) or (kopieresult<>0) ;
    FREEMEM(Puffer,MAXPUFFER);
    getftime(ein,time);
    close(ein);IF InOutRes<>0 THEN kopieresult:=IOResult;
    setftime(aus,time);
    close(aus);IF InOutRes<>0 THEN kopieresult:=IOResult;
  END;
  IF kopieresult<>0 THEN
  BEGIN
    if uhrbegonnen then prozentuhr(20,maxy-20,1,1,false);
    close(ein);	IF ioresult<>0 THEN;
    close(aus);	IF ioresult<>0 THEN;
    erase(aus); IF ioresult<>0 THEN;
    DOSerrSL(Kopieresult);
  END;
  if uhrbegonnen then zeichneprozentuhr(20,maxy-20,false);
END;

(*---------------------------------------------------------------------
	      EINE DATEI LSCHEN, AUCH SCHREIBGESCHTZTE
---------------------------------------------------------------------*)
PROCEDURE Loesche_Datei(VAR DN:word;Rueckfragen:Boolean);
{DN ist die Nummer im Dateinamenfeld}
VAR
    f:file;
    a:word;
BEGIN
  if Rueckfragen then
  IF DNamenfeld[DN]^.F=LaufWerk
  THEN
  WriteSL('Laufwerk '+Dnamenfeld[DN]^.N+' aus Liste entfernen'
	 ,TRUE)
  ELSE
  BEGIN
    IF DNamenfeld[DN]^.F=Datei THEN
    {Ein Infofenster soll verhindern, da "die falschen" Dateien
     unbeabsichtigt gelscht werden}
    File_info(akt_dir,dnamenfeld[dn]^,DateiAttr,Palpos,Palfarben);
    WriteSL(fexpand(akt_dir+Dnamenfeld[DN]^.N)+': WIRKLICH LSCHEN'
	    ,TRUE);
  END;
  IF not rueckfragen or JaNeinSL THEN
  if Dnamenfeld[DN]^.F=Laufwerk then
  LoescheDateinamen(DN)
  ELSE
    BEGIN
      {Der folgende Test auf den Schreibschutz eines Laufwerkes ist
       ungeheuer wichtig, denn sonst holt DOS das Lschen nach, wenn
       ZEIGWPG beendet wird! Warum das so ist, ist eines der Ge-
       heimnisse zwischen DOS 5.0 und TP 6.0 ... ich habe jedenfalls
       keine Idee, was der Grund sein knnte.}
      IF ioresult<>0 THEN;
      assign(f,akt_dir+EXENAME+'.$$$');
      rewrite(f);
      ior:=ioresult;                    {Diskette beschreibbar?}
      close(f); IF ioresult<>0 THEN;
      erase(f); IF ioresult<>0 THEN;

      IF ior=0 THEN
      BEGIN
	IF DNamenfeld[DN]^.F=Verzeichnis
	THEN rmdir(akt_dir+DNamenfeld[DN]^.N)
	else
	BEGIN
	  IF DNamenfeld[DN]^.Markiert
	  Then
	  BEGIN
	    dec(MarkierteKByte,
		(Dateigroesse(akt_dir+dnamenfeld[dn]^.N)+1023)div 1024);
	    dec(MarkierteDateien);
	    DNamenfeld[DN]^.Markiert:=FALSE;
	    Gruppen_info(MarkierteDateien,MarkierteKByte);
	  END;
	  close(wpg);if ioresult<>0 then;
	  assign(wpg,akt_dir+dnamenfeld[dn]^.N);
	  setfattr(wpg,0);
	  erase(wpg);
	END;
	ior:=ioresult;
      END;

      DosErrSL(ior);

      IF ior=0
      THEN LoescheDateinamen(DN);
    END;
    If Dateienzahl=0 then Holesuchmaske;
    {Frher war hier eine Schleife, die so lange nach einer Suchmaske
     fragte, bis Dateien gefunden wurden. Ist jetzt berflssig, weil
     ja mindestens die Laufwerksliste aufgebaut wird.}
END; {Loesche_Datei}


PROCEDURE HM_Loesche_Datei;
VAR i:Integer;
VAR W:Word;
BEGIN
  If DNamenFeld[Dateinummer]^.Markiert
  and (Markiertedateien>1)
  then
  BEGIN
    Gruppen_Info(MarkierteDateien,MarkierteKByte);
    Writesl('Dateien lschen',true);
    If Janeinsl then
    begin
      for i:=Dateienzahl downto 1 do
      if DNamenFeld[i]^.Markiert and not Escapegedrueckt
      then
      begin
	w:=i; {W Wird verndert!}
	Loesche_Datei(w,FALSE); {Ohne Rckfragen}
	if i<=dateinummer then dec(dateinummer);
      end;
      if Escapegedrueckt THEN
      begin
	writesl('* Abgebrochen *',TRUE);
	ZeigDateiliste(Liste_von,Liste_bis,DateiNummer,UpDateCursor);
	while keypressed do readkey;
	repeat until keypressed;
      end;
    end;
  END
  ELSE
    Loesche_Datei(Dateinummer,TRUE); {Mit Rckfragen}
END;


(*---------------------------------------------------------------------
	   DATEI IM ANGEMELDETEN VERZEICHNIS UMBENENNEN
---------------------------------------------------------------------*)

PROCEDURE Umbenenne_Datei;
var name:String;
var ds:dirstr;
    ns:namestr;
    es:extstr;
BEGIN
  If DNamenFeld[Dateinummer]^.F=Laufwerk then exit;
  WRITESL('Neuer Name: ',TRUE);
  name:=Dnamenfeld[Dateinummer]^.N;
  IF InputSL(name,11)
  THEN
  BEGIN
  fsplit(fexpand(name),ds,ns,es);
  name:=ns+es;
  WRITESL('Neuer Name: '+name,TRUE);
  WildCardExpand(name,Dnamenfeld[Dateinummer]^.N);
  IF DNamenFeld[Dateinummer]^.F=Verzeichnis
  THEN name:=LowStr(name)
  else name:=upstr(name);
  IF name<>Dnamenfeld[Dateinummer]^.N THEN
  BEGIN
    IF ioresult<>0 THEN;
    rename(wpg,AKT_dir+name);
    IOR:=IORESULT;
    IF ior=0 THEN
    BEGIN
      Dnamenfeld[Dateinummer]^.N:=Name;
      ZeigDateiListe(Liste_von,Liste_bis,Dateinummer,UpDateName);
    END
    ELSE
      DOSErrSL(IOR);
  END; {Wenn neuer Name eingegeben}
 END;  {Wenn InputSL nicht mit ESC abgebrochen wurde}
END; {UmBenenne_Datei}

(*---------------------------------------------------------------------
			DATEI KOPIEREN
---------------------------------------------------------------------*)
PROCEDURE Kopiere_Datei(DN:Word;ZielErfragen:Boolean);
VAR DirBak:Pathstr;
VAR SZEILE:PATHSTR;
VAR NAMe:NameStr;
VAR EXT:EXTStr;

BEGIN
  ZeigDateiliste(Liste_von,Liste_bis,dn,UpDateCursor);
  IF DNamenFeld[DN]^.F<>Datei
  THEN
  BEGIN
    WriteSL(Programmname+' kann nur Dateien kopieren.',TRUE);
    Copy_Info;
    repeat until keypressed;
    exit;
  END;
  IF kopierziel='' THEN kopierziel:=AKT_dir;
  WRITESL('Kopierziel: ',true);
  If Not ZielErfragen Then
  BEGIN
    SZeile:=Kopierziel;
    Writesl(SZeile+DNamenFeld[DN]^.N,false)
  END
  ELSE
    SZeile:=Kopierziel+DNamenFeld[DN]^.N;
  IF Not ZielErfragen or InputSL(SZeile,12)
  THEN
  BEGIN
  {Zielerfragen ist nur dann false, wenn das Kopierziel ein Verzeichnis ist}
  if not zielerfragen or ist_verzeichnis(Szeile)
  then
  BEGIN
  if szeile[length(szeile)]='\' then dec(szeile[0]);
  szeile:=szeile+'\'+DNamenFeld[DN]^.N;
  END
  ELSE
  WildCardExpand(Szeile,Dnamenfeld[DN]^.N);
  GetDir(0,DirBak);
  CHDIR(chdirformat(KopierZiel));if ioresult<>0 then;
  fsplit(fexpand(SZeile),kopierziel,name,ext);
  CHDIR(DirBak);

  kopiere(AKT_dir+DNamenFeld[DN]^.N,Kopierziel+name+ext,kopieresult);
  IF kopieresult=0 THEN
  BEGIN
  IF DNamenfeld[DN]^.Markiert
  Then
  BEGIN
    dec(MarkierteKByte,(Dateigroesse(AKT_dir+dnamenfeld[dn]^.N)+1023)div 1024);
    dec(MarkierteDateien);
    DNamenfeld[DN]^.Markiert:=FALSE;
    Gruppen_info(MarkierteDateien,MarkierteKByte);
    ZeigDateiListe(Liste_von,Liste_bis,DN,UpDateName);
  END;

  IF KopierZiel=AKT_DIR THEN
  BEGIN
    LoescheAlleDateinamen(Dnamenfeld,Dateienzahl);
    Hole_Dateien(Suchmaske,DNamenfeld,Dateienzahl);
    QSort_Dateinamen(1,Dateienzahl);
    ZeigDateiListe(Liste_von,Liste_bis,Dateinummer,UpDateAll);
  END
  END;
 END;  {Wenn InputSL nicht mit ESC abgebrochen}
END; {Kopiere_Datei}

(*---------------------------------------------------------------------
			VERZEICHNIS ANLEGEN
---------------------------------------------------------------------*)
PROCEDURE Mach_Verzeichnis;
VAR SZeile:String;

BEGIN
  Writesl('Name des neu anzulegenden Unterverzeichnisses: ',TRUE);
  SZEILE:='';
  IF InputSL(SZeile,18)
  THEN
  BEGIN
    if pos('\',szeile)=0 then szeile:=akt_dir+szeile;
    MKDIR(SZEILE);
    if ioresult=0 then
    begin
      LoescheAlleDateinamen(Dnamenfeld,Dateienzahl);
      Hole_Dateien(Suchmaske,DNamenfeld,Dateienzahl);
      QSort_Dateinamen(1,Dateienzahl);
      ZeigDateiListe(Liste_von,Liste_bis,Dateinummer,UpDateAll);
    end
    else
    begin
      sound(50);
      Writesl('Das Verzeichnis "'+SZEILE+'" kann nicht angelegt werden. [Taste]',true);
      delay(300);
      nosound;
      repeat readkey until not keypressed;
    end;
  END
END; {Mach_Verzeichnis}

(*---------------------------------------------------------------------
		 DATEI VERSCHIEBEN QUER BER LAUFWERKE
---------------------------------------------------------------------*)

PROCEDURE Verschiebe_Datei(dn:word;Fragen:boolean);
Var copydelete:Boolean; {Laufwerksbergreifend}
var dirbak:dirstr;
VAR SZEILE:PATHSTR;
VAR NAME:NAMESTR;
VAR EXT:EXTSTR;
BEGIN
  ZeigDateiliste(Liste_von,Liste_bis,dn,UpDateCursor);
  IF DNamenFeld[DN]^.F<>Datei
  THEN
  BEGIN
    WriteSL('Kann nur Dateien verschieben ...',TRUE);
    if fragen then
    repeat until keypressed;
    exit;
  END;
  IF VerschiebungsZiel='' THEN VerschiebungsZiel:=AKT_dir;
  WriteSL('Verschiebungsziel: ',TRUE);
  Szeile:=VerschiebungsZiel+DNamenFeld[DN]^.N;
  If Not Fragen Then Writesl(Szeile,False);
  IF not fragen or InputSL(Szeile,13)
  THEN
  BEGIN
    IF ioresult<>0 THEN;
    getdir(0,dirbak);
    chdir(chdirformat(VerschiebungsZiel));if ioresult<>0 then;
    SZeile:=upstr(fexpand(Szeile));
    chdir(dirbak);
    if ist_verzeichnis(Szeile)
    then szeile:=szeile+'\*.*';
    Wildcardexpand(Szeile,DNamenFeld[DN]^.N);
    Kopieresult:=0;
    IF fileexist(SZeile) THEN
    BEGIN
      double_file_info(AKT_dir+DNamenFeld[DN]^.N,szeile);
      writesl('Datei existiert. Zieldatei lschen',true);
      IF janeinsl THEN
      BEGIN
	Assign(wpg,szeile);
	setfattr(wpg,0);
	erase(wpg); if ioresult<>0 then;
      END
      ELSE
      BEGIN
	If EscapeGedrueckt Then Kopieresult:=-1; {Storno}
	exit;
      END;
    END;
    If Kopieresult=0 then
    begin
    IF Szeile<>AKT_dir+dnamenfeld[DN]^.N
    then
    BEGIN
      CLOSE(WPG); if ioresult<>0 then;
      assign(wpg,AKT_dir+DNamenFeld[DN]^.N);
      RENAME(WPG,SZeile);
      If DNAMENFELD[DN]^.Markiert then
      If InOutRes=0 Then
      begin
       dnamenfeld[dn]^.Markiert:=False;
       dec(MarkierteDateien);
       dec(MarkierteKByte,(DateiGroesse(SZeile)+1023)div 1024);
       Gruppen_info(MarkierteDateien,MarkierteKByte);
       ZeigDateiListe(Liste_von,Liste_bis,DN,UpDateName);
      end;
    END;
    kopieresult:=ioresult;
    END;
    {17 = cannot rename across drives}
    {5 = file access denied, i.d.R. existiert Zieldatei schon}
    copydelete:=Kopieresult in [17,5];
    If copydelete then
    BEGIN
      kopiere(AKT_dir+DNamenFeld[DN]^.N,SZeile,kopieresult);
      {Falls Kopie erfolgreich, ohne Rckfrage lschen}
      if kopieresult=0 then Loesche_Datei(DN,FALSE);
    END;
    fsplit(fexpand(szeile),VerschiebungsZiel,name,ext);
    If not CopyDelete Then
    Case Kopieresult of
    0: IF VerschiebungsZiel=AKT_DIR THEN
       BEGIN
	 LoescheAlleDateinamen(Dnamenfeld,Dateienzahl);
	 Hole_Dateien(Suchmaske,DNamenfeld,Dateienzahl);
	 IF Dateienzahl>0 THEN QSort_Dateinamen(1,Dateienzahl);
	 ZeigDateiListe(Liste_von,Liste_bis,DN,UpDateAll);
       END
       ELSE LoescheDateinamen(DN);
    ELSE
    BEGIN
       DOSERRSL(kopieresult);
       LoescheAlleDateinamen(Dnamenfeld,Dateienzahl);
       Hole_Dateien(Suchmaske,DNamenfeld,Dateienzahl);
       IF Dateienzahl>0 THEN QSort_Dateinamen(1,Dateienzahl);
       ZeigDateiListe(Liste_von,Liste_bis,DN,UpDateAll);
    END;
    END; {Case Kopieresult}

    Dateinummer:=LMIN(Dateinummer,Dateienzahl);
    while Dateinummer=0 do
      BEGIN
	Holesuchmaske;
	IF Dateinummer=0 THEN
	  BEGIN
	    Writesl('Programm beenden',true);
	    IF JaneinSL THEN fehlerabbruch(Benutzerabbruch);
	  END;
      END;

  END;
END; {Umsetze_Dateien}



begin end.
