{$A+,B-,D+,E-,F+,G-,I-,L+,N-,O+,R-,S-,V-,X+}
UNIT WPSHELL;

INTERFACE

VAR ShellResident:Boolean;
VAR ShellVersion:String[5];

Function WPShell_GoTo:Integer;
Function WPShell_RequestExitPermission:Integer;
Function WPShell_Write(typ:Integer;var Puffer;Anzahl:Word):Integer;
Function WPShell_Append(typ:Integer;var Puffer;Anzahl:Word):Integer;
Function WPShell_Retrieve(typ:Integer;var Puffer:pointer;var Anzahl:Word):Integer;
Function WPShell_ThisProgramToBeInstalledResident:Boolean;

IMPLEMENTATION uses dos;

type idstringtyp=Array[-2..10] of char;
var p:^idstringtyp;
var i:integer;
var id:integer;

function wpshell_check:Pointer;
var r:registers;
begin
  r.ah:=$35;
  r.es:=0;
  r.bx:=0;
  intr($1a,r);
  wpshell_check:=ptr(r.es,r.bx);
end;

function wpshell_getid:Integer;
var r:registers;
begin
  r.ah:=$50;
  intr($1a,r);
  wpshell_getid:=r.ah*256+r.al;
end;

function wpshell_goto:Integer;
var r:registers;
begin
if shellresident then begin
  r.ah:=$51;
  r.al:=id;
  intr($1a,r);
  wpshell_goto:=r.ah;
end else wpshell_goto:=0;
end;

function wpshell_RequestExitPermission:Integer;
var r:registers;
begin
if shellresident then begin
  r.ah:=$55;
  r.al:=id;
  intr($1a,r);
  wpshell_RequestExitPermission:=r.ah;
end else wpshell_RequestExitPermission:=-1;
end;

Function WPShell_Write(typ:Integer;var Puffer;Anzahl:Word):Integer;
VAR R:Registers;
BEGIN
  r.ah:=$52;
  r.al:=id;
  r.bl:=typ;
  r.cx:=anzahl;
  r.ds:=seg(puffer);
  r.si:=ofs(puffer);
  intr($1a,r);
  WPShell_Write:=r.ah;
END;

Function WPShell_Append(typ:Integer;var Puffer;Anzahl:Word):Integer;
VAR R:Registers;
BEGIN
  r.ah:=$53;
  r.al:=id;
  r.bl:=typ;
  r.cx:=anzahl;
  r.ds:=seg(puffer);
  r.si:=ofs(puffer);
  intr($1a,r);
  WPShell_Append:=r.ah;
END;

Function WPShell_Retrieve(typ:Integer;var Puffer:pointer;var Anzahl:Word):Integer;
VAR R:Registers;
BEGIN
  r.ah:=$54;
  r.al:=id;
  r.bl:=typ;
  intr($1a,r);
  anzahl:=r.cx;
  WPShell_Retrieve:=r.ah;
  puffer:=ptr(r.es,r.di);
END;

Function WPShell_GetProgramID:Word;
VAR R:Registers;
BEGIN
  r.ah:=$50;
  intr($1a,r);
  WPShell_GetProgramID:=r.AX;
  {Bei Werten ber 255 ist die ID ungltig}
END;

Function WPShell_ThisProgramToBeInstalledResident:Boolean;
VAR R:Registers;
BEGIN
  r.ah:=$57;
  r.al:=id;
  intr($1a,r);
  WPShell_ThisProgramToBeInstalledResident:=r.ax=1;
END;

function bs(b,l:byte):string;
var s:string;
begin
  str(b,s);
  while length(s)<l do s:='0'+s;
  bs:=s;
end;

begin
p:=wpshell_check;
shellresident:=p<>nil;
if shellresident then
begin
  id:=wpshell_getid;
  if p^[8]<>#0
  then ShellVersion:='1.0'
  else ShellVersion:=bs(byte(p^[9]),1)+'.'+bs(byte(p^[10]),2);
end;
end.
